

PRINT N'Altering Table [dbo].[AsyncInteraction]...';

GO
ALTER TABLE [dbo].[AsyncInteraction] ALTER COLUMN [Campaign] VARCHAR (100) NULL;

PRINT N'Altering Table [dbo].[Audio]...';

GO
ALTER TABLE [dbo].[Audio] ALTER COLUMN [Campaign] VARCHAR (100) NULL;

GO
PRINT N'Altering Table [dbo].[AuditorEvaluationPlan]...';


GO
ALTER TABLE [dbo].[AuditorEvaluationPlan] ALTER COLUMN [IdCampaign] VARCHAR (100) NULL;


GO
PRINT N'Altering Table [dbo].[EvaluationResult]...';


GO
ALTER TABLE [dbo].[EvaluationResult] ALTER COLUMN [IdCampaign] VARCHAR (100) NULL;


GO
PRINT N'Altering Table [dbo].[HistoricCampaignEvaluationFormat]...';


GO
ALTER TABLE [dbo].[HistoricCampaignEvaluationFormat] ALTER COLUMN [IdCampaign] VARCHAR (100) NULL;


GO
PRINT N'Altering Table [dbo].[InteractionEvaluationPlan]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan] ALTER COLUMN [IdCampaign] VARCHAR (100) NULL;


GO
PRINT N'Altering Table [dbo].[ProcessAsyncInteraction]...';


GO
ALTER TABLE [dbo].[ProcessAsyncInteraction] ALTER COLUMN [Campaign] VARCHAR (100) NULL;


GO
PRINT N'Altering Table [dbo].[Transcription]...';


GO
ALTER TABLE [dbo].[Transcription] ALTER COLUMN [Campaign] VARCHAR (100) NULL;

PRINT N'Altering Table [dbo].[CampaignEvaluationFormat]'
GO
    ALTER TABLE CampaignEvaluationFormat
    DROP CONSTRAINT PK_CampaignEvaluationFormat;

    ALTER TABLE CampaignEvaluationFormat
    ALTER COLUMN IdCampaign VARCHAR(100)  NOT NULL;

    ALTER TABLE CampaignEvaluationFormat
    ADD CONSTRAINT PK_CampaignEvaluationFormat
    PRIMARY KEY (Instance, IdEvaluationFormat, IdCampaign);



GO
PRINT N'Altering Procedure [dbo].[SaveCampaignEvaluationFormat]...';


GO

ALTER PROCEDURE [dbo].[SaveCampaignEvaluationFormat] (
	@Instance Varchar(50) = NULL, 				@IdEvaluationFormat Varchar(50) = NULL,
	@IdCampaign Varchar(100) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	INSERT INTO [CampaignEvaluationFormat] (
		[Instance], [IdEvaluationFormat], [IdCampaign],
		[TimeStamp]
		)
	VALUES (
		@Instance, @IdEvaluationFormat, @IdCampaign,
		GETUTCDATE()
	)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetCampaignQualificationAverage]...';


GO

ALTER PROCEDURE [dbo].[GetCampaignQualificationAverage] (
	@Instance Varchar(50) = NULL,
	@IdCampaign Varchar(100) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		ERCQS.EvaluationResultCampaignQualificationSum/ERCQ.EvaluationResultCampaignQuantity CampaignQualificationAverage
	FROM
		(
			-- EvaluationResultCampaignQualificationSum
			SELECT
				SUM([QualificationSum]) EvaluationResultCampaignQualificationSum
			FROM
				(
					SELECT
						SUM([Qualification]) QualificationSum
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdCampaign]= @IdCampaign
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction]
				) EvaluationResultCampaign
		) ERCQS,
		(
			-- EvaluationResultCampaignQuantity
			SELECT
				COUNT(*) EvaluationResultCampaignQuantity
			FROM
				(
					SELECT
						[IdCampaign]
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdCampaign]= @IdCampaign
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction],
						[IdCampaign]
				) EvaluationResultCampaign
		) ERCQ

    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetReportByDetailAgent]...';


GO

ALTER PROCEDURE [dbo].[GetReportByDetailAgent] (@VCC varchar(50) = '', @Campaign varchar(100) = '', @Plan varchar(50) = '',
@EvaluationFormat varchar(50), @StartDate varchar(50) = '', @EndDate varchar(50) = '', @IdAuditor varchar(50) = '')
AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  
  -- GetReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro'
  SET NOCOUNT ON

  SELECT
    * INTO #TempEvaluationResult
  FROM (SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
	EP.Evaluation_Mode	
  FROM EvaluationResult ER
  LEFT JOIN EvaluationFormat EF
    ON ER.IdEvaluationFormat = EF.ID
  LEFT JOIN Ability A
    ON A.ID = ER.IdAbility
  LEFT JOIN EvaluationPlan EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [Group] GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup SGP
    ON SGP.ID = ER.IdSubGroup
  WHERE EF.Description LIKE CASE
    WHEN @EvaluationFormat <> '' THEN @EvaluationFormat
    ELSE EF.Description
  END
  AND ER.Instance LIKE CASE
    WHEN @VCC <> '' THEN @VCC
    ELSE ER.Instance
  END
  AND EP.Description LIKE CASE
    WHEN @Plan <> '' THEN @Plan
    ELSE EP.Description
  END
  AND ER.CampaignDescription LIKE CASE
    WHEN @Campaign <> '' THEN @Campaign
    ELSE ER.CampaignDescription
  END
  AND ER.IdAuditor LIKE CASE
    WHEN @IdAuditor <> '' THEN @IdAuditor
    ELSE ER.IdAuditor
  END
  AND ER.EvaluationDate >=
                          CASE
                            WHEN @StartDate <> '' THEN @StartDate
                            ELSE '19800101'
                          END
  AND ER.EvaluationDate <
                         CASE
                           WHEN @EndDate <> '' THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END) a



  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability)
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
   -- SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction'
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
      '' AS DescriptionPlan,
      '' AS DescriptionFormat,
      '' AS AgentDescription,
      '' AS CampaignDescription,
      '' AS IdInteraction,
      '' AS EvaluationDate,
      '' AS IdAuditor
  END
  SET NOCOUNT OFF
GO
PRINT N'Altering Procedure [dbo].[GetReportBySummaryAgent]...';


GO

--ALTER PROCEDURE [dbo].[GetReportBySummaryAgent] (@VCC varchar(50) = '', @Campaign varchar(50) = '', @Plan varchar(50) = '',
--@EvaluationFormat varchar(50), @StartDate varchar(50) = '', @EndDate varchar(50) = '', @IdAuditor varchar(50) = '')
--AS

  --DECLARE @VCC varchar(50) = '' 
  --DECLARE @Campaign varchar(50) = '' 
  --DECLARE @Plan varchar(50) = ''
  --DECLARE @EvaluationFormat varchar(50) ='nov01-0356'
  --DECLARE @StartDate varchar(50) = ''
  --DECLARE @EndDate varchar(50) = ''
  --DECLARE @IdAuditor varchar(50) = ''
  --DECLARE @cols varchar(max)
  --DECLARE @query varchar(max)

  ALTER PROCEDURE [dbo].[GetReportBySummaryAgent] (@VCC varchar(50) = '', @Campaign varchar(100) = '', @Plan varchar(50) = '',
@EvaluationFormat varchar(50) = '', @StartDate varchar(50) = '', @EndDate varchar(50) = '', @IdAuditor varchar(50) = '')
AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  --GetReportBySummaryAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191010','20191231',''
  --SET @EvaluationFormat = 'nov01-0356'
  SET NOCOUNT ON
  SELECT
    * INTO #TempEvaluationResult
  FROM (SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
	EP.Evaluation_Mode	
  FROM EvaluationResult ER
  LEFT JOIN EvaluationFormat EF
    ON ER.IdEvaluationFormat = EF.ID
  LEFT JOIN Ability A
    ON A.ID = ER.IdAbility
  LEFT JOIN EvaluationPlan EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [Group] GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup SGP
    ON SGP.ID = ER.IdSubGroup
  WHERE EF.Description LIKE CASE
    WHEN @EvaluationFormat <> '' THEN @EvaluationFormat
    ELSE EF.Description
  END
  AND ER.Instance LIKE CASE
    WHEN @VCC <> '' THEN @VCC
    ELSE ER.Instance
  END
  AND EP.Description LIKE CASE
    WHEN @Plan <> '' THEN @Plan
    ELSE EP.Description
  END
  AND ER.CampaignDescription LIKE CASE
    WHEN @Campaign <> '' THEN @Campaign
    ELSE ER.CampaignDescription
  END
  AND ER.IdAuditor LIKE CASE
    WHEN @IdAuditor <> '' THEN @IdAuditor
    ELSE ER.IdAuditor
  END
  AND ER.EvaluationDate >=
                          CASE
                            WHEN @StartDate <> '' THEN @StartDate
                            ELSE '19800101'
                          END
  AND ER.EvaluationDate <
                         CASE
                           WHEN @EndDate <> '' THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END) a



  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability)
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
	-- ROUND(AVG(CAST(ER.Qualification AS float)), 2) AS 'Qualification',
	DECLARE @colavg varchar(max) = STUFF((SELECT DISTINCT
      ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As ['+Ability +']'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
    --SELECT @colavg
	If @type = 'M'
	BEGIN
    SET @query = ' 
				Select q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription,count(q.IdInteraction) As Audits,
				sum(q.DurationTime) As DurationTime,ROUND(AVG(CAST(q.Note AS float)), 2) As Note, '+ @colavg +' From
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription
				'
    END
	ELSE 
	BEGIN
    SET @query = '
	
			    Select q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription,count(q.IdInteraction) As Audits,
				sum(q.DurationTime) As DurationTime,ROUND(AVG(CAST(q.Note AS float)), 2) As Note, '+ @colavg +' From 
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription'
	END
	Print(@query)
    EXECUTE (@query)
	--Select * From @query

    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
      '' AS DescriptionPlan,
      '' AS DescriptionFormat,
      '' AS AgentDescription,
      '' AS CampaignDescription,
      '' AS IdInteraction,
      '' AS EvaluationDate,
      '' AS IdAuditor
  END
  SET NOCOUNT OFF
GO
PRINT N'Altering Procedure [dbo].[SaveEvaluationResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationResult] (
	@Instance Varchar(50) = NULL,
	@Id Varchar(250) = NULL,
	@IdCampaign Varchar(100) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@MinQualificationAcceptable numeric(5,2) = NULL,
	@IdGroup Varchar(50) = NULL,
	@IdSubGroup Varchar(50) = NULL,
	@IdAbility Varchar(50) = NULL,
	@Qualification numeric(5,2) = NULL,
	@OwnScore NUMERIC(5,2) = NULL,
	@InheritedScore NUMERIC(5,2) = NULL,
	@IdEvaluator Varchar(50) = NULL,
	@EvaluationDate Datetime = NULL,
	@MaxAbilityScore numeric(5,2) = NULL,
	@AbilityInnerScore NUMERIC(5,2) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@Comment Varchar(1000) = NULL,
	@NotApplies bit = NULL,
	@ScoreDescription varchar(100) = NULL,
	@CampaignDescription varchar(100) = NULL,
	@AgentDescription varchar(100) = NULL,
	@InteractionDateini [datetime] = NULL,
	@InteractionDatefin [datetime] = NULL,
	@InteractionAddress VARCHAR(200) = NULL,
	@InteractionType varchar(50) = NULL,
	@AbilityOrder numeric(4,0) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@Conditional varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @IdAbilityEvaluationFormat Varchar(50) = NULL

	-- RECUPERAMOS EL IDABILITYEVALUATIONFORMAT
	SELECT @IdAbilityEvaluationFormat = ID
		FROM [AbilityEvaluationFormat] (NOLOCK)
		WHERE [Instance] = @Instance
			AND [IdEvaluationFormat] = @IdEvaluationFormat
			AND [IdGroup] = @IdGroup
			AND [IdSubGroup] = @IdSubGroup
			AND [IdAbility] = @IdAbility
			AND isNull([Conditional],'') = isNull(@Conditional,'')

	-- BUSCAMOS SI YA EXISTE UN REGISTRO EN LA BASE DE DATOS PARA LA EVALUACION
	DECLARE @SAVED_QUALIFICATION NUMERIC(5, 2) = NULL
	DECLARE @SAVED_COMMENT       VARCHAR(1000) = NULL

	SELECT @SAVED_QUALIFICATION = ER.[Qualification],
	       @SAVED_COMMENT = ER.[Comment]
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		WHERE ER.[Instance] = @Instance
			AND ER.[IdEvaluationPlan] = @IdEvaluationPlan
			AND ER.[IdEvaluationFormat] = @IdEvaluationFormat
			AND ER.[IdAbility] = @IdAbility
			AND ER.[IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
			AND ER.[IdInteraction] = @IdInteraction
			AND ER.[IdAuditor] = @IdEvaluator

	-- 
	IF @SAVED_QUALIFICATION IS NULL 
	BEGIN
	   
		-- INSERTAMOS EL NUEVO RESULT
		INSERT INTO [dbo].[EvaluationResult]
			   ([Instance]
			   ,[IdCampaign]
			   ,[IdInteraction]
			   ,[IdAgent]
			   ,[IdEvaluationFormat]
			   ,[MinQualificationAcceptable]
			   ,[IdGroup]
			   ,[IdSubGroup]
			   ,[IdAbility]
			   ,[Qualification]
			   ,[OwnScore]
			   ,[InheritedScore]
			   ,[IdEvaluator]
			   ,[IdAuditor]
			   ,[EvaluationDate]
			   ,[MaxAbilityScore]
			   ,[AbilityInnerScore]
			   ,[IdEvaluationPlan]
			   ,[Comment]
			   ,[NotApplies]
			   ,[ScoreDescription]
				,[CampaignDescription]
				,[AgentDescription]
				,[InteractionDateini]
				,[InteractionDatefin]
				,[InteractionAddress]
				,[InteractionType]
				,[AbilityOrder]
			   ,[CreatedDate]
			   ,[CreatedByUserId]
			   ,[LastModifiedDate]
			   ,[LastModifiedByUserId]
			   ,[IdAbilityEvaluationFormat]
			   ,[Conditional]
			   ,[TimeStamp]
			   )
		 VALUES
			   (
			   @Instance,
			   @IdCampaign,
				@IdInteraction,
				@IdAgent,
				@IdEvaluationFormat,
				@MinQualificationAcceptable ,
				@IdGroup, @IdSubGroup, @IdAbility,
				@Qualification,
				@OwnScore,
				@InheritedScore,
				@IdEvaluator,
				@IdEvaluator,
				@EvaluationDate,
				@MaxAbilityScore,
				@AbilityInnerScore,
				@IdEvaluationPlan,
				@Comment,
				@NotApplies,
				@ScoreDescription,
				@CampaignDescription,
				@AgentDescription,
				@InteractionDateini,
				@InteractionDatefin,
				@InteractionAddress,
				@InteractionType,
				@AbilityOrder,
				@CreatedDate,@CreatedByUserId,@LastModifiedDate,@LastModifiedByUserId,
				@IdAbilityEvaluationFormat,
				@Conditional,
			   GETUTCDATE())

	END
	ELSE
	BEGIN

		-- PRINT CONCAT('SAVED: ', @SAVED_QUALIFICATION)
		-- PRINT CONCAT('INPUT: ', @Qualification)

		-- ACTUALIZAMOS LA CALIFICACION EN CASO SEA DIFERENTE
		UPDATE [dbo].[EvaluationResult] 
			SET [Qualification] = @Qualification,
				[OwnScore] = @OwnScore,
				[InheritedScore] = @InheritedScore,
				[AbilityInnerScore] = @AbilityInnerScore,
				[ScoreDescription] = @ScoreDescription,
				[IdEvaluator] = @IdEvaluator,
				[LastModifiedByUserId] = @LastModifiedByUserId,
				[LastModifiedDate] = @LastModifiedDate,
				[TimeStamp] = GETUTCDATE(),
				[NotApplies] = @NotApplies
			WHERE [Instance] = @Instance
				AND [IdEvaluationPlan] = @IdEvaluationPlan
				AND [IdEvaluationFormat] = @IdEvaluationFormat
				AND [IdAbility] = @IdAbility
				AND [IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
				AND [IdInteraction] = @IdInteraction
				AND [IdAuditor] = @IdEvaluator
		
		--ACTUALIZAR EL COMENTARIO
		IF @Comment <> ISNULL(@SAVED_COMMENT,'') 
		BEGIN 
			UPDATE [dbo].[EvaluationResult] 
					SET	[Comment] = @Comment
					WHERE [Instance] = @Instance
						AND [IdEvaluationPlan] = @IdEvaluationPlan
						AND [IdEvaluationFormat] = @IdEvaluationFormat
						AND [IdAbility] = @IdAbility
						AND [IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
						AND [IdInteraction] = @IdInteraction
						AND [IdAuditor] = @IdEvaluator

		END
		
		
	END

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveInteractionEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdCampaign Varchar(100) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@InteractionSection Int = 0,
	@InteractionPart Int = 0,
	@InteractionFolder VARCHAR(50) = NULL,
	@InteractionDateStart DateTime = '1980-01-01',
    @InteractionDateEnd DateTime = '2050-01-01',
	@InteractionType Varchar(50) = NULL,
	@TotalMessages INT = NULL,
	@InteractionDuration Int = 0,
	@InteractionOrigin Varchar(50) = NULL,
	@InteractionManagementResult Varchar(50) = NULL,
	@InteractionContactId Varchar(50) = NULL,
	@InteractionFormat Varchar(20) = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@LastModifiedDate DateTime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@CreatedDate DateTime = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DEPRECATED: REEMPLAZADO POR BULKINTERACTIONEVALUATIONPLAN
	IF(@InteractionManagementResult = '') SET @InteractionManagementResult = NULL;

	UPDATE [InteractionEvaluationPlan]
	SET
		[Instance] = @Instance, 
		[IdEvaluationPlan] = @IdEvaluationPlan, 
		[IdAgent] = @IdAgent,
		[IdCampaign] = @IdCampaign, 
		[IdInteraction] = @IdInteraction, 
		[InteractionSection] = @InteractionSection, 
		[InteractionPart] = @InteractionPart, 
		[InteractionDateStart] = @InteractionDateStart,
		[FormattedEndDate] = @InteractionFolder,
		[InteractionDateEnd] = @InteractionDateEnd, 
		[InteractionType] = @InteractionType, 
		[InteractionMessages] = @TotalMessages,
		[InteractionDuration] = @InteractionDuration,
		[InteractionOrigin] = @InteractionOrigin, 
		[ManagementResult] = @InteractionManagementResult, 
		[ContactId] = @InteractionContactId,
		[InteractionFormat] = @InteractionFormat,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[LastModifiedDate] = GETUTCDATE(),
		[TimeStamp] = GETUTCDATE()

		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND	[IdInteraction] = @IdInteraction
			AND	[InteractionSection] = @InteractionSection
			AND	[InteractionPart] = @InteractionPart

	IF @@ROWCOUNT = 0
		INSERT INTO [InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[IdCampaign], [IdInteraction], [FormattedEndDate], 
			[InteractionSection], [InteractionPart], [InteractionDateStart], 
			[InteractionDateEnd], [InteractionType], [InteractionMessages],
			[InteractionDuration], [InteractionOrigin], [ManagementResult], 
			[ContactId], [InteractionFormat], [CreatedByUserId], 
			[CreatedDate], [TimeStamp]
		)
		VALUES (
			@Instance, @IdEvaluationPlan, @IdAgent,
			@IdCampaign, @IdInteraction, @InteractionFolder,
			@InteractionSection, @InteractionPart, @InteractionDateStart, 
			@InteractionDateEnd, @InteractionType, @TotalMessages,
			@InteractionDuration, @InteractionOrigin, @InteractionManagementResult, 
			@InteractionContactId, @InteractionFormat, @CreatedByUserId, 
			@CreatedDate, GETUTCDATE()
		)

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetTranscription]...';


GO
-- [dbo].[GetTranscription] 'default', 'F040EA5A-E455-49EC-8A8D-4A4AD13D8786', 0, 0, 'FFB04B5FF6E242098CD31F419CC4E4A3'
ALTER PROCEDURE [dbo].[GetTranscription]
(
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@Section NUMERIC(5, 0),
	@Part NUMERIC(5, 0),
	@Campaign VARCHAR(100) = NULL,
	@Folder VARCHAR(50) = NULL,
	@ID VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI INTERACTIONTYPE ES NULL SETTEAMOS COMO CALL
	IF @InteractionType IS NULL SET @InteractionType = 'CALL'

	SELECT
		[VCC]						'vcc',
		[ProcessId]					'processId',
		[InteractionType]			'interactionType',
		[Section]					'section',
		[Part]						'part',
		[Folder]					'folder',
		[Campaign]					'campaign',
		[ID]						'id',
		[Value]						'value',
		[CreatedDate]				'createdDate',
		[CreatedByUserId]			'createdByUserId',
		[LastModifiedDate]			'lastModifiedDate',
		[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [dbo].[Transcription] (NOLOCK)
	WHERE
		[VCC] = @VCC 
		AND [ProcessId] = @ProcessId 
		AND [InteractionType] = @InteractionType
		AND (
			(
				[InteractionType] = 'CALL'
					AND [Section] = @Section 
					AND [Part] = @Part 
			) OR (
				[InteractionType] <> 'CALL'
					-- AND [Folder] = @Folder
					AND [Campaign] = @Campaign
			)
		)
		AND [ID] = @ID

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveTranscription]...';


GO
-- [SaveTranscription] 'default', 'F040EA5A-E455-49EC-8A8D-4A4AD13D8786', 'FFB04B5FF6E242098CD31F419CC4E4A3', 0, 0, 2, 'admin'
ALTER PROCEDURE [dbo].[SaveTranscription]
(
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@Section NUMERIC(5, 0),
	@Part NUMERIC(5, 0),
	@Campaign VARCHAR(100) = NULL,
	@Folder VARCHAR(50) = NULL,
	@ID VARCHAR(50) = NULL,
	@Value INT,
	@UserId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI EL INTERACTIONTYPE ES NULL SETTEAMOS CALL POR DEFECTO
	IF @InteractionType IS NULL SET @InteractionType = 'CALL'

	UPDATE [dbo].[Transcription] SET
	[Value] = @Value,
	[LastModifiedDate] = GETUTCDATE(),
	[LastModifiedByUserId] = @UserId
	WHERE
		[VCC] = @VCC 
		AND [ProcessId] = @ProcessId 
		AND [InteractionType] = @InteractionType
		AND (
			(
				[InteractionType] = 'CALL'
					AND [Section] = @Section 
					AND [Part] = @Part 
			) OR (
				[InteractionType] <> 'CALL'
					AND [Folder] = @Folder
					AND [Campaign] = @Campaign
			)
		)
		AND [ID] = @ID

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Transcription](
			[VCC],
			[ProcessId],
			[InteractionType],
			[Section],
			[Part],
			[Campaign],
			[Folder],
			[ID],
			[Value],
			[CreatedByUserId]
		)
		VALUES(
			@VCC,
			@ProcessId,
			@InteractionType,
			@Section,
			@Part,
			@Campaign,
			@Folder,
			@ID,
			@Value,
			@UserId
		)
	END

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetInteractionQueryResults]...';


GO
ALTER PROCEDURE [dbo].[GetInteractionQueryResults] (
	@VCC VARCHAR(50) = NULL,
	@TransactionType VARCHAR(50) = NULL, 
	@TransactionId VARCHAR(50) = NULL, 
	@InteractionType VARCHAR(10) = NULL,  
	@InteractionId VARCHAR(250) = NULL, 
	@Campaign VARCHAR(100) = NULL,  
	@Folder VARCHAR(50) = NULL
) 
AS 
BEGIN 
    SET NOCOUNT ON

	-- HACEMOS LA BUQUEDA SEGUN EL TIPO DE INTERACCION
	IF @InteractionType = 'CALL'
		BEGIN
			SELECT IQR.[InteractionId]				'interactionId',
					IQR.[Section]					'section',
					IQR.[Part]						'part',
					IQR.[InteractionType]			'interactionType',
					IQR.[BatchType]					'transactionType',
					IQR.[BatchTypeId]				'transactionId',
					IQR.[BatchTypeName]				'transactionName',
					IQR.[AnalysisType]				'analysisType',
					IQR.[QueryId]					'queryId',
					IQR.[QueryName]					'queryName',
					IQR.[QueryValue]				'queryValue',
					IQR.[QueryData]					'queryData',
					IQR.[Matches]					'matches',
					IQR.[Details]					'details'
				FROM [dbo].[InteractionQueryResult] IQR (NOLOCK)
				WHERE IQR.[VCC] = @VCC
					AND IQR.[InteractionType] = @InteractionType
					AND (
						IQR.[InteractionId] = @InteractionId		-- GUID BASICO DE 32 CARACTERES APROXIMADAMENTE
						OR
						IQR.[TranscriptionId] = @InteractionId		-- GUID BASICO + SECTION + PART
					)
		END
		ELSE
		BEGIN
			SELECT IQR.[InteractionId]				'interactionId',
					IQR.[Section]					'section',
					IQR.[Part]						'part',
					IQR.[InteractionType]			'interactionType',
					IQR.[BatchType]					'transactionType',
					IQR.[BatchTypeId]				'transactionId',
					IQR.[BatchTypeName]				'transactionName',
					IQR.[AnalysisType]				'analysisType',
					IQR.[QueryId]					'queryId',
					IQR.[QueryName]					'queryName',
					IQR.[QueryValue]				'queryValue',
					IQR.[QueryData]					'queryData',
					IQR.[Matches]					'matches',
					IQR.[Details]					'details'
				FROM [dbo].[InteractionQueryResult] IQR (NOLOCK)
				WHERE IQR.[VCC] = @VCC
					AND IQR.[InteractionType] = @InteractionType
					AND (
						IQR.[InteractionId] = @InteractionId
						OR
						IQR.[TranscriptionId] = CONCAT(@InteractionType, '_', @Campaign, '_', @Folder, '_', REPLACE(@InteractionId, ':', '_'))
					)
		END

	SET NOCOUNT OFF
END
GO
PRINT N'Refreshing Procedure [dbo].[BulkAsyncInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAsyncInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Refreshing Procedure [dbo].[CloseI6InteractionAsyncInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CloseI6InteractionAsyncInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAsyncBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAsyncBillingInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAudioNavigatorInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudioNavigatorInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[GetBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBillingInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCleanerData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCleanerData]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanTipificationInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanTipificationInteractionTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetGlobalSearchFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGlobalSearchFilters]';


GO
PRINT N'Refreshing Procedure [dbo].[GetGlobalSearchInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGlobalSearchInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetI6AlreadyRegisteredTextInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6AlreadyRegisteredTextInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetI6InteractionMessages]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6InteractionMessages]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessI6InteractionsToUpdate]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessI6InteractionsToUpdate]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationBaseResult]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[GetProcessFiltersData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessFiltersData]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Refreshing Procedure [dbo].[CleanFailedBatchData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedBatchData]';


GO
PRINT N'Refreshing Procedure [dbo].[CleanFailedEvaluationPlanData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CleanFailedEvaluationPlanData]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAuditorEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteAuditorEvaluationPlanByInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAuditorEvaluationPlanByInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAgentsFromHistoricEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentsFromHistoricEvaluationPlans]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAuditorEvaluationPlanEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorEvaluationPlanEvaluation]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAuditorsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAuditorsFromEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsFromEvaluationPlans]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAuditorsInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsInteractions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCampaignFulfillment]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignFulfillment]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEfectivityPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEfectivityPlans]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlans]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlansExpired]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlansExpired]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationReviewCommitments]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationReviewCommitments]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionsByType]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsByType]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionsEvaluationPlanWithoutFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlanWithoutFilters]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionTypes]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTypes]';


GO
PRINT N'Refreshing Procedure [dbo].[GetTeamPerformanceFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFilters]';


GO
PRINT N'Refreshing Procedure [dbo].[GetTeamPerformanceFromEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFromEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[GetTopAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTopAgents]';


GO
PRINT N'Refreshing Procedure [dbo].[ReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByDetailAgent]';


GO
PRINT N'Refreshing Procedure [dbo].[ReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryAgent]';


GO
PRINT N'Refreshing Procedure [dbo].[RestoreEvaluationResultDraftBackup]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[RestoreEvaluationResultDraftBackup]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveAuditorEvPlanResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAuditorEvPlanResult]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationPlanCompleted]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlanCompleted]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationStatus]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationTipificationBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationTipificationBaseResult]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteractionForEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionSyncInteractionForEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveInteractionEvaluationPlanResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlanResult]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationReview]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationReview]';


GO
PRINT N'Refreshing Procedure [dbo].[GetFiltersFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetFiltersFromEvaluation]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkTipificationInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkTipificationInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAudio]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationFormatContent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationFormatContent]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCampaignsEvaluationFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignsEvaluationFormat]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveHistoricEvaluationPlanData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveHistoricEvaluationPlanData]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationFormat]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationResultDraftBackup]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationResultDraftBackup]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteEvaluationResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationResults]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAgentQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentQualificationAverage]';


GO
PRINT N'Refreshing Procedure [dbo].[GetAverageGroupRating]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAverageGroupRating]';


GO
PRINT N'Refreshing Procedure [dbo].[GetCognitiveInteractionIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCognitiveInteractionIntents]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationFormatQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormatQualificationAverage]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationResultEfectivitySummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultEfectivitySummary]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResults]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationResultsByCriteria]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsByCriteria]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationTypesInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationTypesInteraction]';


GO
PRINT N'Refreshing Procedure [dbo].[ReportAuditsByAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportAuditsByAgent]';


GO
PRINT N'Refreshing Procedure [dbo].[ReportBySummaryFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryFormat]';


GO
PRINT N'Refreshing Procedure [dbo].[ReportTestEvaluationResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportTestEvaluationResult]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationEfectivitySample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationEfectivitySample]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveEvaluationResultDraftBackup]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationResultDraftBackup]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkInteractionEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteI6InteractionAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteI6InteractionAudio]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanByInteractionId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanByInteractionId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Refreshing Procedure [dbo].[GetI6InteractionAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetI6InteractionAudios]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlan]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveInteractionEvaluationPlanSample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlanSample]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteProcessAsync]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteProcessAsync]';


GO
PRINT N'Refreshing Procedure [dbo].[GetBatchScheduledTemplateItemResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBatchScheduledTemplateItemResults]';


GO
PRINT N'Refreshing Procedure [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveStudyBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveStudyBaseResult]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkInteractionCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionCognitive]';


GO
PRINT N'Refreshing Procedure [dbo].[DeleteProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteProcess]';


GO
PRINT N'Refreshing Procedure [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Refreshing Procedure [dbo].[SaveI6InteractionAsyncInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveI6InteractionAsyncInteraction]';


GO
PRINT N'Update complete.';


GO
