PRINT N'Iniciando recompilación de la tabla [dbo].[Environment]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Environment] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [Name]                 VARCHAR (50)  NOT NULL,
    [Type]                 VARCHAR (50)  NULL,
    [Description]          VARCHAR (200) NULL,
    [Bucket]               VARCHAR (50)  NULL,
    [FTPDirectory]         VARCHAR (MAX) NULL,
    [ApiHost]              VARCHAR (50)  NULL,
    [ApiPort]              VARCHAR (50)  NULL,
    [ApiUser]              VARCHAR (50)  NULL,
    [ApiPassword]          VARCHAR (50)  NULL,
    [DbDisabled]           BIT           NULL,
    [DbServer]             VARCHAR (50)  NULL,
    [DbPort]               VARCHAR (50)  NULL,
    [DbUser]               VARCHAR (50)  NULL,
    [DbPassword]           VARCHAR (50)  NULL,
    [PbxDisabled]          BIT           NULL,
    [PbxServer]            VARCHAR (50)  NULL,
    [PbxPort]              VARCHAR (50)  NULL,
    [PbxUser]              VARCHAR (50)  NULL,
    [PbxPassword]          VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Environment1] PRIMARY KEY CLUSTERED ([VCC] ASC, [Name] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Environment])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Environment] ([VCC], [Name], [Type], [Description], [FTPDirectory], [ApiHost], [ApiPort], [ApiUser], [ApiPassword], [DbDisabled], [DbServer], [DbPort], [DbUser], [DbPassword], [PbxDisabled], [PbxServer], [PbxPort], [PbxUser], [PbxPassword], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [Name],
                 [Type],
                 [Description],
                 [FTPDirectory],
                 [ApiHost],
                 [ApiPort],
                 [ApiUser],
                 [ApiPassword],
                 [DbDisabled],
                 [DbServer],
                 [DbPort],
                 [DbUser],
                 [DbPassword],
                 [PbxDisabled],
                 [PbxServer],
                 [PbxPort],
                 [PbxUser],
                 [PbxPassword],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Environment]
        ORDER BY [VCC] ASC, [Name] ASC;
    END

DROP TABLE [dbo].[Environment];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Environment]', N'Environment';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Environment1]', N'PK_Environment', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[WorkGroupSupervisor]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_WorkGroupSupervisor] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [Description]          VARCHAR (50)  NOT NULL,
    [SupervisorId]         VARCHAR (250) NOT NULL,
    [CampaignId]           VARCHAR (250) NOT NULL,
    [AgentId]              VARCHAR (250) NOT NULL,
    [IsHistoric]           BIT           NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK__tmp_ms_x__89284CC5064D97A41] PRIMARY KEY CLUSTERED ([VCC] ASC, [Description] ASC, [SupervisorId] ASC, [CampaignId] ASC, [AgentId] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[WorkGroupSupervisor])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_WorkGroupSupervisor] ([VCC], [Description], [SupervisorId], [CampaignId], [AgentId], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [IsHistoric])
        SELECT   [VCC],
                 [Description],
                 [SupervisorId],
                 [CampaignId],
                 [AgentId],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp],
                 [IsHistoric]
        FROM     [dbo].[WorkGroupSupervisor]
        ORDER BY [VCC] ASC, [Description] ASC, [SupervisorId] ASC, [CampaignId] ASC, [AgentId] ASC;
    END

DROP TABLE [dbo].[WorkGroupSupervisor];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_WorkGroupSupervisor]', N'WorkGroupSupervisor';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK__tmp_ms_x__89284CC5064D97A41]', N'PK__tmp_ms_x__89284CC5064D97A4', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creando Índice [dbo].[EvaluationResult].[BulkEvaluationPlanAbility_01]...';


GO
CREATE NONCLUSTERED INDEX [BulkEvaluationPlanAbility_01]
    ON [dbo].[EvaluationResult]([Instance] ASC, [IdEvaluationPlan] ASC, [IdInteraction] ASC);


GO
PRINT N'Creando Índice [dbo].[EvaluationResult].[BulkEvaluationPlanAbility_02]...';


GO
CREATE NONCLUSTERED INDEX [BulkEvaluationPlanAbility_02]
    ON [dbo].[EvaluationResult]([Instance] ASC, [IdEvaluationPlan] ASC, [IdAbility] ASC);


GO
PRINT N'Creando Índice [dbo].[ProcessAsyncInteraction].[IX_BulkEvaluationPlanAbility_01]...';


GO
CREATE NONCLUSTERED INDEX [IX_BulkEvaluationPlanAbility_01]
    ON [dbo].[ProcessAsyncInteraction]([VCC] ASC, [ProcessId] ASC, [InteractionType] ASC, [FormattedEndDate] ASC, [Campaign] ASC, [InteractionId] ASC);


GO
PRINT N'Modificando Procedimiento [dbo].[GetEnvironment]...';


GO
ALTER PROCEDURE [dbo].[GetEnvironment] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT [VCC]				'vcc',
			[Name]					'name',
			[Type]					'type',
			[Description]			'description',
			[FTPDirectory]			'ftpDirectory',
			[ApiHost]				'apiHost',
			[ApiPort]				'apiPort',
			[Bucket]				'bucket',
			[ApiUser]				'apiUser',
			[ApiPassword]			'apiPassword',
			[DbDisabled]			'dbDisabled',
			[DbServer]				'dbServer',
			[DbPort]				'dbPort',
			[DbUser]				'dbUser',
			[DbPassword]			'dbPassword',
			[PbxDisabled]			'pbxDisabled',
			[PbxServer]			    'pbxServer',
			[PbxPort]			    'pbxPort',
			[PbxUser]			    'pbxUser',
			[PbxPassword]			'pbxPassword',
			[CreatedDate]			'createdDate',
			[CreatedByUserId]		'createdByUserId',
			[LastModifiedDate]		'lastModifiedDate',
			[LastModifiedByUserId]	'lastModifiedByUserId'
		FROM [Environment] (NOLOCK)
		WHERE [VCC] = @VCC
			AND [Name] = @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null, -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
			[dbo].[Audio].[ErrorMessage] = NULL
		
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				INSERTED.[RelativePath]					'relativePath',
				INSERTED.[FileName]						'fileName',
				INSERTED.[Format]                       'format',
				INSERTED.[MediaInfoTime]                'mediaInfoTime',
				INSERTED.[NeedI6Update]					'needI6Update',
				0										'isDiariced',
				P.[Language]							'language',
				P.[DictionaryId]						'dictionaryId',
				P.Retranscription						'retranscription',
				P.Diarization							'diarization',
				P.ChannelChange							'channelchange',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[Bucket]								'bucket',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime',
				INSERTED.[RelativeFileName]				'relativeFileName'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(A.[IsProcess], 0) = 0				
					AND 
					ISNULL(A.[IsTranscribed], 0) = 0	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				)
				OR 
				(
					A.[IsProcess] = 1						
					AND 
					A.[IsCancel] = 1
				)
			
				
				
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL,
			[dbo].[AsyncInteraction].[ErrorMessage] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				INSERTED.[FileName]                                                 'fileName',
				'allegro'															'environmentType',
				P.Retranscription													'retranscription'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				-- AND AI.[EndDate] = PAI.[EndDate]
				AND FORMAT (AI.[EndDate], 'yyyy-MM-dd') = FORMAT (PAI.[EndDate], 'yyyy-MM-dd')
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(AI.[IsProcess], 0) = 0
					AND 
					ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					AI.[IsProcess] = 1
					AND 
					AI.[IsCancel] = 1
				)

				
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveEnvironment]...';


GO

ALTER PROCEDURE [dbo].[SaveEnvironment] (
	@VCC VARCHAR(50) = NULL,
	@Name VARCHAR(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@Description VARCHAR(200) = NULL,
	@Bucket VARCHAR(50) = NULL,
	@FTPDirectory VARCHAR(MAX) = NULL,
	@ApiHost VARCHAR(50) = NULL,
	@ApiPort VARCHAR(50) = NULL,
	@ApiUser VARCHAR(50) = NULL,
	@ApiPassword VARCHAR(50) = NULL, 		
	@DbDisabled Bit = NULL,
	@DbServer VARCHAR(50) = NULL,
	@DbPort VARCHAR(50) = NULL,				
	@DbUser VARCHAR(50) = NULL,
	@DbPassword VARCHAR(50) = NULL,
	@PbxDisabled BIT = NULL, 				
	@PbxServer VARCHAR(50) = NULL,
	@PbxPort VARCHAR(50) = NULL,
	@PbxUser VARCHAR(50) = NULL,			
	@PbxPassword VARCHAR(50) = NULL,
	@CreatedDate DATETIME = NULL,
	@CreatedByUserId VARCHAR(50) = NULL, 	
	@LastModifiedDate DATETIME = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [Environment]
		SET [Type] = @Type,
			[Description] = @Description,
			[Bucket] = @Bucket,
			[FTPDirectory] = @FTPDirectory,
			[ApiHost] = @ApiHost,
			[ApiPort] = @ApiPort,
			[ApiUser] = @ApiUser,
			[ApiPassword] = CASE WHEN @ApiPassword IS NULL THEN [ApiPassword] ELSE @ApiPassword END,
			[DbDisabled] = @DbDisabled,
			[DbServer] = @DbServer,
			[DbPort] = @DbPort,
			[DbUser] = @DbUser,
			[DbPassword] = CASE WHEN @DbPassword IS NULL THEN [DbPassword] ELSE @DbPassword END,
			[PbxDisabled] = @PbxDisabled,
			[PbxServer] = @PbxServer,
			[PbxPort] = @PbxPort,
			[PbxUser] = @PbxUser,
			[PbxPassword] = CASE WHEN @PbxPassword IS NULL THEN [PbxPassword] ELSE @PbxPassword END,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Environment] (
			[VCC], [Name], [Type], [Bucket], [FTPDirectory],
			[Description], [ApiHost], [ApiPort],
			[ApiUser], [ApiPassword], [DbDisabled],
			[DbServer],[DbPort],[DbUser], 
			[DbPassword], [PbxDisabled], [PbxServer],
			[PbxPort], [PbxUser],[PbxPassword],
			[CreatedDate], [CreatedByUserId], 
			[LastModifiedDate],[LastModifiedByUserId], 
			[TimeStamp]
			)
		VALUES (
			@VCC, @Name, @Type, @Bucket, @FTPDirectory,
			@Description, @ApiHost, @ApiPort,
			@ApiUser, @ApiPassword, @DbDisabled, 
			@DbServer,@DbPort,@DbUser, 
			@DbPassword, @PbxDisabled, @PbxServer,
			@PbxPort, @PbxUser, @PbxPassword,
			@CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, 
			GETUTCDATE()
		)
	END

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetAllegroInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroInteractions] (
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				VARCHAR(50),
	@EndHour				VARCHAR(50),
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					INT,
	@Origin					VARCHAR(MAX),
	@MinDuration			INT,
	@MaxDuration			INT,
	@Format					VARCHAR(50) = NULL, 
	@InteractionIds         VARCHAR(MAX) = NULL, 
	@Evaluated              VARCHAR(MAX) = NULL,
	-- @UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO (AUDIOS/INTERACTIONS)
	@ResultType				VARCHAR(50) = NULL,						-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
	@ContactAddress			VARCHAR(300) = NULL,
	@LimitIntByAgent		INT = 0
) AS
BEGIN
	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	IF @Format IS NULL OR @Format = '' SET @Format = 'mp3,wav,ogg'

	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TABLE_HISTORICAL_DATA VARCHAR(50) = ''
	DECLARE @TABLE_MMPRODAT VARCHAR(50) = ''

	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	DECLARE @SQL_TMP VARCHAR(MAX) = ''
	DECLARE @SQL_CTE VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FROM_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_FIXED VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_OPTIONAL VARCHAR(MAX) = ''
	DECLARE @SQL_CTE_FILTERS_EXCLUDING VARCHAR(MAX) = ''
	
	DECLARE @Sql NVARCHAR(MAX)

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TABLE_HISTORICAL_DATA = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_HISTORICAL_DATA = '[HistoricalData].[dbo].'
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
		IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
		BEGIN
			-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
			CREATE TABLE #TMP_HD_INTERACTIONS
			(
				[ID] VARCHAR(150),
				[InteractionId] VARCHAR(100),
				[Section] INT,
				[Part] INT,
				[Channel] VARCHAR(50),
				[Number] VARCHAR(100),
				[Gender] VARCHAR(50),
				[SilenceTime] INT,
				[DurationTime] INT,
				[AttentionTime] INT,
				[Category1] VARCHAR(100),
				[Category2] VARCHAR(100),
				[Category3] VARCHAR(100),
				[Description] VARCHAR(150),
				[DispositionCode] INT,
				[Campaign] VARCHAR(150),
				[Agent] VARCHAR(100),
				[AgentName] VARCHAR(100),
				[Type] VARCHAR(100),
				[StartDate] VARCHAR(100),
				[EndDate] VARCHAR(100),
				[Format] VARCHAR(50),
				[ContactAddress] VARCHAR(300),
				[ContactId]  VARCHAR(50),
				[ContactName] VARCHAR(300),
				[RelativeFileName] VARCHAR(1000),
				[RNA] INT
			)

			-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
			SET @IS_NESTED = 0
		END
		ELSE
		BEGIN
			-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
			SET @IS_NESTED = 1
		END 

		-- INICIAMOS ARMANDO LOS FILTROS PARA LA TABLA CTE PRINCIPAL
		SET @SQL_CTE_FILTERS_FIXED = '
				WHERE ID.[VirtualCC] = ''' + @VCC + '''
					AND ID.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' 
					AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + '''
					AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Format + ''','','')) '

		-- AGREGAMOS EL SCRIPT PARA LOS FILREOS DE HORA MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
					AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
					AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE CAMPAIGN
		IF (@Campaign IS NOT NULL AND @Campaign <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_CAMPAIGNS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_CAMPAIGNS FC 
					ON FC.[Value] = ID.[Campaign] ' 
		END

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO DE AGENT
		IF (@Agent IS NOT NULL AND @Agent <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE AGENTS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_AGENTS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_AGENTS FA 
					ON FA.[Value] = ISNULL(ID.[LastAgent], ID.[FirstAgent]) '
		END

		-- AGREGAMOS EL SCRPT PARA EL FILTRO ORIGEN
		IF (@Origin IS NOT NULL AND @Origin <> '') 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) '

		-- AGREGAMOS EL SCRIPT PARA LOS FILTROS DE DURACION MAXIMA Y HORA MINIMA LAS CUALES TIENEN UN COMPORTAMIENTO DIFERENTES SEGUN CUAL ES MAYOR
		IF (@MinDuration IS NOT NULL) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' '
		IF (@MaxDuration IS NOT NULL) 
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '

		-- AGREGAMOS EL SCRIPT PARA EL FILTRO CONTACT
		IF (@ContactAddress IS NOT NULL)
			SET @SQL_CTE_FILTERS_OPTIONAL += '
				AND ID.[ContactId] LIKE ''%' + @ContactAddress + '%'' '

		-- AGREGAMOS EL SCRIPT PARA INTERACTION_ID
		IF @InteractionIds IS NOT NULL AND @InteractionIds <> ''
		BEGIN
			SET @SQL_TMP = ''
			SET @SQL_CTE_FROM_OPTIONAL = ''
			SET @SQL_CTE_FILTERS_OPTIONAL = ''
			
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_INTERACTIONS_IDS
				FROM (
					SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')
				) A '
			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_FROM_OPTIONAL += '  
				INNER JOIN #FILTER_INTERACTIONS_IDS FID 
					ON FID.[Value] = ID.[Id] ' 
			-- SET @SQL_CTE_FILTERS_EXCLUDING = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
		END 


		-- ARMAMOS EL QUERY PARA EL CONTENIDO DE LA CTE
		SET @SQL_CTE_SELECT = '
			;WITH CTE_INTERACTION AS (
				SELECT ID.[VirtualCC]																						''VCC'',
						ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.[Part])	''ID'',       
						ID.[Id]																								''InteractionId'',       
						IMP.[Section]																						''Section'',       
						IMP.[Part]																							''Part'',       
						''CALL''																							''Channel'',       
						CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END								''Number'',       
						''''																								''Gender'',      
						ID.[HoldTime]																						''SilenceTime'',       
						ID.[AttentionTime]																					''DurationTime'', -- ESTO SE DEBE CORREGIR       
						ID.[AttentionTime]																					''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN       
						ID.[Campaign]																						''Campaign'',       
						ISNULL(ID.[LastAgent], ID.[FirstAgent])																''Agent'',   
						ID.[ManagementResult]																				''ManagementResult'',
						ID.[Direction]																						''Type'',       
						CONVERT(VARCHAR, ID.[StartDate], 120)																''StartDate'',       
						CONVERT(VARCHAR, ID.[EndDate], 120)																	''EndDate'',       
						IMP.[Format]																						''Format'',       
						CASE WHEN ID.[Direction] = ''E'' THEN CID.[CallerId] ELSE CID.[CalledId] END						''ContactAddress'',       
						CASE WHEN ID.[Direction] = ''E'' THEN CID.[CallerId] ELSE CID.[CalledId] END						''ContactId'',       
						ID.[ContactName]																					''ContactName'',       
						IMP.[RelativePath] + ''/'' + IMP.[FileName]															''RelativeFileName'',
						CASE WHEN CID.[SourceHangup] = 0 THEN ''Client'' ELSE ''Agent'' END      							''Ender''
					FROM [HistoricalData].[dbo].[InteractionDetail] ID (NOLOCK)    
					INNER JOIN [HistoricalData].[dbo].[InteractionMultimediaParts] IMP (NOLOCK)      
						ON IMP.Id = ID.Id
					INNER JOIN [HistoricalData].[dbo].[CallInteractionDetail] CID (NOLOCK)        
						ON ID.Id = CID.Id '
					+ @SQL_CTE_FROM_OPTIONAL
					+ @SQL_CTE_FILTERS_FIXED
					+ @SQL_CTE_FILTERS_OPTIONAL
					+ @SQL_CTE_FILTERS_EXCLUDING + '
			)
			,CTE_WITH_IAD AS (
				SELECT CET_I.*,
						IAD.[ActorName]											 ''agentName'' 
					FROM CTE_INTERACTION CET_I
					LEFT JOIN [HistoricalData].[dbo].[InteractionActorDetail] IAD (NOLOCK)       
						ON IAD.[VirtualCC] = CET_I.[VCC]
							AND IAD.[Id] = CET_I.[InteractionId]        
							AND IAD.[Section] = CET_I.[Section]        
							AND IAD.[Part] = CET_I.[Part]
			)
			,CTE_WITH_CGRM AS (	
				SELECT CTE_C.*,
						ISNULL(CGRM.[Category1], '''')								''Category1'',       
						ISNULL(CGRM.[Category2], '''')								''Category2'',       
						ISNULL(CGRM.[Category3], '''')								''Category3'',       
						ISNULL(CGRM.[Description], '''')							''Description'',       
						ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')				''DispositionCode'', 
						RNA = ROW_NUMBER() OVER(PARTITION BY (CTE_C.[Id] + ''_'' + CONVERT(VARCHAR(10), CTE_C.[Section]) + ''_'' + CONVERT(VARCHAR(10), CTE_C.Part)) ORDER BY CTE_C.[Id]) -- ROW NUMBER AUDIO
				FROM CTE_WITH_IAD CTE_C 
				LEFT JOIN (       
					SELECT VCC, CampaignID, [Order], [Code],            
							[Description], Category1, Category2, Category3         
						FROM [MMProDat].[dbo].[CampaignGoalResultManagement] (NOLOCK)
						WHERE VCC = ''' + @VCC + '''
				) CGRM         
					ON CGRM.VCC = CTE_C.[VCC]         
						AND CGRM.CampaignId = CTE_C.[Campaign]
						AND CGRM.[Description] = CTE_C.[ManagementResult]'

		-- AGREGAMOS EL SCRIPT PARA RESULTADO DE GESTION
		IF (@ResultCode IS NOT NULL AND @ResultCode <> '') 
		BEGIN
			-- DEBEMOS PASAR LA LISTA DE CAMPAIGNS A UNA TABLA TEMPORAL PARA AGILIZAR LA BUSQUEDA 
			SET @SQL_TMP += '
			SELECT * 
				INTO #FILTER_RESULT_CODES
				FROM (
					SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')
				) A '

			-- AGREGAMOS EL JOIN EN LA BUSQUEDA PRINCIPAL
			SET @SQL_CTE_SELECT += '  
				INNER JOIN #FILTER_RESULT_CODES FRC 
					ON (
						FRC.[Value] = CONCAT(CTE_C.[Campaign], ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), ''''))
						OR
						FRC.[Value] = CTE_C.[ManagementResult] 
					) '
		END

		SET @SQL_CTE_SELECT += '
			) -- SELECT * FROM CTE_WITH_CGRM'

		-- ARMAMOS EL QUERY PRINCIPAL
		SET @SQL_CTE = @SQL_TMP + @SQL_CTE_SELECT

		-- SEGUN SI EL SP ES ANIDADO O NO INSERTAMOS EN LA TEMPORAL EXISTENTE O LA CREAMOS
		IF @IS_NESTED = 1 
			SET @SQL_CTE += '
			INSERT INTO #TMP_HD_INTERACTIONS'	
		SET @SQL_CTE += '
			SELECT CTE_C.[ID],
					CTE_C.[InteractionId],
					CTE_C.[Section],
					CTE_C.[Part],
					CTE_C.[Channel],
					CTE_C.[Number],
					CTE_C.[Gender],
					CTE_C.[SilenceTime],
					CTE_C.[DurationTime],
					CTE_C.[AttentionTime],
					CTE_C.[Category1],
					CTE_C.[Category2],
					CTE_C.[Category3],
					CTE_C.[Description],
					CTE_C.[DispositionCode],
					CTE_C.[Campaign],
					CTE_C.[Agent],
					CTE_C.[AgentName],
					CTE_C.[Type],
					CTE_C.[StartDate],
					CTE_C.[EndDate],
					CTE_C.[Format],
					CTE_C.[ContactAddress],
					CTE_C.[ContactId],
					CTE_C.[ContactName],
					CTE_C.[RelativeFileName],
					CTE_C.[Ender],
					CTE_C.[RNA] '
		IF @IS_NESTED = 0 
			SET @SQL_CTE += '
				INTO #TMP_HD_INTERACTIONS '
		SET @SQL_CTE += '
				FROM CTE_WITH_CGRM CTE_C
			
			SELECT ROW_NUMBER() OVER (PARTITION BY Agent ORDER BY StartDate) AS RowNumber,
					HDI.*
				INTO #TMP_HD_INTERACTIONS_LIMIT
				FROM #TMP_HD_INTERACTIONS HDI
				WHERE [RNA] = 1

			SELECT DISTINCT [Agent] 
				INTO #AGENTS
				FROM #TMP_HD_INTERACTIONS HDI
				WHERE [RNA] = 1

			DROP TABLE IF EXISTS #FILTER_CAMPAIGNS 
			DROP TABLE IF EXISTS #FILTER_AGENTS
			DROP TABLE IF EXISTS #FILTER_RESULT_CODES
			DROP TABLE IF EXISTS #FILTER_INTERACTIONS_IDS '

		-- EJECUTAMOS EL SQL QUE NOS DEJA LA TEMPORAL #TMP_HD_INTERACTIONS CON REGISTROS
		--PRINT @SQL_CTE
		--EXEC (@SQL_CTE)
		--SELECT * FROM #TMP_HD_INTERACTIONS

		-- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
		DECLARE @QUERY_SUMMARY VARCHAR(MAX) = ''
		DECLARE @QUERY_DETAIL VARCHAR(MAX) = ''
		DECLARE @QUERY VARCHAR(MAX) = ''
		DECLARE @QUERY_FILTER VARCHAR(MAX) = ''
		DECLARE @QUERY_JOIN VARCHAR(MAX) = ''
	
		-- FILTRO POR INTERACCIONES EVALUADAS O NO
		IF(@Evaluated IS NOT NULL AND @Evaluated <> '')
		BEGIN 
			DECLARE @EvaluatedTable TABLE (Val BIT)
			INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
			-- SOLAMENTE SI ES SI O NO
			IF((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
			BEGIN
				IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
				BEGIN 
					SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
				END
				ELSE  --Si es No
				BEGIN
					SET @QUERY_JOIN += ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[InteractionId] AND AEP.[Completed] = 1) '
					SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
				END
			END
		END
		-- FIN FILTRO INTERACCIONES EVALUADAS

		-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
		IF @IS_NESTED = 0
		BEGIN
			-- EN AMBOS CASOS SE REQUIERE EL RESUMEN
			SET @QUERY_SUMMARY = @SQL_CTE + '
				SELECT HDIL.[channel]										AS ''interactionType'',
						COUNT(DISTINCT (HDIL.[InteractionId]))				AS ''interactions'',
						COUNT(DISTINCT (HDIL.[ID]))							AS ''details'',
						SUM(HDIL.[AttentionTime])							AS ''attentionTime''
					FROM #TMP_HD_INTERACTIONS_LIMIT HDIL '
			SET @QUERY +=  @QUERY_SUMMARY + @QUERY_JOIN
			IF @LimitIntByAgent > 0
			BEGIN
				SET @QUERY += ' WHERE HDIL.[RowNumber] <= '+CAST(@LimitIntByAgent AS VARCHAR) + @QUERY_FILTER + ' GROUP BY HDIL.[channel] '
			END
			ELSE
			BEGIN
				SET @QUERY += @QUERY_FILTER + ' GROUP BY HDIL.[channel] '
			END

			-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
			--IF @ResultType = 'SUMMARIZED'
			--BEGIN
			-- END
			-- ELSE 
			IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY_DETAIL = '
					SELECT HDIL.* 
						FROM #TMP_HD_INTERACTIONS_LIMIT HDIL ' 
				SET @QUERY += @QUERY_DETAIL + @QUERY_JOIN 
				IF (@LimitIntByAgent > 0)
				BEGIN
					SET @QUERY += ' WHERE HDIL.[RowNumber] <= '+CAST(@LimitIntByAgent AS VARCHAR) + @QUERY_FILTER + ' '
				END
				ELSE
				BEGIN
					SET @QUERY +=  @QUERY_FILTER + ' '
				END
			END

			DECLARE @QUERY_AGENTS VARCHAR(MAX)
			SET @QUERY_AGENTS = ' SELECT Agent as agent FROM #AGENTS'

			SET @QUERY+=  @QUERY_AGENTS
			-- EJECUTAMOS LA CONSULTA
			--PRINT @QUERY
			EXEC (@QUERY)
    
			-- ELIMINAMOS LA TABLA TEMPORARL
			DROP TABLE #TMP_HD_INTERACTIONS
		END

	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''		
		EXEC (@Sql)
	END

	

END
GO
PRINT N'Modificando Procedimiento [dbo].[GetAudio]...';


GO
ALTER PROCEDURE [dbo].[GetAudio] (
	@VCC Varchar(50) = NULL,
	@ProcessId Varchar(50) = NULL,
	@ID Varchar(100) = NULL,
	@Section NUMERIC(5, 0) NULL,
	@Part NUMERIC(5, 0) NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT TOP 1
		A.[ID]						'id',
		A.[Section]					'section',
		A.[Part]					'part',
		PA.[ProcessId]				'processId',
		A.[Number]					'number',
		A.[Gender]					'gender',
		A.[SilenceTime]				'silenceTime',
		A.[DurationTime]			'durationTime',
		A.[DurationLinguisticTime]	'durationLinguisticTime',
		A.[Category1]				'category1',
		A.[Category2]				'category2',
		A.[Category3]				'category3',
		A.[Description]				'description',
		A.[Campaign]				'campaign',
		A.[Agent]					'agent',
		A.[Type]					'type',
		A.[Init]					'init',
		A.[ChannelsChanged]			'channelsChanged',
		A.[IsTranscribed]			'isTranscribed',
		A.[RelativePath]			'relativePath',
		A.[FileName]				'fileName',
		P.[Retranscription]			'retranscription',
		A.[RelativeFileName]		'relativeFileName'
	FROM [Audio] A (NOLOCK)
	LEFT JOIN [ProcessAudio] PA (NOLOCK)
		ON PA.[VCC] = A.[VCC]
			AND A.ID = PA.AudioId 
			AND A.Section = PA.Section 
			AND A.Part = PA.Part
	LEFT JOIN [dbo].[Process] P (NOLOCK)
		ON P.[VCC] = A.[VCC]
			AND PA.[ProcessId] = P.[Name]
	WHERE A.[VCC] = @VCC
		AND (
			(@ProcessId IS NOT NULL AND P.[Name] = @ProcessId)
			OR 
			(@ProcessId IS NULL)
		)
		AND A.[ID] = @ID
		AND A.[Section] = @Section
		AND A.[Part] = @Part
		AND A.[IsTranscribed] = 1
		AND ISNULL(A.[IsCancel], 0) = 0
		AND P.[Name] IS NOT NULL
	ORDER BY A.CreatedDate DESC, PA.[CreatedDate] DESC

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetEvaluationPlanTipificationInteractionTask]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationPlanTipificationInteractionTask] (
    @VCC VARCHAR(50) = NULL, 
	@EvaluationPlanId VARCHAR(50) = NULL -- EVALUATION PLAN ID
)
AS
BEGIN
SET NOCOUNT ON
	-- ESTE SP TIENE POR FINALIDAD RETORNAR LA LISTA DE INTERACCIONES CRUZADA CON LOS MODELOS NLU PARA TIPIFICACIONES QUE SE VAN A EVALUAR

	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL TAMANO DE CAMPO NUEVO EN LA TABLA TEMPORAL
	DECLARE @MAIN_TARGET VARCHAR(50) = 'ABILITY' 
	
	-- BUSCAMOS LOS MODELOS ASOCIADOS AL PLAN Y LAS HABILIDADES QUE LO APLICAN
	SELECT DISTINCT HAQ.VCC										'vcc'
					,N.[Name] + '|' + I.[Name]					'cognitiveId'
					,N.[Name]									'nluId'
					,N.[AppId]									'appId'
					,I.[IntentId]								'intentId'
					,@MAIN_TARGET								'mainTarget'
					,STUFF(
						(
							SELECT DISTINCT ',' + INNER_HAQ.[AbilityId]
								FROM [dbo].[HistoricAbilityQuery] INNER_HAQ (NOLOCK)
								WHERE INNER_HAQ.[VCC] = HAQ.[VCC]
									AND INNER_HAQ.[EvaluationPlanId] = HAQ.[EvaluationPlanId]
									AND INNER_HAQ.[QueryContent] = N.[Name] + '|' + I.[Name]
							FOR XML PATH(''), TYPE
						).value('.', 'NVARCHAR(MAX)'), 
						1, 
						1, 
						''
					)											'abilities'
					,CONVERT(BIT, 1) 							'needRequest'
		INTO #EVALUATION_PLAN_MODELS 
		FROM [HistoricAbilityQuery] HAQ (NOLOCK) 
		INNER JOIN [HistoricAbility] HA (NOLOCK)
			ON HA.[VCC] = HAQ.[VCC]
				AND HA.[EvaluationPlanId] = HAQ.[EvaluationPlanId]
				AND HA.[ID] = HAQ.[AbilityId]
		INNER JOIN [dbo].[Intent] I (NOLOCK)
			ON I.[VCC] = HAQ.[VCC]
				AND I.[IntentId] = HAQ.[QueryId]
		INNER JOIN [dbo].[NLU] N (NOLOCK)
			ON N.[VCC] = HAQ.[VCC]
				AND N.[AppId] = I.[AppId]
		WHERE HAQ.[VCC] = @VCC
			AND HAQ.[EvaluationPlanId] = @EvaluationPlanId
			AND HA.[AnalysisType] = 'COGNITIVE'

	-- DROP TABLE #EVALUATION_PLAN_MODELS 
	-- SELECT * FROM #EVALUATION_PLAN_MODELS 

	-- BUSCAMOS LOS MODELOS ASOCIADOS AL PLAN (TIPIFICACIONES) QUE NO EXISTEN EN LAS HABILIDADES
	INSERT INTO #EVALUATION_PLAN_MODELS 
		SELECT DISTINCT HEFASTQ.VCC								'vcc'
						,N.[Name] + '|' + I.[Name]				'cognitiveId'
						,N.[Name]								'nluId'
						,N.[AppId]								'appId'
						,I.[IntentId]							'intentId'
						,'TIPIFICATION'							'mainTarget'
						,STUFF(
							(
								SELECT DISTINCT ',' + INNER_HS.[IdAbility]
									FROM [dbo].[HistoricEvaluationFormatAbilityScoreTipificationQuery] INNER_HEFASTQ (NOLOCK)
									INNER JOIN [dbo].[HistoricScore] INNER_HS (NOLOCK)
										ON INNER_HS.[VCC] = INNER_HEFASTQ.[VCC]
											AND INNER_HS.[EvaluationPlanId] = INNER_HEFASTQ.[EvaluationPlanId]
											AND INNER_HS.[ID] = INNER_HEFASTQ.[ScoreId]
									WHERE INNER_HEFASTQ.[VCC] = HEFASTQ.[VCC]
										AND INNER_HEFASTQ.[EvaluationPlanId] = HEFASTQ.[EvaluationPlanId]
										AND INNER_HEFASTQ.[QueryContent] = N.[Name] + '|' + I.[Name]
								FOR XML PATH(''), TYPE
							).value('.', 'NVARCHAR(MAX)'), 
							1, 
							1, 
							''
						)										'abilities'
						,CASE WHEN EPM.[vcc] IS NULL 
								THEN CONVERT(BIT, 1)
								ELSE CONVERT(BIT, 0)
							END									'needRequest'
			FROM [dbo].[HistoricEvaluationFormatAbilityScoreTipificationQuery] HEFASTQ (NOLOCK)
			INNER JOIN [dbo].[HistoricScore] HS (NOLOCK)
				ON HS.[VCC] = HEFASTQ.[VCC]
					AND HS.[EvaluationPlanId] = HEFASTQ.[EvaluationPlanId]
					AND HS.[ID] = HEFASTQ.[ScoreId]
			INNER JOIN [dbo].[Intent] I (NOLOCK)
				ON I.[VCC] = HEFASTQ.[VCC]
					AND I.[IntentId] = HEFASTQ.[QueryId]
			INNER JOIN [dbo].[NLU] N (NOLOCK)
				ON N.[VCC] = HEFASTQ.[VCC]
					AND N.[AppId] = I.[AppId]
			LEFT JOIN #EVALUATION_PLAN_MODELS EPM (NOLOCK)
				ON EPM.[VCC] = HEFASTQ.[VCC]
					AND EPM.[appId] = N.[AppId]
					AND EPM.[intentId] = I.[IntentId]
			WHERE HEFASTQ.[VCC] = @VCC
				AND HEFASTQ.[EvaluationPlanId] = @EvaluationPlanId



	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO CALL QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance									'vcc'
			,EP.ProcessId								'processId'
			,'EVALUATION_PLAN'							'batchTypeName'
			,AU.Campaign								'campaign'
			,IEP.[InteractionType]						'interactionType'
			,EP.[Id]									'evaluationPlanId'
			,IEP.IdInteraction							'id'
			,AU.Section									'section'
			,AU.Part									'part'
			,NULL										'folder'
			,EPM.nluId									'nluId'
			,EPM.appId									'appId'
			,EPM.[mainTarget]							'mainTarget'
			,AU.[FileName]								'fileName'
			--,EPM.[cognitiveId]						-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]						'cognitiveEngine'
			,EPM.[abilities]							'abilities'
			,EPM.[needRequest]							'needRequest'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON IEP.Instance = EP.Instance 
			AND IEP.IdEvaluationPlan = EP.Id
	INNER JOIN [dbo].[Audio] AU (NOLOCK) 
		ON AU.VCC = EP.Instance
			AND AU.ID = IEP.IdInteraction 
	INNER JOIN [dbo].[EvaluationResult] ER (NOLOCK)
		ON ER.[Instance] = EP.[Instance]
			AND ER.[IdEvaluationPlan] = EP.[ID]
			AND ER.[IdInteraction] = AU.[ID]
	INNER JOIN #EVALUATION_PLAN_MODELS EPM 
		ON EPM.[vcc] = EP.[Instance]
			--AND EPM.[cognitiveId] = HAQ.[QueryContent] 
			--AND EPM.[intentId] = HAQ.[QueryId] 
	INNER JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @EvaluationPlanId
		AND AU.[IsTranscribed] = 1
		AND ER.[Qualification] = 0
		AND EPM.[mainTarget] = 'TIPIFICATION'
	
	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO TEXT QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance									'vcc'
			,EP.ProcessId								'processId'
			,'EVALUATION_PLAN'							'batchTypeName'
			,AI.[Campaign]								'campaign'
			,IEP.[InteractionType]						'interactionType'
			,EP.[Id]									'evaluationPlanId'
			,IEP.IdInteraction							'id'
			,NULL										'section'
			,NULL										'part'
			,AI.[EndDate]								'endDate'
			,AI.[Folder]								'folder'
			,AI.[DispositionCode]						'dispositionCode'
			,EPM.nluId									'nluId'
			,EPM.appId									'appId'
			,EPM.[mainTarget]							'mainTarget'
			,AI.[FileName]								'fileName'
			--,F.[cognitiveId]							-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]						'cognitiveEngine'
			,EPM.[abilities]							'abilities'
			,EPM.[needRequest]							'needRequest'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON EP.Instance = IEP.Instance 
			AND EP.Id = IEP.IdEvaluationPlan
	INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK) 
		ON EP.Instance = AI.VCC 
			AND IEP.IdInteraction = AI.ID
			AND IEP.FormattedEndDate = AI.Folder
	INNER JOIN [dbo].[EvaluationResult] ER (NOLOCK)
		ON ER.[Instance] = EP.[Instance]
			AND ER.[IdEvaluationPlan] = EP.[ID]
			AND ER.[IdInteraction] = AI.[ID]
	INNER JOIN #EVALUATION_PLAN_MODELS EPM 
		ON EPM.[vcc] = EP.[Instance]
			--AND EPM.[cognitiveId] = HAQ.[QueryContent] 
			--AND EPM.[intentId] = HAQ.[QueryId] 
	INNER JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @EvaluationPlanId
		AND AI.[IsTranscribed] = 1
		AND ER.[Qualification] = 0
		AND EPM.[mainTarget] = 'TIPIFICATION'

SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveEvaluationBaseResult]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS

BEGIN
	-- ALERTA: NO ESTA PROBBADO PARA PLAN MANUAL

	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART

	DROP TABLE IF EXISTS #TMP_TRANSCRIBED_CALL_INTERACTIONS
	DROP TABLE IF EXISTS #TMP_RESULTS_FOR_EVALUATION 
	DROP TABLE IF EXISTS #TMP_EVALUATIONS_RESULTS

	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LAS INTERACCIONES CALL YA TRANSRITAS
	SELECT A.[ID]
		INTO #TMP_TRANSCRIBED_CALL_INTERACTIONS
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
			ON PA.[VCC] = A.[VCC]
				AND PA.[AudioId] = A.[ID] 
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = A.[VCC]
				AND EP.[ProcessId] = PA.[ProcessId]
		WHERE A.[VCC] = @VCC 
			AND A.[IsTranscribed] = 1
			AND EP.[ID] = @EVALUATION_PLAN_ID

	-- SELECT * FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
	
	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LAS INTERACCIONES TEXT YA TRANSRITAS
	SELECT AI.[ID]
		INTO #TMP_TRANSCRIBED_TEXT_INTERACTIONS
		FROM [dbo].[AsyncInteraction] AI (NOLOCK)
		INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			ON PAI.[VCC] = AI.[VCC]
				AND PAI.[InteractionId] = AI.[ID]
				AND PAI.[FormattedEndDate] = AI.[Folder]
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = AI.[VCC]
				AND EP.[ProcessId] = PAI.[ProcessId]
		WHERE AI.[VCC] = @VCC 
			AND AI.[IsTranscribed] = 1
			AND EP.[ID] = @EVALUATION_PLAN_ID

	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LOS EVALUATION_RESULT YA REGISTRADOS
	SELECT ER.*
		INTO #TMP_EVALUATIONS_RESULTS
		FROM [dbo].[EvaluationResult] ER (NOLOCK) 
		WHERE ER.[Instance] = @VCC 
			AND ER.[IdEvaluationPlan] = @EVALUATION_PLAN_ID

	-- SELECT * FROM #TMP_TRANSCRIBED_TEXT_INTERACTIONS
	
	-- GENERAMOS REGISTROS PARA TODAS LAS INTERACCIONES
	;WITH VALID_INTERACTIONS_CTE AS (
		SELECT [ID] FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
		UNION ALL
		SELECT [ID] FROM #TMP_TRANSCRIBED_TEXT_INTERACTIONS
	)
	, INTERACTIONS_ALL_CTE AS (
		SELECT IEP.[Instance],
				IEP.[IdEvaluationPlan],
				IEP.[IdCampaign],
				IEP.[IdInteraction],
				IEP.[IdAgent],
				IEP.[InteractionDateStart],
				IEP.[InteractionDateEnd],
				IEP.[InteractionType],
				IEP.[ContactId],
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],
													IEP.[IdEvaluationPlan],				
													IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent],
													IEP.[InteractionDateStart],
													IEP.[InteractionDateEnd],
													IEP.[InteractionType],
													IEP.[ContactId]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC)
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			INNER JOIN VALID_INTERACTIONS_CTE IA_CTE 
				ON IA_CTE.[ID] = IEP.[IdInteraction]
			WHERE IEP.[Instance] = @VCC
				AND IEP.[IdEvaluationPlan] = @EVALUATION_PLAN_ID
	)  -- SELECT * FROM INTERACTIONS_ALL_CTE RETURN
	, INTERACTIONS_SUMMARY_CTE AS (
		SELECT I_A_CTE.*
			FROM INTERACTIONS_ALL_CTE I_A_CTE
			WHERE I_A_CTE.RN = 1
	) -- SELECT * FROM INTERACTIONS_SUMMARY_CTE RETURN
	, INTERACTIONS_FIRST_FILTER_CTE AS (
		SELECT * 
			FROM INTERACTIONS_SUMMARY_CTE IS_CTE
			WHERE (
					IS_CTE.[InteractionType] = 'CALL' 
					AND 
					IS_CTE.[IdInteraction] IN (
						SELECT [ID] FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
					)
				)
				OR
				IS_CTE.[InteractionType] <> 'CALL' 
	)  -- SELECT * FROM INTERACTIONS_FIRST_FILTER_CTE RETURN /*
	-- TODO: EL SECOND_FILTER ES SOBRE LAS INTERACCIONES TEXT TRANSCRITAS
	, MAIN_CTE AS (
		SELECT EP.[Instance]										'vcc',
				EP.[ID]												'IdEvaluationPlan',
				EP.[IdEvaluationFormat]								'IdEvaluationFormat',
				HEF.[MinQualificationAcceptable]					'MinQualificationAcceptable',
				IFF_CTE.[IdInteraction]								'IdInteraction',
				IFF_CTE.[IdCampaign]								'IdCampaign',
				IFF_CTE.[IdAgent]									'IdAgent',
				EP.[ProcessId]										'ProcessId',
				HAEF.[IdGroup]										'IdGroup',
				HAEF.[IdSubGroup]									'IdSubGroup',
				HAEF.[IdAbility]									'IdAbility',
				HAEF.[Score]										'MaxAbilityScore',
				HS.[Value]											'AbilityInnerScore',
				HS.[Description]									'ScoreDescription',
				IFF_CTE.[IdCampaign]								'CampaignDescription',
				IFF_CTE.[IdAgent]									'AgentDescription',
				IFF_CTE.[InteractionDateStart]						'InteractionDateini',
				IFF_CTE.[InteractionDateEnd]						'InteractionDatefin',
				IFF_CTE.[ContactId]									'InteractionAddress',
				HAEF.[Order]										'AbilityOrder',
				IFF_CTE.[InteractionType]							'InteractionType',
				HAEF.[ID]											'IdAbilityEvaluationFormat',
				HAEF.[Conditional]									'Conditional'
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			INNER JOIN [dbo].[HistoricEvaluationFormat] HEF (NOLOCK)
				ON HEF.[VCC] = EP.[Instance]
					AND HEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbilityEvaluationFormat] HAEF (NOLOCK)
				ON HAEF.[VCC] = EP.[Instance]
					AND HAEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
				ON HA.[VCC] = EP.[Instance]
					AND HA.[EvaluationPlanId] = EP.[ID]
					AND HA.[ID] = HAEF.[IdAbility]
			INNER JOIN [dbo].[HistoricScore] HS (NOLOCK)
				ON HS.[VCC] = EP.[Instance]
					AND HS.[EvaluationPlanId] = EP.[ID]
					AND HS.[IdAbility] = HA.[ID]
					AND HS.[Value] = IIF(HA.[IsNegative] = 1, 100, 0)
			INNER JOIN INTERACTIONS_FIRST_FILTER_CTE IFF_CTE 
				ON IFF_CTE.[Instance] = EP.[Instance]
					AND IFF_CTE.[IdEvaluationPlan] = EP.[ID]
			LEFT JOIN #TMP_EVALUATIONS_RESULTS TMP_ER 
				ON TMP_ER.[Instance] = EP.[Instance]
					AND TMP_ER.[IdEvaluationPlan] = EP.[ID]
					AND TMP_ER.[IdInteraction] = IFF_CTE.[IdInteraction]
					AND TMP_ER.[IdAbility] = HA.[ID]
					AND ISNULL(TMP_ER.[IdAgent], '') = ISNULL(IFF_CTE.[IdAgent], '')
					AND TMP_ER.[IdAbilityEvaluationFormat] = HAEF.[ID]
			WHERE TMP_ER.[Instance] IS NULL
				AND EP.[Instance] = @VCC
				AND IFF_CTE.[IdInteraction] IS NOT NULL
			    AND EP.[ID] = @EVALUATION_PLAN_ID
				AND (
					(
						@ABILITY_TYPE = 'AUTOMATIC' 
						AND 
						HA.[Type] = 'MANUAL_AUTOMATIC'
					)
					OR
					(
						@ABILITY_TYPE = 'MANUAL' 
						AND 
						HA.[Type] = 'MANUAL'
					)
				)
	)  -- SELECT * FROM MAIN_CTE RETURN
	
		
	-- INSERTAMOS TODOS LOS REGISTROS EN UNA TABLA TEMPORAL
	SELECT * -- 0 'DEBUG'
		INTO #TMP_RESULTS_FOR_EVALUATION
		FROM MAIN_CTE
	
	-- ELIMINAMOS LOS REGISTROS PARA INTERACCIONES TEXT NO TRANSCRITAS
	/*
	DELETE FROM TMP_RESULTS_FOR_EVALUATION
		WHERE [InteractionType] <> 'CALL' 
			AND [IdInteraction] NOT IN (
				SELECT [ID] FROM #TMP_NOT_TRANSCRIBED_TEXT_INTERACTIONS
			)
			*/

	-- TENEMOS LOS REGISTROS PARA INSERTAR EN EVALUATIONRESULT
	-- SELECT * FROM #TMP_RESULTS_FOR_EVALUATION RETURN

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [OwnScore], [AbilityInnerScore],
		[IdEvaluator], [EvaluationDate], [MaxAbilityScore],
		[IdEvaluationPlan], [CreatedDate], [CreatedByUserId],
		[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],
		[Comment], [NotApplies], [ScoreDescription],
		[CampaignDescription], [AgentDescription], [InteractionDateini],
		[InteractionDatefin], [InteractionAddress], [AbilityOrder],
		[InteractionType], [IdAbilityEvaluationFormat],  [IdAuditor],
		[Conditional]
	)
		SELECT TMP_RFE.[vcc], TMP_RFE.[IdCampaign], TMP_RFE.[IdInteraction],
				ISNULL(TMP_RFE.[IdAgent], ''), TMP_RFE.[IdEvaluationFormat], TMP_RFE.[MinQualificationAcceptable],
				TMP_RFE.[IdGroup], TMP_RFE.[IdSubGroup], TMP_RFE.[IdAbility],
				(TMP_RFE.[MaxAbilityScore] * TMP_RFE.[AbilityInnerScore] / 100), (TMP_RFE.[MaxAbilityScore] * TMP_RFE.[AbilityInnerScore] / 100), TMP_RFE.[AbilityInnerScore],
				'SPEECH', GETUTCDATE(), TMP_RFE.[MaxAbilityScore],
				TMP_RFE.[IdEvaluationPlan], GETUTCDATE(), 'SPEECH',
				--'100', TMP_RFE.[IdEvaluationPlan], GETUTCDATE(),
				GETUTCDATE(), 'SPEECH', GETUTCDATE(),
				NULL, '0', TMP_RFE.[ScoreDescription],
				TMP_RFE.[CampaignDescription], TMP_RFE.[AgentDescription], TMP_RFE.[InteractionDateini],
				TMP_RFE.[InteractionDatefin], TMP_RFE.[InteractionAddress], TMP_RFE.[AbilityOrder],
				TMP_RFE.[InteractionType], TMP_RFE.[IdAbilityEvaluationFormat], 'SPEECH',
				TMP_RFE.[Conditional]
			FROM #TMP_RESULTS_FOR_EVALUATION TMP_RFE

	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE #TMP_TRANSCRIBED_CALL_INTERACTIONS
	DROP TABLE #TMP_RESULTS_FOR_EVALUATION
	DROP TABLE #TMP_EVALUATIONS_RESULTS

	SET NOCOUNT OFF

END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkEvaluationPlanAbility]...';


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanAbility]
AS
BEGIN
	SET NOCOUNT ON
	-- ESTE PROCEDURE RECIBE COMO RESULTADO LAS INTERACCIONES QUE COINCIDEN CON UN QUERY EN UN PLAN DE EVALUACION
	
	/*-- INSERTAMOS LA DATA DE LA TEMPORAL PARA DEPURAR EL SP MANUALMENTE
	IF OBJECT_ID(N'[dbo].[TMP_BULK_QUERY]', N'U') IS NULL
	BEGIN
		SELECT *
			INTO [dbo].[TMP_BULK_QUERY]
			FROM [dbo].[#EvaluationPlanAbilityTemp]

		/*
		SELECT * 
			INTO #EvaluationPlanAbilityTemp
			FROM [dbo].[TMP_BULK_QUERY] (nolock)
		*/
	END
	*/

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				EPATMP.[VCC]						'VCC', 
				EPATMP.[EvaluationPlanId]			'EVALUATION_PLAN_ID'
			FROM [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

		-- INSERTAMOS LOS RESULTADOS DE LAS INTERACCIONES DE AUDIO QUE MATCHEARON CON LA QUERY
		INSERT INTO [dbo].[InteractionQueryResult] (
			[VCC],
			[InteractionId],
			[Section],
			[Part],
			[InteractionType],
			[TranscriptionId],
			[BatchType],
			[BatchTypeId],
			[BatchTypeName],
			[AnalysisType],
			[QueryId],
			[QueryName],
			[QueryValue],
			[QueryData],
			[Matches],
			[Details],
			[CreatedDate],
			[TimeStamp]
		)
			SELECT @CURRENT_VCC,
					PA.[AudioId],
					PA.[Section],
					PA.[Part],
					'CALL', --EPATMP.[Channel],
					CONCAT(PA.[AudioId], '_', ISNULL(PA.[Section], '0'), '_', ISNULL(PA.[Part], '0')),
					'EVALUATION_PLAN',
					@CURRENT_EVALUATION_PLAN_ID,
					EP.[Description],
					'SEMANTIC',
					GQ.[Name],
					GQ.[Name],
					GQ.[Query],
					GQ.[RawData],
					EPATMP.[Matches],
					EPATMP.[MatchesDetail],
					GETUTCDATE(),
					GETUTCDATE()
				FROM [#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = EPATMP.[VCC]
						AND EP.[ID] = EPATMP.[EvaluationPlanId]
				INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
					ON PA.[VCC] = EPATMP.[VCC]
						AND PA.[ProcessId] = EPATMP.[ProcessId]
						AND PA.[AudioId] = EPATMP.[AudioId]
						AND PA.[Section] = EPATMP.[Section]
						AND PA.[Part] = EPATMP.[Part]
				INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
					ON AEF.[Instance] = EPATMP.[VCC]
						AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				/*
				INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
					ON AQ.[VCC] = EPATMP.[VCC]
						AND AQ.[AbilityId] = AEF.[IdAbility] 
						AND AQ.[QueryId] = EPATMP.[QueryId]
				*/
				INNER JOIN [GenericQuery] GQ (NOLOCK)
					ON GQ.[VCC] = EPATMP.[VCC]
						AND GQ.[Name] = EPATMP.[QueryId]
				WHERE EPATMP.[VCC] = @CURRENT_VCC
					AND EPATMP.[EvaluationPlanId] = @CURRENT_EVALUATION_PLAN_ID

		-- INSERTAMOS LOS RESULTADOS DE LAS INTERACCIONES DE TEXTO QUE MATCHEARON CON LA QUERY
		INSERT INTO [dbo].[InteractionQueryResult] (
			[VCC],
			[InteractionId],
			[Section],
			[Part],
			[InteractionType],
			[TranscriptionId],
			[BatchType],
			[BatchTypeId],
			[BatchTypeName],
			[AnalysisType],
			[QueryId],
			[QueryName],
			[QueryValue],
			[QueryData],
			[Matches],
			[Details],
			[CreatedDate],
			[TimeStamp]
		)
			SELECT @CURRENT_VCC,
					PAI.[InteractionId],
					NULL,
					NULL,
					EPATMP.[Channel],
					EPATMP.[AudioId],
					'EVALUATION_PLAN',
					@CURRENT_EVALUATION_PLAN_ID,
					EP.[Description],
					'SEMANTIC',
					GQ.[Name],
					GQ.[Name],
					GQ.[Query],
					GQ.[RawData],
					EPATMP.[Matches],
					EPATMP.[MatchesDetail],
					GETUTCDATE(),
					GETUTCDATE()
				FROM [#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = EPATMP.[VCC]
						AND EP.[ID] = EPATMP.[EvaluationPlanId]
				INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = EPATMP.[VCC]
						AND PAI.[ProcessId] = EPATMP.[ProcessId]
						AND PAI.[InteractionType] = EPATMP.[Channel]
						AND PAI.[FormattedEndDate] = EPATMP.[EndDate]
						AND PAI.[Campaign] = EPATMP.[Campaign]
						/* LA TEMPORAL DE TYPESCRIPT REMOVIA EL PREFIJO, POR ELLO SE CAMBIO PARA MATCHEAR CON EL ID
						AND (
							CONCAT(
									PAI.[InteractionType], 
									'_', 
									PAI.[Campaign], 
									'_', 
									PAI.[FormattedEndDate], 
									'_', 
									REPLACE(PAI.[InteractionId], ':', '_')
							) = EPATMP.[AudioId]
						)
						*/
						AND REPLACE(PAI.[InteractionId], ':', '_') = EPATMP.[AudioId]
				INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
					ON AEF.[Instance] = EPATMP.[VCC]
						AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				/*
				INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
					ON AQ.[VCC] = EPATMP.[VCC]
						AND AQ.[AbilityId] = AEF.[IdAbility] 
						AND AQ.[QueryId] = EPATMP.[QueryId]
				*/
				INNER JOIN [GenericQuery] GQ (NOLOCK)
					ON GQ.[VCC] = EPATMP.[VCC]
						AND GQ.[Name] = EPATMP.[QueryId]
				WHERE EPATMP.[VCC] = @CURRENT_VCC
					AND EPATMP.[EvaluationPlanId] = @CURRENT_EVALUATION_PLAN_ID
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS

	
	
	
	--ACTUALIZAR LOS SCORES DE LAS HABILIDADES RETORNADAS EN LA TABLA TEMPORAL
	UPDATE ER 
	SET ER.[Qualification] = (S.[Value] * AEF.[Score] / 100), 
		ER.[OwnScore] = (AEF.[Score] * S.[Value]) / 100,
		ER.[ScoreDescription] = S.[Description],
		ER.[AbilityInnerScore] = S.[Value]
	/*
	SELECT (S.[Value] * AEF.[Score] / 100), 
			(AEF.[Score] * S.[Value]) / 100,
			S.[Description],
			S.[Value]
	*/
	FROM [dbo].[EvaluationResult] ER (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND REPLACE(ER.[IdInteraction], ':', '_') = EPATMP.[AudioId] 
	LEFT JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		ON AEF.[Instance] = ER.[Instance] 
		AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
		AND AEF.[IdAbility] = ER.[IdAbility]
	INNER JOIN [dbo].[Ability] A (NOLOCK) 
		ON A.[Instance] = ER.[Instance] 
		AND A.[ID] = ER.[IdAbility]
	INNER JOIN [dbo].[AbilityQuery] AB (NOLOCK)
		ON AB.[VCC] = ER.[Instance] 
			AND AB.[AbilityId] = AEF.[IdAbility]
			AND AB.[QueryId] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = ER.[Instance] 
		AND S.[IdAbility] = ER.[IdAbility]
		AND S.[Value] =  IIF(A.[IsNegative] = 1, 0, 100)

	;WITH 
	-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DE LA SUMA DE HABILIDADES PARA LA EVALUACION
	CteEvaluationScoreResult AS (
		-- ESTE BLOQUE ACTUALIZA LAS NOTAS DE EVALUACIONES AUTOMATICAS SEGUN LOS PLANES CONTENIDOS EN LA TEMPORAL
		SELECT ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction], SUM(ER.[Qualification]) TOTAL
			FROM EvaluationResult ER 
			INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) EPATMP 
			--INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) EPATMP 
				ON EPATMP.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
			LEFT JOIN AbilityEvaluationFormat AEF 
				ON AEF.[Instance] = ER.[Instance]
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
					AND AEF.[ID] = ER.[IdAbilityEvaluationFormat]
			WHERE ER.[IdAuditor] = 'SPEECH'
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction]
	)
	
	-- SE ACTUALIZA LAS EVALUACIONES QUE COINCIDEN CON LOS RESULTADOS
	UPDATE AEP 
		SET AEP.[Score] = ESR.[TOTAL],
			AEP.[AutomaticScore] =  ESR.[TOTAL],
			AEP.[ManualScore] = 0,
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		INNER JOIN CteEvaluationScoreResult ESR 
			ON AEP.[Instance] = ESR.[Instance]
				AND AEP.[IdEvaluationPlan] = ESR.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = ESR.[IdEvaluator]
				AND AEP.[IdInteraction] = ESR.[IdInteraction]

	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	;WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[AbilityInnerScore] = 0 AND ER.[NotApplies] = 0 AND HAEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				HAEF.[Penalizes],
				CASE HAEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[AbilityInnerScore] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE HAEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [dbo].[EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [dbo].[HistoricAbilityEvaluationFormat] HAEF (NOLOCK) 
				ON HAEF.[VCC] = ER.[Instance]
					AND HAEF.[EvaluationPlanId] = ER.[IdEvaluationPlan]
					AND HAEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND HAEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) 
			--WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) 
				AND ER.[AbilityInnerScore] = 0
                AND ER.[NotApplies] = 0
				AND HAEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),
	--SELECT * FROM CTEFP

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				ER.[IdAuditor],
				SUM(ER.[Qualification])															'TOTAL_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC', ER.[Qualification], 0))					'TOTAL_AUTOMATIC_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL', ER.[Qualification], 0))							'TOTAL_MANUAL_SCORE',
				--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
				SUM(ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
				))																				'PENALIZED_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL_AUTOMATIC',
					ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
					) THEN 0 ELSE 1 END),
					0) 
				)																				'PENALIZED_AUTOMATIC_SCORE',
				SUM(IIF(HA.[Type] = 'MANUAL',
					ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1
					) THEN 0 ELSE 1 END),
					0) 
				)																				'PENALIZED_MANUAL_SCORE'
			FROM [dbo].[EvaluationResult] ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[IdInteraction], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP2
				ON FP2.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
					AND ER.[IdInteraction] = FP2.[IdInteraction]
					/*
					AND CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
					AND FP2.[Penalized] = 1
					*/
			INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
				ON HA.[VCC] = ER.[Instance]
					AND HA.[EvaluationPlanId] = ER.[IdEvaluationPlan]
					AND HA.[ID] = ER.[IdAbility]
			--WHERE ER.[Instance] = 'multisalud'
			WHERE -- ER.[Instance] = FP2.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
				-- AND 
				ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp)
				--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				ER.[IdAuditor]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[AutomaticScore] = FS.[PENALIZED_AUTOMATIC_SCORE],
			AEP.[ManualScore] = FS.[PENALIZED_MANUAL_SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
				AND FS.[IdAuditor] = AEP.[IdAuditor]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	--insert into test(origin,content) values('BulkAbilityCognitive',(select *  from [dbo].[#AbilityCognitiveTemp] FOR JSON AUTO))

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [dbo].[#EvaluationPlanAbilityTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]

	



	------------INICIO DE ACTUALIZACION DE ESTADOS DE PROCESS I6UPDATE --------------

	-- ACTUALIZAMOS EL ESTADO GENERAL DE PROCESS SOBRE LA ACTUALIZACION DE INTERACCIONES CALL I6
	PRINT CONCAT('UPDATING I6_UPDATE STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE P 
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error],0) > 0 
											THEN 'I6_UPDATE_COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error],0) = 0 
											THEN 'I6_UPDATE_COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON P.[vcc] = PT.[vcc] 
				AND PT.ProcessId = P.[Name] 
		WHERE PT.[Type] = 'i6update'

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	PRINT CONCAT('UPDATING I6_UPDATE: PROCESS_STATUS ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE A
		SET [Status] = CASE 
				WHEN B.total >= 0 
						AND B.total <= B.[updated] + B.cancel 
						AND B.cancel > B.[updated] 
					THEN 'FAILED' 
				WHEN B.total >= 0 
						AND B.total <= B.[updated] + B.cancel 
					THEN 'COMPLETE' 
				ELSE 'INPROCESS_I6_UPDATE' 
				END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] AS A
		INNER JOIN (
			SELECT SUM(UT.total)									'total',
					SUM(UT.cancel)									'cancel',
					SUM(UT.[updated])								'updated',
					UT.processId									'processId',
					UT.vcc											'vcc'
				FROM (
					SELECT COUNT(1)										'total'
							,COUNT(A.[isCancel])						'cancel'
							,COUNT(IIF(A.[NeedI6Update] = 0, 1, 0))		'updated' 
							,PT.[ProcessId]								'processId'
							,PT.[vcc]									'vcc'
						FROM [dbo].[ProcessAudio] PA (NOLOCK)
						INNER JOIN [#ProgressTemp] PT 
							ON PA.[vcc] = PT.[vcc] 
								AND PA.ProcessId = PT.ProcessId 
								AND PT.[Percentage] = 1
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON PA.[VCC] = A.VCC 
								AND PA.[AudioId] = A.ID 
						WHERE PT.[Type] = 'i6update'
						GROUP BY PT.ProcessId, PT.vcc
				) UT 
				GROUP BY UT.processId, UT.vcc
		) B ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.[ProcessId]

	------------FIN DE ACTUALIZACION DE ESTADOS DE PROCESS I6UPDATE --------------



	  
	------------INICIO DE ACTUALIZACION DE ESTADOS DE PROCESS --------------
	PRINT CONCAT('UPDATING PROCESS_UPDATE: STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE A
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error], 0) > 0 
											THEN 'COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error], 0) = 0 
											THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM Process AS A
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON A.[vcc] = PT.[vcc] 
				AND A.[Name] = PT.ProcessId 
		WHERE PT.[Type] IS NULL

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	PRINT CONCAT('UPDATING PROCESS_UPDATE: PROCESS_STATUS ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT ISNULL(SUM(UT.total), 0)					'total',
				ISNULL(SUM(UT.cancel), 0)				'cancel',
				ISNULL(SUM(UT.transcription), 0)		'transcription',
				UT.processId							'processId',
				UT.vcc									'vcc'
			FROM (
			SELECT COUNT(1)					total
					,COUNT(C.isCancel)			cancel
					,COUNT(C.IsTranscribed)		transcription 
					,B.ProcessId				processId
					,B.vcc						vcc
				FROM [ProcessAudio] A (NOLOCK)
				INNER JOIN [#ProgressTemp] B 
					ON A.[vcc] = B.[vcc] 
						AND A.ProcessId = B.ProcessId 
						-- AND B.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN Audio C (NOLOCK) 
					ON A.VCC = C.VCC 
						AND A.AudioId =C.ID 
						AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
						AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
				WHERE B.[Type] IS NULL
				GROUP BY B.ProcessId, B.vcc
			UNION
			SELECT 
				COUNT(1)						total
				,COUNT(AI.IsCancel)			cancel
				,COUNT(AI.IsTranscribed)		transcription
				,PT.[ProcessId]				processId
				,PT.[vcc]						vcc
				FROM [ProcessAsyncInteraction] PAI (NOLOCK)
				INNER JOIN [#ProgressTemp] PT
					ON PAI.[VCC] = PT.[vcc]
						AND PAI.[ProcessId] = PT.[ProcessId]
						-- AND PT.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN [AsyncInteraction] AI (NOLOCK) 
					ON AI.[VCC] = PT.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE PT.[Type] IS NULL
				GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	-- ACTUALIZAMOS EL ESTADO DE OTROS PROCESOS QUE ESTAN COMO FALLIDOS, COLGADOS, ETC QUE COINCIDEN CON LAS INTERACCIONES DEL PROCESS TERMINADO
	PRINT CONCAT('UPDATING PROCESS_UPDATE: OTHER_PROCESS_STATUS ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[VCC] = P.[VCC]
								AND PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[VCC] = PA.[VCC]
								AND A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	PRINT CONCAT('UPDATING PROCESS_UPDATE: BATCH_INSERT ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION

	-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
	PRINT CONCAT('UPDATING PROCESS_UPDATE: TEMPLATE_SCHEDULE_INSERT ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT PTMP.[vcc],
				NEWID(),
				BS.[Id],
				PTMP.[ProcessId],
				GETUTCDATE(),
				'PENDING',
				'system',
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
				ON BS.[VCC] = PTMP.[vcc]
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION
				AND BS.[BatchType] = 'TEMPLATE'
				AND GETUTCDATE() >= BS.[StartDate]
				AND (
					BS.[EndDate] IS NULL 
					OR
					GETUTCDATE() < BS.[EndDate]
				)

	------------FIN DE ACTUALIZACION DE ESTADOS DE PROCESS --------------





	------------INICIO DE ACTUALIZACION DE ESTADOS DE ESTUDIOS --------------
	PRINT CONCAT('UPDATING STUDY_UPDATE: STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] IN ('study', 'template')
				
	--Eliminar StudyResultSummary
	PRINT CONCAT('UPDATING STUDY_UPDATE: DELETE_STUFF_01 ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	         DELETE SRS FROM [dbo].[StudyResultSummary] SRS 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRS.[VCC] 
	                       AND S.[Name] = SRS.[StudyId] 
	                       AND S.[TemplateId] = SRS.[TemplateId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRS.[TemplateThemeId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRS.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	                  
	           	        
	 -- Eliminar StudyResultSummaryDetail
	 PRINT CONCAT('UPDATING STUDY_UPDATE: DELETE_STUFF_02 ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	           	  DELETE SRSD FROM [dbo].[StudyResultSummaryDetail] SRSD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRSD.[VCC] 
	                       AND S.[Name] = SRSD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRSD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SRSD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRSD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	
   	 -- Eliminar StudyResultSummaryDetail
	 PRINT CONCAT('UPDATING STUDY_UPDATE: DELETE_STUFF_03 ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	           	  DELETE SD FROM [dbo].[StudyDetail] SD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SD.[VCC] 
	                       AND S.[Name] = SD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.[ProcessId] 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type] IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	PRINT CONCAT('UPDATING STUDY_UPDATE: BATCH_INSERT ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], UPPER(PTMP.[Type]), PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] IN ('study', 'template')
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IN ('study', 'template')

	-- ACTUALIZAMOS LA EJECUCION RELACIONADA AL BATCH TEMPLATE TERMINADO
	PRINT CONCAT('UPDATING STUDY_UPDATE: BATCH_SCHEDULE_UPDATE ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE BSE 
		SET BSE.[Status] = 'FINISHED',
			BSE.[LastModifiedByUserId] = 'system',
			BSE.[LastModifiedDate] = GETUTCDATE()
		FROM [#ProgressTemp] PTMP
		INNER JOIN [dbo].[BatchScheduleExecution] BSE 
			ON BSE.[vcc] = PTMP.[vcc] 
				AND BSE.[BatchId] = PTMP.[TypeId] 
		WHERE PTMP.[Percentage] = 1 
			AND PTMP.[Type] = 'template'

	------------FIN DE ACTUALIZACION DE ESTADOS DE ESTUDIOS --------------





	------------INICIO DE ACTUALIZACION DE ESTADOS DE PLAN DE EVALUACION --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE EP
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE 'IN_PROGRESS' END
			,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
				AND B.[Type] IS NULL 
				AND EP.[FilterByContentQueryName] IS NOT NULL 
				AND EP.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: STEP_03_STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'
			
	-- UPDATE PARA INICIAR LA PARTE DE ANALISIS SEMANTICO/COGNITIVO CUANDO EL PROCESS TERMINOS
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: EVALUATION_PLAN_STATUS_UPDATE_01 ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE EP
		SET EP.[Total] = B.[Total]
			,EP.[progress] = B.[Progress]
			,EP.[error] = B.[Error]
			,EP.[percentage] = B.[Percentage]
			,EP.[StatusDescription] = CASE WHEN B.[Percentage] = 1 
												AND P.[Status] NOT LIKE '%I6_UPDATE%'
											--THEN CASE WHEN P.[StatusDescription] = 'FAILED' THEN 'CANCELLED_BY_FAILED_PROCESS'
											--		ELSE P.[StatusDescription]
											--		END
											THEN IIF (P.[StatusDescription] = 'FAILED', 'CANCELLED_BY_FAILED_PROCESS', P.[StatusDescription])
											ELSE 'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN B.[Percentage] = 1
							--THEN CASE WHEN P.[StatusDescription] = 'FAILED' THEN 10 
							--		ELSE 5 END
								THEN IIF (P.[StatusDescription] = 'FAILED', 10, 5)
							ELSE 2 END
			,EP.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[Process] P (NOLOCK)
			ON P.[VCC] = EP.[Instance]
				AND P.[Name] = EP.[ProcessId] 
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
		WHERE EP.[FilterByContentQueryName] IS NULL 
				AND EP.[FilterByContentQuery] IS NULL 
				AND EP.[Evaluation_Mode] IN ('A', 'X')
				AND B.[Type] IS NULL 

	/*
	--OBTENGO ESTADOS DE PROCESO DE AUDIOS
	;WITH AudioStatus AS (
		SELECT D.[VCC]										'instance',
				D.[ProcessId]								'processId',
				COUNT(*) 									'total',
				SUM(IIF(A.[IsTranscribed] = 1, 1, 0))		'transcribed',
				SUM(IIF(A.[IsCancel] = 1, 1, 0))			'cancelled'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON A.[ID] = IEP.[IdInteraction]
					AND A.[Section] = IEP.[InteractionSection]
					AND A.[Part] = IEP.[InteractionPart]
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = IEP.[Instance]
					AND EP.[ID] = IEP.[IdEvaluationPlan]
			INNER JOIN [dbo].[#ProgressTemp] D (NOLOCK)
				ON D.[vcc] = EP.[Instance]
					AND D.[ProcessId] = EP.ProcessId
					AND  D.[TypeId] = EP.Id
					AND D.[Type] = 'ability'
			GROUP BY D.[VCC], D.[ProcessId]
	)
	*/

	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES(FASE DE EVALUACION AUTOMATICA) DE LA TABLA TEMPORAL CUANDO EL PLAN ESTA EN STATUS 5 (ANALIZADO) O 6 (EVALUANDO)
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: EVALUATION_PLAN_STATUS_UPDATE_02 ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE EP
		SET EP.[Total] = B.[Total]
			,EP.[progress] = B.[Progress]
			,EP.[error] = B.[Error]
			,EP.[percentage] = B.[Percentage]
			,EP.[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error], 0) > 0 THEN 'EVALUATION_COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error], 0) = 0 THEN 'EVALUATION_COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN B.[Percentage] = 1 THEN 11 ELSE 6 END
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
				AND EP.Id = B.[TypeId] 
				AND B.[Type] = 'ability'
		WHERE EP.[Status] IN (5, 6)

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 11 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: AUDITOR_EVALUATION_PLAN_STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[StatusDescription] = 'COMPLETED'
			,[LastModifiedByUserId] = 'system'
			,[LastModifiedDate] = GETUTCDATE()
			,[TimeStamp] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
	WHERE EP.[Status] = 11
		AND AEP.[IdAuditor] = 'SPEECH' 
		AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X') 
		AND B.[Type] = 'ability'



	/*************************************INICIO DE ACTUALIZACION DE TIPIFICACIONES***********************************************/
	
	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES(FASE DE TIPIFICACIONES) DE LA TABLA TEMPORAL
	PRINT CONCAT('UPDATING TIPIFICATION_UPDATE: STUFF ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE EP
		SET EP.[percentage] = TMP_P.[Percentage]
			,EP.[StatusDescription] = CASE WHEN TMP_P.[Percentage] = 1 AND  ISNULL(TMP_P.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN TMP_P.[Percentage] = 1 AND  ISNULL(TMP_P.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN TMP_P.[Percentage] = 1 THEN 7 ELSE 12 END
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] EP
		INNER JOIN [dbo].[#ProgressTemp] TMP_P 
			ON EP.[Instance] = TMP_P.[vcc] 
				AND EP.[ProcessId] = TMP_P.ProcessId 
				AND EP.Id = TMP_P.[TypeId] 
		WHERE EP.[Status] IN (11, 12)
			AND TMP_P.[Type] = 'tipification'

	/*************************************FIN DE ACTUALIZACION DE TIPIFICACIONES***********************************************/

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND PTMP.[Type] IN ('ability', 'evaluationPlan', 'tipification')
			WHERE EP.[Status] = 7
				AND PTMP.[Percentage] = 1 
				AND PTMP.[Type] IN ('ability', 'evaluationPlan', 'tipification')



	-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: TEMPLATE_SCHEDULE_INSERT ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT PTMP.[vcc],
				NEWID(),
				BS.[Id],
				PTMP.[ProcessId],
				GETUTCDATE(),
				'PENDING',
				'system',
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
				ON BS.[VCC] = PTMP.[vcc]
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan') -- EL NULL INDICA QUE ES PROCESS DE PLAN DE EVALUACION
				AND BS.[BatchType] = 'TEMPLATE'
				AND GETUTCDATE() >= BS.[StartDate]
				AND (
					BS.[EndDate] IS NULL 
					OR
					GETUTCDATE() < BS.[EndDate]
				)

	-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: PATCHING_MISSING_RESULTS ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT PTMP.[vcc] 'VCC', 
				PTMP.[TypeId] 'EVALUATION_PLAN_ID'
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
			WHERE PTMP.[Percentage] = 1 
				AND (
					PTMP.[Type] = 'ability' 
					OR 
					PTMP.[Type] = 'evaluationPlan'
				)
			
	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: PATCHING_MISSING_RESULTS_PER_PLAN ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1 
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
		BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
			EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
			UPDATE AEP
				SET AEP.[Completed] = '1'
					,AEP.[StatusDescription] = 'COMPLETED'
					,AEP.[LastModifiedByUserId] = 'system'
					,AEP.[LastModifiedDate] = GETUTCDATE()
					,AEP.[TimeStamp] = GETUTCDATE()
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		END

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





	-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE DE EVALUACION AUTOMATICA(ESTADO 11), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL AL ESTADO 7)

	DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: UPDATING_MIXED_EVALUATION_PLAN_STATUS ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	DECLARE MY_CURSOR_2 CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				PT.[vcc]								'VCC', 
				PT.[TypeId]								'EVALUATION_PLAN_ID',
				EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
			FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
			INNER JOIN [dbo].[#ProgressTemp] PT 
				ON EP.[Instance] = PT.[vcc] 
					AND EP.[ProcessId] = PT.[ProcessId] 
					AND EP.[Id] = PT.[TypeId] 
					AND PT.[Type] = 'ability'
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			WHERE EP.[Status] = 11
				AND EP.[Evaluation_Mode] = 'X'

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: UPDATING_MIXED_EVALUATION_PLAN_STATUS_PER_PLAN ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	OPEN MY_CURSOR_2
	FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
		BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
			UPDATE EP 
				SET EP.[percentage] = 0
					,EP.[StatusDescription] = 'IN_PROGRESS'
					,EP.[Status] = 8
					,EP.[LastModifiedDate] = GETUTCDATE() 
				FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
				WHERE EP.[Instance] = @CURRENT_VCC
					AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
			DECLARE MY_AUDITOR_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
				FOR 
				-- CONSULTAMOS LOS ID DE AUDITORES
				SELECT DISTINCT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE  AEP.[Instance] = @CURRENT_VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND AEP.[IdAuditor] <> 'SPEECH'

			-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
			OPEN MY_AUDITOR_CURSOR
			FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
				INSERT INTO [dbo].[EvaluationResult] (
					[Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
					[MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
					[OwnScore], [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], 
					[CreatedDate], [CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], 
					[CampaignDescription], [AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], 
					[AbilityOrder], [InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
				) 
					-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
					SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
							ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
							ER.[OwnScore], ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], 
							ER.[CreatedDate], ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], 
							ER.[CampaignDescription], ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], 
							ER.[AbilityOrder], ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
						FROM [dbo].[EvaluationResult] ER (NOLOCK)
						INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
							ON AEP.[Instance] = ER.[Instance]
								AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
								AND AEP.[IdAuditor] = ER.[IdAuditor]
								AND AEP.[IdInteraction] = ER.[IdInteraction]
								AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
						WHERE ER.[Instance] = @CURRENT_VCC
							AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
							AND ER.[IdAuditor] = 'SPEECH'

				-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
				UPDATE [dbo].[AuditorEvaluationPlan]
					SET [Completed] = 0,
						[AutomaticScore] = [Score],
						[ManualScore] = 0,
						[StatusDescription] = 'NEW',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = @CURRENT_AUDITOR_ID

				FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			END
			CLOSE MY_AUDITOR_CURSOR
			DEALLOCATE MY_AUDITOR_CURSOR

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

			-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
			DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] = 'SPEECH'
					AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'
					AND [IdInteraction] IN (
						SELECT [IdInteraction] 
							FROM [dbo].[AuditorEvaluationPlan] 
							WHERE [Instance] = @CURRENT_VCC
								AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
								AND [IdAuditor] = 'SPEECH'
								AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
					)

			-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
			UPDATE [dbo].[AuditorEvaluationPlan]
					SET [AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = 'SPEECH'

		END
		ELSE
		BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
			DELETE FROM [dbo].[AuditorEvaluationPlan] 
				WHERE  [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

		END

		FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	END
	CLOSE MY_CURSOR_2
	DEALLOCATE MY_CURSOR_2

	-- INVALIDAR LAS AUDITORIAS CUYO AUDIO PRESENTAN ALGUN ERROR
	PRINT CONCAT('UPDATING EVALUATION_PLAN_UPDATE: UPDATING_FAILED_INTERACTIONS ', (CONVERT(VARCHAR(24), GETUTCDATE(), 121)))
	UPDATE AEP
		SET AEP.[StatusDescription] = 'INVALID'
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK)
		    ON AEP.[Instance] = A.[VCC] 
		        AND AEP.[IdInteraction] = A.[ID]
		INNER JOIN [#ProgressTemp] PTMP (NOLOCK)
			ON AEP.[Instance] = PTMP.[vcc]
			    AND AEP.[IdEvaluationPlan] = PTMP.[TypeId]
		WHERE (
				A.[IsTranscribed] IS NULL 
				OR 
				A.[IsTranscribed]  <> 1
			)
		    AND (
				PTMP.[Type] = 'ability' 
				OR 
				PTMP.[Type] = 'evaluationPlan'
			)
		    -- AND A.[ErrorMessage] IN ('GET_AUDIO_REQUEST_FAILED','JSON_IDATHA_IS_NOT_FOUND','JSON_TRANSCRIPTION_CONTENT_IS_EMPTY')

	-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

	/*
	-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
	UPDATE EP 
		SET EP.[percentage] = 0
			,EP.[StatusDescription] = 'IN_PROGRESS'
			,EP.[Status] = 8
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON EP.[Instance] = PT.[vcc] 
				AND EP.[ProcessId] = PT.[ProcessId] 
				AND EP.[Id] = PT.[TypeId] 
				AND PT.[Type] = 'ability'
		WHERE EP.[Status] = 7
			AND EP.[Evaluation_Mode] = 'X'
	*/
	

	-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteEnvironment]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEnvironment]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEnvironmentByName]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEnvironmentByName]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEnvironments]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEnvironments]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEnvironmentTypeByName]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEnvironmentTypeByName]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcess]';


GO
PRINT N'Actualizando Procedimiento [dbo].[RollbackVcc]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[RollbackVcc]';


GO
PRINT N'Actualizando Procedimiento [dbo].[DeleteWorkGroupSupervisor]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteWorkGroupSupervisor]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetTeamPerformanceFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFilters]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetTeamPerformanceFromEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTeamPerformanceFromEvaluationPlan]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetWorkGroupsFromSupervisorEP]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetWorkGroupsFromSupervisorEP]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetHistoricAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetHistoricAgents]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetHistoricCampaigns]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetHistoricCampaigns]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetWorkGroupsSupervisor]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetWorkGroupsSupervisor]';


GO
PRINT N'Actualizando Procedimiento [dbo].[GetWorkGroupSupervisor]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetWorkGroupSupervisor]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveWorkGroupSupervisor]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveWorkGroupSupervisor]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando Procedimiento [dbo].[CreateVcc]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CreateVcc]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveVcc]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveVcc]';


GO
PRINT N'Actualización completada.';


GO