PRINT N'Iniciando recompilación de la tabla [dbo].[Process]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Process] (
    [VCC]                  VARCHAR (50)    NOT NULL,
    [Name]                 VARCHAR (50)    NOT NULL,
    [Description]          VARCHAR (50)    NULL,
    [ClientId]             VARCHAR (50)    NULL,
    [Total]                INT             NULL,
    [Progress]             INT             NULL,
    [Error]                INT             NULL,
    [Percentage]           FLOAT (53)      NULL,
    [StatusDescription]    VARCHAR (MAX)   NULL,
    [Status]               VARCHAR (50)    NULL,
    [Type]                 VARCHAR (50)    NULL,
    [StartDate]            DATETIME        NULL,
    [EndDate]              DATETIME        NULL,
    [MinDurationTime]      NUMERIC (18, 2) NULL,
    [MaxDurationTime]      NUMERIC (18, 2) NULL,
    [Language]             VARCHAR (25)    NULL,
    [DictionaryId]         VARCHAR (50)    NULL,
    [Environment]          VARCHAR (50)    NULL,
    [QueryId]              VARCHAR (50)    NULL,
    [QueryDataId]          VARCHAR (50)    NULL,
    [QueryDataIdDate]      DATETIME        NULL,
    [CreatedDate]          DATETIME        NULL,
    [CreatedByUserId]      VARCHAR (50)    NULL,
    [LastModifiedDate]     DATETIME        NULL,
    [LastModifiedByUserId] VARCHAR (50)    NULL,
    [TimeStamp]            DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Process_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [Name] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Process])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Process] ([VCC], [Name], [Description], [ClientId], [Total], [Progress], [Error], [Percentage], [StatusDescription], [Status], [Type], [StartDate], [EndDate], [MinDurationTime], [MaxDurationTime], [Language], [Environment], [QueryId], [QueryDataId], [QueryDataIdDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [Name],
                 [Description],
                 [ClientId],
                 [Total],
                 [Progress],
                 [Error],
                 [Percentage],
                 [StatusDescription],
                 [Status],
                 [Type],
                 [StartDate],
                 [EndDate],
                 [MinDurationTime],
                 [MaxDurationTime],
                 [Language],
                 [Environment],
                 [QueryId],
                 [QueryDataId],
                 [QueryDataIdDate],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Process]
        ORDER BY [VCC] ASC, [Name] ASC;
    END

DROP TABLE [dbo].[Process];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Process]', N'Process';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Process_11]', N'PK_Process_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Modificando [dbo].[VCC]...';


GO
ALTER TABLE [dbo].[VCC]
    ADD [DeleteDataDays] INT DEFAULT ('360') NULL;


GO
PRINT N'Creando [dbo].[CleanerSummary]...';


GO
CREATE TABLE [dbo].[CleanerSummary] (
    [Task]        VARCHAR (15)  NULL,
    [Status]      BIT           NULL,
    [Description] VARCHAR (250) NULL,
    [CreatedAt]   DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[Dictionary]...';


GO
CREATE TABLE [dbo].[Dictionary] (
    [VCC]                  VARCHAR (50)  NULL,
    [Name]                 VARCHAR (50)  NULL,
    [Description]          VARCHAR (250) NULL,
    [Language]             VARCHAR (5)   NULL,
    [IsSystemDictionary]   BIT           NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[DictionaryWord]...';


GO
CREATE TABLE [dbo].[DictionaryWord] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [DictionaryId]         VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (50)  NOT NULL,
    [Word]                 VARCHAR (100) NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[DictionaryWordSoundLike]...';


GO
CREATE TABLE [dbo].[DictionaryWordSoundLike] (
    [VCC]                  VARCHAR (50)  NULL,
    [DictionaryWordId]     VARCHAR (50)  NULL,
    [ID]                   VARCHAR (50)  NULL,
    [SoundLike]            VARCHAR (100) NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[DF_Dictionary_IsSystemDictionary]...';


GO
ALTER TABLE [dbo].[Dictionary]
    ADD CONSTRAINT [DF_Dictionary_IsSystemDictionary] DEFAULT ((0)) FOR [IsSystemDictionary];


GO
PRINT N'Modificando [dbo].[GetProcess]...';


GO
--exec [GetProcess] 'inconcert','test'
ALTER PROCEDURE [dbo].[GetProcess] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]						    'vcc',
		[Name]						    'name',
		[Description]					'description',
		[ClientId]						'clientId',
		[Status]						'status',
		[Type]							'type',
		[StartDate]						'startDate',
		[EndDate]						'endDate',
		[MinDurationTime]				'minDurationTime',
		[MaxDurationTime]				'maxDurationTime',
		[Language]						'language',
		[DictionaryId]					'dictionaryId',
		IIF (
			[DictionaryId] IS NULL, 
			CONVERT(BIT, 0), 
			CONVERT(BIT, 1)
		)								'useDictionary',
		[Environment]					'environment',
		[QueryId]						'queryId',
		[QueryDataId]					'queryDataId',
		[QueryDataIdDate]				'queryDataIdDate',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [Process] (NOLOCK)
	WHERE [VCC] = @VCC
	AND [Name] = @Name

	EXEC [GetProcessFilters] @VCC, @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcessByName]...';


GO
--[GetProcessByName] 'inconcert', 'test2'
ALTER PROCEDURE [dbo].[GetProcessByName] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[Name]						    'name',
		[Description]					'description',
		[ClientId]						'clientId',
		[Status]						'status',
		[StartDate]						'startDate',
		[EndDate]						'endDate',
		[MinDurationTime]				'minDurationTime',
		[MaxDurationTime]				'maxDurationTime',
		[Language]						'language',
		[DictionaryId]					'dictionaryId',
		IIF (
			[DictionaryId] IS NULL, 
			CONVERT(BIT, 0), 
			CONVERT(BIT, 1)
		)								'useDictionary',
		[Environment]					'environment',
		[QueryId]						'queryId',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [Process] (NOLOCK)
	WHERE [Name] = @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
		
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				INSERTED.[RelativePath]					'relativePath',
				INSERTED.[FileName]						'fileName',
				P.[Language]							'language',
				P.[DictionaryId]						'dictionaryId',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND ((ISNULL(A.[IsProcess], 0) = 0				
					AND ISNULL(A.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (A.[IsProcess] = 1						
					AND A.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				'allegro'															'environmentType'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				AND AI.[EndDate] = PAI.[EndDate]
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND ((ISNULL(AI.[IsProcess], 0) = 0
					AND ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (AI.[IsProcess] = 1
					AND AI.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcessTask]...';


GO
--exec [GetProcess] 'inconcert','test'
ALTER PROCEDURE [dbo].[GetProcessTask] (
	@VCC Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]						    'vcc',
		[Name]						    'name',
		[Description]					'description',
		[ClientId]						'clientId',
		[Status]						'status',
		[Type]							'type',
		[StartDate]						'startDate',
		[EndDate]						'endDate',
		[MinDurationTime]				'minDurationTime',
		[MaxDurationTime]				'maxDurationTime',
		[Language]						'language',
		[DictionaryId]					'dictionaryId',
		[Environment]					'environment',
		[QueryId]						'queryId',
		[QueryDataId]					'queryDataId',
		[QueryDataIdDate]				'queryDataIdDate',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [Process] (NOLOCK)
	WHERE [VCC] = @VCC
	AND [Name] = @ID

	EXEC [GetProcessFilters] @VCC, @ID
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveProcess]...';


GO

ALTER PROCEDURE [dbo].[SaveProcess] (
	@VCC Varchar(50) = NULL,
	@Name Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@ClientId Varchar(50) = NULL,
	@Type VARCHAR(50),
	@Status Varchar(50) = NULL,
	@StartDate Datetime = NULL,
	@EndDate Datetime = NULL,
	@MinDurationTime Numeric(18, 2) = NULL,
	@MaxDurationTime Numeric(18, 2) = NULL,
	@Language VARCHAR(25) = NULL,
	@DictionaryId VARCHAR(50) = NULL,
	@Environment Varchar(50) = NULL,
	@QueryId Varchar(50) = NULL,
	@QueryDataId Varchar(50) = NULL,
	@QueryDataIdDate Datetime = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Process]
	SET [Description] = @Description,
		[ClientId] = @ClientId,
		[Status] = @Status,
		[Type] = @Type,
		[StartDate] = @StartDate,
		[EndDate] = @EndDate,
		[MinDurationTime] = @MinDurationTime,
		[MaxDurationTime] = @MaxDurationTime,
		[Language] = @Language,
		[DictionaryId] = @DictionaryId,
		[Environment] = @Environment,
		[QueryId] = @QueryId,
		[QueryDataId] = @QueryDataId,
		[QueryDataIdDate] = @QueryDataIdDate,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Process] (
			[VCC], [Name], [Description],
			[ClientId], [Status], [Type], [StartDate],
			[EndDate], [MinDurationTime], [MaxDurationTime], 
			[Language], [DictionaryId], [Environment], 
			[QueryId], [QueryDataId], [QueryDataIdDate], 
			[CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @Name, @Description,
			@ClientId, @Status, @Type, @StartDate,
			@EndDate, @MinDurationTime, @MaxDurationTime, 
			@Language, @DictionaryId, @Environment, 
			@QueryId, @QueryDataId, @QueryDataIdDate, 
			@CreatedDate, @CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetVCC]...';


GO
ALTER PROCEDURE [dbo].[GetVCC](
	@ID varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]									'vcc',
		[ID]									'id',
		[TYPE]									'type',
		[TranscriptionDefaultLanguage]			'transcriptionDefaultLanguage',
		[Description]							'description',
		[CognitiveEngine]						'cognitiveEngine',
		[Country]								'country',
		[Language]								'language',
		[TimeZone]								'timeZone',
		[CreatedDate]							'createdDate',
		[CreatedByUserId]						'createdByUserId',
		[LastModifiedDate]						'lastModifiedDate',
		[LastModifiedByUserId]					'lastModifiedByUserId',
		[IsMigrating]                           'isMigrating',
		[DeleteDataDays]                        'deleteDataDays'
	FROM [VCC] (NOLOCK)
	WHERE [ID] = @ID

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveNLU]...';


GO

ALTER PROCEDURE [dbo].[SaveNLU] (
	@VCC Varchar(50) = NULL, 					
	@Name Varchar(50) = NULL,					
	@Culture Varchar(50) = NULL,
	@Description Varchar(50) = NULL,			
	@AppId Varchar(100) = NULL,					
	@SubscriptionKey Varchar(50) = NULL,
	@IsSystemApp BIT = 0,
	@IsPublished BIT = NULL,
	@LastPublishedDate DATETIME = NULL,
	@IsTrained BIT = NULL,
	@NeedTrain BIT = NULL,
	@LastTrainedDate DATETIME = NULL,
	@CreatedDate Datetime = NULL,               
	@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,			
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	-- SI LA VARIABLE LLEGA NULL, LA SETTEAMOS COMO 0
	IF @IsSystemApp IS NULL 
		SET @IsSystemApp = 0

	UPDATE [NLU]
	SET [Culture] = @Culture,
		[Description] = @Description,
		[AppId] = @AppId,
		[IsPublished] = CASE WHEN @IsPublished IS NULL THEN [IsPublished] ELSE @IsPublished END,
		[LastPublishedDate] = CASE WHEN @LastPublishedDate IS NULL THEN [LastPublishedDate] ELSE @LastPublishedDate END,
		[IsSystemApp] = CASE WHEN @IsSystemApp IS NULL THEN [IsSystemApp] ELSE @IsSystemApp END,
		[SubscriptionKey] = CASE WHEN @SubscriptionKey IS NULL THEN [SubscriptionKey] ELSE @SubscriptionKey END,
		[IsTrained] = CASE WHEN @IsTrained IS NULL THEN [IsTrained] ELSE @IsTrained END,
		[NeedTrain] = CASE WHEN @NeedTrain IS NULL THEN [NeedTrain] ELSE @NeedTrain END,
		[LastTrainedDate] = CASE WHEN @LastTrainedDate IS NULL THEN [LastTrainedDate] ELSE @LastTrainedDate END,
		-- [CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [NLU] (
			[VCC], [Name], [Culture],
			[Description], [AppId], [SubscriptionKey],
			[IsSystemApp], [CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[CognitiveEngine]
			)
		VALUES (
			@VCC, @Name, @Culture,
			@Description, @AppId, @SubscriptionKey,
			@IsSystemApp, GETUTCDATE(), @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(),
			IIF(@IsSystemApp = 1, 'RASA', (SELECT [CognitiveEngine] FROM [dbo].[VCC] WHERE [VCC] = @VCC))
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveVcc]...';


GO
ALTER PROCEDURE [dbo].[SaveVcc] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@TranscriptionDefaultLanguage VARCHAR(25) = NULL,
	@CognitiveEngine VARCHAR(25) = NULL,
	@Country Varchar(50) = NULL,
	@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId   VARCHAR(50) = NULL,
	@DeleteDataDays         INT = 360,
	@ChangedCognitiveEngine BIT = 0
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @IsMigrating BIT = 0
	IF(@ChangedCognitiveEngine IS NOT NULL AND @ChangedCognitiveEngine = 1)
	   SET @IsMigrating = 1
	   
	   
	UPDATE [VCC]
		SET [Description] = @Description,
			[Type] = @Type,
			[Country] = @Country,
			[TranscriptionDefaultLanguage] = @TranscriptionDefaultLanguage,
			[CognitiveEngine] = @CognitiveEngine,
			[Language] = @Language,
			[TimeZone] = @TimeZone,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[IsMigrating] = IIF(@IsMigrating = 1,1,0),
			[DeleteDataDays] = @DeleteDataDays,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [VCC] (
			[VCC], [ID], [Description], [Type], [Country], 
			[TranscriptionDefaultLanguage], [CognitiveEngine], [Language], [TimeZone], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [DeleteDataDays], [TimeStamp]
			)
		VALUES (
			@VCC, @ID, @Description, @Type, @Country, 
			@TranscriptionDefaultLanguage, @CognitiveEngine, @Language, @TimeZone, @CreatedDate,  
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId, @DeleteDataDays, GETUTCDATE()
		)
		
	--SI HA CAMBIADO LOS NLUS ACTUALIZAR EL ESTADO DE LOS MODELOS A NO DISPONIBLE
	IF(@IsMigrating = 1)
	BEGIN 
	  EXEC SaveCognitiveEngineMigrateStatus @VCC,'*','*',0,'NOT_AVAILABLE'
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], ISNULL(A.[AgentName], AG.[Name]) 'AgentName',
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[RelativePath], A.[FileName], A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], 
				A.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
			FROM #AudioTemp A (NOLOCK)
			LEFT JOIN [dbo].[Agent] AG (NOLOCK)
				ON AG.[VCC] = A.[VCC]
					AND AG.[AgentId] = A.[Agent]
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[RelativePath]
			,[FileName]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[RelativePath]
			,A.[FileName]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
			SELECT * FROM Audio B (NOLOCK)
			WHERE B.[VCC] = A.[VCC]
			AND B.[ID] = A.[ID]
			AND B.[Section] = A.[Section]
			AND B.[Part] = A.[Part]
		);

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Modificando [dbo].[GetAudiosTranscriptions]...';


GO
ALTER PROCEDURE [dbo].[GetAudiosTranscriptions]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
    @InteractionIds         VARCHAR(MAX) = NULL
)
AS
BEGIN
	DECLARE @SQL                    NVARCHAR(MAX);
    DECLARE @FILTERS_OPTIONAL_PART  VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
	SET @SQL = 'SET NOCOUNT ON
	DECLARE @rows INT
	SET @rows = (SELECT COUNT(A.ID)
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[VCC] = A.[VCC]
				AND A.ID = PA.AudioId 
				AND A.Section = PA.Section 
				AND A.Part = PA.Part
		LEFT JOIN [dbo].[Process] P (NOLOCK)
			-- ON P.[Description] = PA.[ProcessId]
			ON P.[VCC] = A.[VCC]
				AND P.[Name] = PA.[ProcessId]
		WHERE A.[VCC] = ''' + @VCC + ''' 
			AND A.[IsTranscribed] = 1 
			AND P.[TYPE] = ''SPEECH'' '
			IF(@ProcessId IS NOT NULL)
			BEGIN
				SET @SQL += '
				AND PA.[ProcessId]= ''' + @ProcessId + ''' '
			END
​
​
	BEGIN
		IF(@ID IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND CONCAT(A.[ID], ''_'', A.[Section], ''_'', A.[Part]) LIKE ''%' + @ID + '%''
			'
		END
		IF(@Campaign IS NOT NULL AND LEN(@Campaign) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[Campaign] IN(''' + @Campaign + ''')
			'
		END
		IF(@Agent IS NOT NULL AND LEN(@Agent) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[Agent] IN(''' + @Agent + ''')
			'
		END
		IF(@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND CONCAT(A.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), A.[DispositionCode]), '''')) IN (''' + @ResultCode + ''')
			'
		END
		IF(@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[EndDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
			'
		END
		IF(@StartHour IS NOT NULL AND @EndHour IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND DATEPART(HOUR, A.[EndDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' AND DATEPART(HOUR, A.[EndDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
			'
		END
		IF(@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND DATEPART(MINUTE, A.[EndDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' AND DATEPART(MINUTE, A.[EndDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
			'
		END
​
        IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
        BEGIN 
            SET @FILTERS_OPTIONAL_PART = '';
	        SET @FILTERS_EXCLUDING_PART=' AND A.[ID] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
        END
​
	END
	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;
	SET @SQL += ') '
	SET @SQL += ' SELECT @rows AS total '
​
	SET @SQL += '
		SELECT
			A.[ID]						''id'',
			A.[Section]					''section'',
			A.[Part]					''part'',
			PA.[ProcessId]				''processId'',
			A.[Number]					''number'',
			B.[Name]					''name'',
			A.[SilenceTime]				''silenceTime'',
			A.[DurationTime]			''durationTime'',
			A.[DurationLinguisticTime]	''durationLinguisticTime'',
			A.[Category1]				''category1'',
			A.[Category2]				''category2'',
			A.[Category3]				''category3'',
			A.[Agent]					''agent'',
			A.[AgentName]				''agentName'',
			A.[Description]				''description'',
			B.[Environment]				''environment'',
			E.[Type]					''environmentType'',
			A.[IsTranscribed]			''isTranscribed'',
			COUNT(UT.[Text])		    ''isSubrayed'',
			A.[CreatedDate]				''createdDate'',
			A.[EndDate]					''endDate''
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[VCC] = A.[VCC]
				AND A.ID = PA.AudioId 
				AND A.Section = PA.Section 
				AND A.Part = PA.Part
		INNER JOIN [dbo].[Process] B (NOLOCK) 
			ON B.[VCC] = PA.[VCC]
				AND PA.[ProcessId] = B.[Name]
		inner JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = B.[VCC]
				AND B.[Environment] = E.[Name] 
				AND B.VCC = E.VCC
		LEFT JOIN [dbo].[Underlined] U (NOLOCK) 
			ON U.[VCC] = A.[VCC]
				AND A.ID = U.AudioId 
				AND A.Section = U.Section 
				AND A.Part = U.Part
	    LEFT JOIN [dbo].[Utterance] UT (NOLOCK)
	        ON UT.[VCC] = U.[VCC]
	           AND U.[UtteranceId] = UT.[Id]
		WHERE
			A.[VCC] = ''' + @VCC + ''' AND A.[IsTranscribed] = 1 '
			IF(@ProcessId IS NOT NULL)
			BEGIN
				SET @SQL += '
				AND PA.[ProcessId] = ''' + @ProcessId + ''' '
			END
			SET @SQL += '
	'
	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;
	SET @SQL += '
		AND B.[TYPE] = ''SPEECH''
		GROUP BY A.[ID], A.[Section], A.[Part], PA.[ProcessId], A.[Number],
				B.[Name], A.[SilenceTime], A.[DurationTime], A.[DurationLinguisticTime], A.[Category1],     
				A.[Category2], A.[Category3], A.[Agent], A.[AgentName], A.[Description], 
				B.[Environment], E.[Type], A.[IsTranscribed], A.[CreatedDate], A.[EndDate]
		ORDER BY A.[ID], PA.[ProcessId], A.[Agent], A.[Description], B.[Environment], A.[DurationTime], A.[CreatedDate]
		OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
		FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY;
	'
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationPlan] (
    @Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
)
AS
BEGIN
SET NOCOUNT ON

	SELECT
		EP.[ID]												'id',
		EP.[Modality]										'modality',
		EP.[DateFin]										'dateFin',
		EP.[IdEvaluationFormat]								'idEvaluationFormat',
		EP.[Description]									'description',
		EP.[Enabled]										'enabled',
		EP.[CreatedDate]									'createdDate',
		EP.[CreatedByUserId]								'createdByUserId',
		EP.[LastModifiedDate]								'lastModifiedDate',
		EP.[LastModifiedByUserId]							'lastModifiedByUserId',
		EP.[Status]											'status',
		EP.[Evaluation_Mode]								'evaluation_mode',
		EP.[ProcessId]										'processId',
		EP.[EvaluationStarted]								'evaluationStarted',
		EP.[FilterByContent]								'filterByContent',
		EP.[FilterByContentPercentage]						'filterByContentPercentage',
		EP.[FilterByContentQuery]							'filterByContentQuery',
		EP.[FilterByContentQueryName]						'filterByContentQueryName',
		EP.[ProcessAndEvaluate]								'processAndEvaluate',
		EP.[TranscriptionLanguage]							'transcriptionLanguage',
		P.[DictionaryId]									'dictionaryId',
		IIF (
			P.[DictionaryId] IS NULL, 
			CONVERT(BIT, 0), 
			CONVERT(BIT, 1)
		)													'useDictionary',
		EP.[EnvironmentId]									'environmentId',
		E.[Type]											'environmentType'
	FROM [EvaluationPlan] EP (NOLOCK)
	LEFT JOIN [Environment] E (NOLOCK)
		ON E.[VCC] = EP.[Instance]
			AND E.[Name] = EP.[EnvironmentId]
	LEFT JOIN [dbo].[Process] P (NOLOCK)
		ON P.[VCC] = EP.[Instance]
			AND P.[Name] = EP.ProcessId
 	WHERE [Instance] = @Instance
		AND [ID] = @ID

SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetIntents]...';


GO
ALTER PROCEDURE [dbo].[GetIntents] (
	@VCC Varchar(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Intents NVARCHAR(MAX)
	)
AS
BEGIN
	
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId
	
	SET @SQL = '
	SET NOCOUNT ON
	SELECT [Name]						    ''name'',
	        [AppId]                         ''appId'',
			[IntentId]						''intentId'',
			[Color]							''color'',
			[CreatedDate]					''createdDate'',
			[CreatedByUserId]				''createdByUserId'',
			[LastModifiedDate]				''lastModifiedDate'',
			[LastModifiedByUserId]			''lastModifiedByUserId'',
			[Status]                        ''status'',
			[StatusCode]                    ''statusCode''
		FROM [dbo].[Intent] (NOLOCK)
		WHERE [VCC] = ''' + @VCC + '''
			AND [AppId] = ''' + @AppId + ''' '

	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND [IntentId] IN (''' + @Intents + ''') '
	END

	IF @SearchCriteria IS NOT NULL AND @SearchExpression IS NOT NULL
	BEGIN
		SET @SQL +=	'
			AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END '
	END

	SET @SQL +=	'
		ORDER BY [LastModifiedDate] ASC, [Name] DESC '

	SET @SQL += ' 
	SET NOCOUNT OFF'

	EXEC(@SQL)
END
GO
PRINT N'Creando [dbo].[DeleteDictionaryWord]...';


GO
CREATE PROCEDURE [dbo].[DeleteDictionaryWord] (
	@VCC VARCHAR(50) = NULL, 
	@DictionaryWordId VARCHAR(50) = NULL
) AS
BEGIN
	-- ELIMINAMOS LA PALABRA DE LA TABLA DICTIONARY WORD
	DELETE FROM [dbo].[DictionaryWord] WHERE [VCC] = @VCC AND [ID] = @DictionaryWordId

	-- ELIMINAMOS LAS PALABRAS SOUND-LIKE DE LA TABLA DICTIONARY WORD SOUND LIKE
	DELETE FROM [dbo].[DictionaryWordSoundLike] WHERE [VCC] = @VCC AND [DictionaryWordId] = @DictionaryWordId

	SELECT 1 'result'
END
GO
PRINT N'Creando [dbo].[DeleteDictionaryWordSoundLike]...';


GO
CREATE PROCEDURE [dbo].[DeleteDictionaryWordSoundLike] (
	@VCC VARCHAR(50) = NULL, 
	@DictionaryWordId VARCHAR(50) = NULL,
	@DictionaryWordSoundLikeId VARCHAR(50) = NULL
) AS
BEGIN
	-- ELIMINAMOS LAS PALABRAS SOUND-LIKE DE LA TABLA DICTIONARY WORD SOUND LIKE
	DELETE FROM [dbo].[DictionaryWordSoundLike] WHERE [VCC] = @VCC AND [DictionaryWordId] = @DictionaryWordId AND [ID] = @DictionaryWordSoundLikeId

	SELECT 1 'result'
END
GO
PRINT N'Creando [dbo].[DeleteInteraction]...';


GO
CREATE PROCEDURE [dbo].[DeleteInteraction] (
	@VCC     VARCHAR(50)  = NULL,
	@ID      VARCHAR(250) = NULL,
	@IsAudio BIT          = 0
)
AS
BEGIN
	SET NOCOUNT ON
	
	IF(@IsAudio = 1) --ELIMINAR AUDIOS
		BEGIN
			 DELETE FROM [dbo].[Audio] WHERE [VCC] = @VCC AND [ID] = @ID
		END
    ELSE --ELIMINAR INTERACCIONES ASINCRONAS
		BEGIN
			DELETE FROM [dbo].[AsyncInteraction] WHERE [VCC] = @VCC AND [ID] = @ID
		END

    SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteProcessAsync]...';


GO
CREATE PROCEDURE [dbo].[DeleteProcessAsync] (
	@VCC        VARCHAR(50)  = NULL,
	@ProcessId  VARCHAR(50)  = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	DELETE FROM [dbo].[ProcessAsyncInteraction] WHERE [ProcessId] = @ProcessId

    SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetCleanerData]...';


GO


CREATE PROCEDURE [dbo].[GetCleanerData] (
@VCC VARCHAR(50),
@DAYS INT
)

AS
BEGIN
	SET NOCOUNT ON
      
				      --BUSCA REGISTROS PARA ELIMINARLOS DE LA BASE DE DATOS POR CADA VCC
				      
				
					   DECLARE @NOW VARCHAR(15) = CONVERT(VARCHAR,GETUTCDATE(),23)
				
					   CREATE TABLE #ProcessToDelete(
					   [Name] VARCHAR(50)
					   )
				       
				       CREATE TABLE #ProcessAsyncToDelete(
				       [ProcessId]  VARCHAR(50)
				       )
				       
				       DECLARE @FindInEvaluationPlan TABLE (
				        [Name] VARCHAR(50)
				       )
				       
				       DECLARE @FindInStudy TABLE (
				        [Name] VARCHAR(50)
				       )	
				       
					   DECLARE @EvaluationPlan TABLE(
					   [ID]      VARCHAR(50)
					   )
					   DECLARE @Study TABLE(
					   [Name]    VARCHAR(50)
					   )

					   CREATE TABLE #AudioToDelete(
					   [ID]       VARCHAR(100),
					   [FileName] VARCHAR(700)
					   )
					   
					   CREATE TABLE #AsyncInteractionToDelete(
					   [ID]       VARCHAR(250),
					   [FileName] VARCHAR(250),
					   [ViewFileName] VARCHAR(250)
					   )
					   
					 --BUSCAR PLANES
					 
					  INSERT INTO @EvaluationPlan
					  SELECT 
							[ID]
					  FROM  [dbo].[EvaluationPlan] (NOLOCK) 
					  WHERE [Instance] = @VCC 
							AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS

					--BUSCAR ESTUDIOS
					
					INSERT INTO @Study
					SELECT 
					    
						  [Name]
				    FROM  [dbo].[Study] (NOLOCK)
					WHERE [VCC] = @VCC
					      AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS
					      
					  
					--BUSCAR PROCESOS DE PLANES
					
			       INSERT INTO #ProcessToDelete 
				   SELECT 
					     P.[Name]
				   FROM  [dbo].[Process] P (NOLOCK) 
				   JOIN  [dbo].[EvaluationPlan] EP (NOLOCK)
				         ON (P.[VCC] = EP.[Instance] AND P.[Name] = EP.[ProcessId] )
				   WHERE P.[VCC] = @VCC 
				         AND EP.[ID] IN (SELECT [ID] FROM @EvaluationPlan)
				         
				         
				    --BUSCAR SI SE ESTA UTILIZANDO EN PLANES MAS RECIENTES
				    
				    INSERT INTO @FindInEvaluationPlan
				    SELECT 
				         DISTINCT [ProcessId]
				    FROM [dbo].[EvaluationPlan] (NOLOCK)
				    WHERE [Instance] = @VCC 
				          AND [ProcessId] IN (SELECT [Name] FROM #ProcessToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          
	

					--BUSCAR PROCESOS DE ESTUDIOS
					
			       INSERT INTO #ProcessToDelete 
				   SELECT 
					     P.[Name]
				   FROM  [dbo].[Process] P (NOLOCK) 
				   JOIN  [dbo].[Study] S (NOLOCK)
				         ON (P.[VCC] = S.[VCC] AND P.[Name] = S.[ProcessId] )
				   WHERE P.[VCC] = @VCC 
				         AND S.[Name] IN (SELECT [Name] FROM @Study)
				         

				    --BUSCAR SI SE ESTA UTILIZANDO EN ESTUDIOS MAS RECIENTES
				    
				    INSERT INTO @FindInStudy
				    SELECT 
				         DISTINCT [ProcessId]
				    FROM [dbo].[Study] (NOLOCK)
				    WHERE [VCC] = @VCC 
				          AND [ProcessId] IN (SELECT [Name] FROM #ProcessToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          
				     
				          
 					--BUSCAR PROCESOS QUE NO ESTEN ASIGNADOS
					
			       INSERT INTO #ProcessToDelete 
				   SELECT 
					     [Name]
				   FROM  [dbo].[Process] (NOLOCK) 
				   WHERE [VCC] = @VCC 
				         AND [Name] NOT IN (SELECT [Name] FROM #ProcessToDelete)
				         AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS
				         
				         
				    --ELIMINAR DE #ProcessToDelete LOS PROCESOS QUE SE ASIGNARON MAS DE UNA VEZ Y RECIENTEMENTE
				    
				     DELETE FROM #ProcessToDelete WHERE [Name] IN (SELECT [Name] FROM @FindInEvaluationPlan)
				     DELETE FROM #ProcessToDelete WHERE [Name] IN (SELECT [Name] FROM @FindInStudy)  
				     

                    --BUSCAR AUDIOS DE LOS PROCESOS QUE QUEDARON PARA SER ELIMINADOS
                    
                    INSERT INTO #AudioToDelete
                    SELECT A.[ID],A.[FileName] FROM [dbo].[Audio] A (NOLOCK)
                    JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
                    ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[AudioId])
                    WHERE A.[VCC] = @VCC 
                          AND  PA.[ProcessId] IN (SELECT [Name] FROM #ProcessToDelete)
                    
                    --BUSCAR Y QUITAR LOS AUDIOS QUE FUERON ASIGNADOS A UN NUEVO PROCESO
                    
                     DELETE FROM #AudioToDelete 
                     WHERE [ID] IN (
                     SELECT [ID] FROM [dbo].[Audio] A (NOLOCK) 
                     JOIN [dbo].[ProcessAudio] PA (NOLOCK)
                     ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[AudioId])
                     WHERE A.[VCC] = @VCC
                          AND  PA.[ProcessId] NOT IN (SELECT [Name] FROM #ProcessToDelete)
                          AND DATEDIFF(DAY,CONVERT(VARCHAR,PA.[CreatedDate],23),@NOW) <= @DAYS
                     )
                     
                     
                    --RESETEAR VARIABLES TEMPORALES PARA UTILIZARLAS CON PROCESOS ASINCRONOS
                    
                    DELETE FROM @FindInEvaluationPlan
                    DELETE FROM @FindInStudy
                    
                    
                    --BUSCAR PROCESOS ASINCRONOS DE PLANES
                     INSERT INTO #ProcessAsyncToDelete
                     SELECT 
					     P.[ProcessId]
				     FROM  [dbo].[ProcessAsyncInteraction] P (NOLOCK) 
				     JOIN  [dbo].[EvaluationPlan] EP (NOLOCK)
				         ON (P.[VCC] = EP.[Instance] AND P.[ProcessId] = EP.[ProcessId] )
				     WHERE P.[VCC] = @VCC 
				         AND EP.[ID] IN (SELECT [ID] FROM @EvaluationPlan)    
				         
				         
				    --BUSCAR PROCESOS ASINCRONOS SI SE ESTA UTILIZANDO EN PLANES MAS RECIENTES
				    
				    INSERT INTO @FindInEvaluationPlan
				    SELECT 
				         [ProcessId]
				    FROM  [dbo].[EvaluationPlan] (NOLOCK)
				    WHERE [Instance] = @VCC 
				          AND [ProcessId] IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          

					--BUSCAR PROCESOS ASINCRONOS DE ESTUDIOS
					
			       INSERT INTO #ProcessAsyncToDelete 
				   SELECT 
					     P.[ProcessId]
				   FROM  [dbo].[ProcessAsyncInteraction] P (NOLOCK) 
				   JOIN  [dbo].[Study] S (NOLOCK)
				         ON (P.[VCC] = S.[VCC] AND P.[ProcessId] = S.[ProcessId] )
				   WHERE P.[VCC] = @VCC 
				         AND S.[Name] IN (SELECT [Name] FROM @Study)
				         
				         
				    --BUSCAR PROCESOS ASINCRONOS SI SE ESTA UTILIZANDO EN ESTUDIOS MAS RECIENTES
				    
				    INSERT INTO @FindInStudy
				    SELECT 
				         DISTINCT [ProcessId]
				    FROM [dbo].[Study]  (NOLOCK)
				    WHERE [VCC] = @VCC 
				          AND [ProcessId] IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          
				     
 					--BUSCAR PROCESOS ASINCRONOS QUE NO ESTEN ASIGNADOS A PLANES NI ESTUDIOS
					
			       INSERT INTO #ProcessAsyncToDelete 
				   SELECT 
					     [ProcessId]
				   FROM  [dbo].[ProcessAsyncInteraction] (NOLOCK) 
				   WHERE [VCC] = @VCC 
				         AND [ProcessId] NOT IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
				         AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS
				         
				    --ELIMINAR DE #ProcessAsyncToDelete LOS PROCESOS QUE SE ASIGNARON MAS DE UNA VEZ Y RECIENTEMENTE
				    
				     DELETE FROM #ProcessAsyncToDelete WHERE [ProcessId] IN (SELECT [ProcessId] FROM @FindInEvaluationPlan)
				     DELETE FROM #ProcessAsyncToDelete WHERE [ProcessId] IN (SELECT [ProcessId] FROM @FindInStudy)  
				     

                    --BUSCAR INTERACCIONES ASINCRONAS DE LOS PROCESOS QUE QUEDARON PARA SER ELIMINADOS
                    
                    INSERT INTO #AsyncInteractionToDelete
                    SELECT 
                          A.[ID],
                          A.[FileName],
                          A.[ViewFileName]
                    FROM [dbo].[AsyncInteraction] A (NOLOCK)
                    JOIN [dbo].[ProcessAsyncInteraction] PA (NOLOCK) 
                    ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[InteractionId])
                    WHERE A.[VCC] = @VCC 
                          AND  PA.[ProcessId] IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
                    
                    --BUSCAR Y QUITAR LAS INTERACCIONES ASINCRONAS QUE FUERON ASIGNADAS A UN NUEVO PROCESO
                    
                     DELETE FROM #AsyncInteractionToDelete 
                     WHERE [ID] IN (
                     SELECT [ID] FROM [dbo].[AsyncInteraction] A (NOLOCK) 
                     JOIN [dbo].[ProcessAsyncInteraction] PA (NOLOCK)
                     ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[InteractionId])
                     WHERE A.[VCC] = @VCC
                          AND  PA.[ProcessId] NOT IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
                          AND DATEDIFF(DAY,CONVERT(VARCHAR,PA.[CreatedDate],23),@NOW) <= @DAYS
                     )
                     
                     
                    --LISTAR LOS RESULTADOS FINALES
                    
                    SELECT [ID] 'id'     FROM @EvaluationPlan
                    
                    SELECT [Name] 'name' FROM @Study
                  
					SELECT DISTINCT [Name] 'name' FROM #ProcessToDelete
					
					SELECT DISTINCT [ProcessId] 'processId' FROM #ProcessAsyncToDelete
					
					SELECT DISTINCT [ID] 'id',[FileName] 'fileName' FROM #AudioToDelete
					
					SELECT DISTINCT [ID] 'id',[FileName] 'fileName',[ViewFileName] 'viewFileName' FROM #AsyncInteractionToDelete
					
					
					--ELIMINAR LAS TABLAS TEMPORALES
					
					DROP TABLE #ProcessToDelete
					DROP TABLE #AudioToDelete
					DROP TABLE #ProcessAsyncToDelete
					DROP TABLE #AsyncInteractionToDelete
	  
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetDictionaries]...';


GO
CREATE PROCEDURE [dbo].[GetDictionaries] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT [Name]					'name',
			[Description]			'description',
			[Language]				'language',
			[CreatedDate]			'createdDate',
			[CreatedByUserId]		'createdByUserId',
			[LastModifiedDate]		'lastModifiedDate',
			[LastModifiedByUserId]	'lastModifiedByUserId'
		FROM [dbo].[Dictionary] (NOLOCK)
		WHERE [VCC] = @VCC
			AND ISNULL([Name], '') LIKE CASE WHEN @SearchCriteria = 'name' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetDictionary]...';


GO

create PROCEDURE [dbo].[GetDictionary] (
	@VCC					VARCHAR(50) = NULL,
	@DictionaryId			VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT [Name]					'name',
			[Description]			'description',
			[Language]				'language',
			[CreatedDate]			'createdDate',
			[CreatedByUserId]		'createdByUserId',
			[LastModifiedDate]		'lastModifiedDate',
			[LastModifiedByUserId]	'lastModifiedByUserId'
		FROM [dbo].[Dictionary] (NOLOCK)
		WHERE [VCC] = @VCC
			AND [Name] = @DictionaryId
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetDictionaryUsage]...';


GO
CREATE PROCEDURE [dbo].[GetDictionaryUsage]
(
	@VCC VARCHAR(50) = NULL,
	@DictionaryId VARCHAR(50)= NULL
)
AS
BEGIN
	SET NOCOUNT ON

	--
	SELECT [Name] 'processId'
		FROM [dbo].[Process] (NOLOCK)
		WHERE [VCC] = @VCC
			AND [DictionaryId] = @DictionaryId
			AND [Percentage] IS NOT NULL
			AND [Percentage] < 1
		ORDER BY [CreatedDate] DESC

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetDictionaryWord]...';


GO

CREATE PROCEDURE [dbo].[GetDictionaryWord] (
	@VCC VARCHAR(50) = NULL, 
	@DictionaryWordId VARCHAR(50) = NULL
) AS
BEGIN
	DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @FILTER           VARCHAR(MAX) = ''
	DECLARE  @ORDER_BY         VARCHAR(MAX) = ''
	
	SET NOCOUNT ON

	--
	SELECT [VCC]							'vcc',
			[DictionaryId]					'dictionaryId',
			[ID]							'id',
			[Word]							'word',
			[CreatedDate]					'createdDate',
			[CreatedByUserId]				'createdByUserId',
			[LastModifiedDate]				'lastModifiedDate',
			[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[DictionaryWord] (NOLOCK)
		WHERE [VCC] = @VCC
			AND [ID] = @DictionaryWordId
	
	SET NOCOUNT OFF

END
GO
PRINT N'Creando [dbo].[GetDictionaryWords]...';


GO
CREATE PROCEDURE [dbo].[GetDictionaryWords] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL,
	@DictionaryId VARCHAR(50) = NULL
) AS
BEGIN
	DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @FILTER           VARCHAR(MAX) = ''
	DECLARE  @ORDER_BY         VARCHAR(MAX) = ''
	
	SET NOCOUNT ON

	SET @SQL = '
	SELECT [VCC]							''vcc'',
			[DictionaryId]					''dictionaryId'',
			[ID]							''id'',
			[word]							''word'',
			[CreatedDate]					''createdDate'',
			[CreatedByUserId]				''createdByUserId'',
			[LastModifiedDate]				''lastModifiedDate'',
			[LastModifiedByUserId]			''lastModifiedByUserId''
		FROM [dbo].[DictionaryWord] (NOLOCK) ' 

	SET @FILTER = '
		WHERE [VCC] = ''' + @VCC + ''' 
			AND [DictionaryId] = ''' + @DictionaryId + ''' '

	IF (@SearchCriteria IS NOT NULL AND @SearchCriteria <> '' AND @SearchExpression IS NOT NULL AND @SearchExpression <> '')
	BEGIN 
	    SET @FILTER += '
			AND ISNULL([Word], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''word'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
	END

	SET @ORDER_BY = ' ORDER BY [LastModifiedDate] ASC, [Word] DESC'

	SET @SQL += @FILTER + @ORDER_BY
	SET NOCOUNT OFF

	EXEC(@SQL)

END
GO
PRINT N'Creando [dbo].[GetDictionaryWordSoundLikes]...';


GO
CREATE PROCEDURE [dbo].[GetDictionaryWordSoundLikes] (
	@VCC VARCHAR(50) = NULL, 
	@DictionaryWordIds VARCHAR(MAX) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ARMAR EL QUERY
	DECLARE  @SQL VARCHAR(MAX)

	SET @SQL = '
		SELECT [VCC]							''vcc'',
				[DictionaryWordId]				''dictionaryWordId'',
				[ID]							''id'',
				[SoundLike]						''soundLike'',
				[CreatedDate]					''createdDate'',
				[CreatedByUserId]				''createdByUserId'',
				[LastModifiedDate]				''lastModifiedDate'',
				[LastModifiedByUserId]			''lastModifiedByUserId''
			FROM [dbo].[DictionaryWordSoundLike] (NOLOCK)
			WHERE [VCC] = ''' + @VCC + '''
				AND [DictionaryWordId] IN (''' + @DictionaryWordIds + ''') ' 
	
	-- EJECUTAMOS EL QUERY ARMADO
	EXEC(@SQL)

	SET NOCOUNT OFF

END
GO
PRINT N'Creando [dbo].[GetVccCleanerConfig]...';


GO
CREATE PROCEDURE [dbo].[GetVccCleanerConfig]
AS
BEGIN
	SET NOCOUNT ON
	
	--OBTENER LA CONFIGURACION DE LOS VCC PARA ELIMINAR LA DATA
	
	SELECT 
	[VCC] 'vcc',
	[DeleteDataDays] 'deleteDataDays' 
	FROM [dbo].[VCC] (NOLOCK) 
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveCleanerSummary]...';


GO
CREATE PROCEDURE [dbo].[SaveCleanerSummary] (
@Task         VARCHAR(15),
@Status       BIT,
@Description  VARCHAR(250)
)
AS
BEGIN
	SET NOCOUNT ON
	
	INSERT INTO [dbo].[CleanerSummary]([Task],[Status],[Description],[CreatedAt]) VALUES(@Task,@Status,@Description,GETUTCDATE())
	
	SELECT 1 AS 'result'
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveDictionary]...';


GO
CREATE PROCEDURE [dbo].[SaveDictionary] (
	@VCC					VARCHAR(50) = NULL,
	@Name					VARCHAR(50) = NULL,
	@Description			VARCHAR(250) = NULL,
	@Language				VARCHAR(5) = NULL,
	@IsSystemDictionary		BIT = NULL,
	@SaveUser				VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
	
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INSERTAMOS LA NUEVO DICCIONARIO
	INSERT INTO [dbo].[Dictionary] (
			[VCC], [Name], [Description], [Language], [IsSystemDictionary], 
			[CreatedDate], [CreatedByUserId], [TimeStamp]
		)
		VALUES (
			@VCC, @Name, @Description, @Language, @IsSystemDictionary, 
			GETUTCDATE(), @SaveUser, GETUTCDATE()
		)
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveDictionaryWord]...';


GO

CREATE PROCEDURE [dbo].[SaveDictionaryWord] (
	@VCC					VARCHAR(50) = NULL,
	@DictionaryId			VARCHAR(50) = NULL,
	@ID						VARCHAR(50) = NULL,
	@Word					VARCHAR(50) = NULL,
	@SaveUser				VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
	
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- VERIFICAMOS SI EL ID EXISTE EN LOS PARAMETROS DE ENTRADA
		IF @ID IS NULL
		BEGIN
			-- VALIDAMOS SI LA PALABRA YA EXISTE EN LA TABLA
			IF EXISTS (
				SELECT * 
					FROM [dbo].[DictionaryWord] (NOLOCK) 
					WHERE [VCC] = @VCC 
						AND [DictionaryId] = @DictionaryId
						AND [Word] = @Word
			)
				RAISERROR('DATABASE_ERROR_DICTIONARY_WORD_ALREADY_EXISTS', 16, 16)

			-- VALIDAMOS SI EL DICCIONARIO A ALCANZO EL LIMITE DE 1000 PALABRAS
			IF 1000 <= (
				SELECT COUNT(*) 
					FROM [dbo].[DictionaryWord] (NOLOCK) 
					WHERE [VCC] = @VCC 
						AND [DictionaryId] = @DictionaryId
			)
				RAISERROR('DATABASE_ERROR_DICTIONARY_ALREADY_HAVE_1000_WORDS', 16, 16)
			
			-- INSERTAMOS LA NUEVA PALABRA
			INSERT INTO [dbo].[DictionaryWord] (
					[VCC], [DictionaryId], [ID], [Word], [CreatedDate], [CreatedByUserId], 
					[TimeStamp]
				)
				VALUES (
					@VCC, @DictionaryId, NEWID(), @Word, GETUTCDATE(), @SaveUser,
					GETUTCDATE()
				)
		END
		ELSE
		BEGIN
			-- ACTUALIZAMOS LA PALABRA POR EL ID
			UPDATE [dbo].[DictionaryWord]
				SET [Word] = @Word,
					[LastModifiedByUserId] = @SaveUser,
					[LastModifiedDate] = GETUTCDATE(),
					[TimeStamp] = GETUTCDATE()
				WHERE [VCC] = @VCC
					AND [DictionaryId] = @DictionaryId
					AND [ID] = @ID
		END
		
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveDictionaryWordSoundLike]...';


GO

CREATE PROCEDURE [dbo].[SaveDictionaryWordSoundLike] (
	@VCC					VARCHAR(50) = NULL,
	@DictionaryWordId		VARCHAR(50) = NULL,
	@ID						VARCHAR(50) = NULL,
	@SoundLike				VARCHAR(50) = NULL,
	@SaveUser				VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
	
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- VALIDAMOS SI LA PALABRA YA EXISTE EN LA TABLA
		IF EXISTS (
			SELECT * 
				FROM [dbo].[DictionaryWordSoundLike] (NOLOCK) 
				WHERE [VCC] = @VCC 
					AND [DictionaryWordId] = @DictionaryWordId
					AND [SoundLike] = @SoundLike
		)
			RAISERROR('DATABASE_ERROR_DICTIONARY_WORD_SOUND_LIKE_ALREADY_EXISTS', 16, 16)

		-- INSERTAMOS LA NUEVA PALABRA
		INSERT INTO [dbo].[DictionaryWordSoundLike] (
				[VCC], [DictionaryWordId], [ID], [SoundLike], [CreatedDate], [CreatedByUserId], 
				[TimeStamp]
			)
			VALUES (
				@VCC, @DictionaryWordId, NEWID(), @SoundLike, GETUTCDATE(), @SaveUser,
				GETUTCDATE()
			)
		
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
	
	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualizando [dbo].[DeleteProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteProcess]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[FinishedBatchClose]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[FinishedBatchClose]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudio]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Actualizando [dbo].[GetBatchDetail]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBatchDetail]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetProcessByStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessByStatus]';


GO
PRINT N'Actualizando [dbo].[GetProcessEvaluationPlanTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessEvaluationPlanTask]';


GO
PRINT N'Actualizando [dbo].[GetProcessUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessUsage]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[SaveBatchStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveBatchStatus]';


GO
PRINT N'Actualizando [dbo].[SaveProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveProcessStatus]';


GO
PRINT N'Actualizando [dbo].[DeleteVCC]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteVCC]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetVCCs]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetVCCs]';


GO
PRINT N'Actualizando [dbo].[UpdateVccStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[UpdateVccStatus]';


GO
PRINT N'Actualización completada.';


GO
