PRINT N'Altering Procedure [dbo].[DeleteUtterance]...';


GO
ALTER PROCEDURE [dbo].[DeleteUtterance] (
	@VCC			VARCHAR(50) = NULL,
	@AppId			VARCHAR(50) = NULL,
	@IntentId		VARCHAR(50) = NULL,
	@Id				VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
    -- DECLARE @ENGINE VARCHAR(15)  = (SELECT [CognitiveEngine] FROM [dbo].[VCC] (NOLOCK) WHERE [VCC] = @VCC)
	-- DECLARE @ID     VARCHAR(50) = @UtteranceId
	-- DECLARE @TempId VARCHAR(50) = NULL
	DECLARE @CognitiveEngine  varchar(50)
	SELECT @CognitiveEngine = CognitiveEngine FROM VCC WHERE VCC = @VCC
	IF @CognitiveEngine = 'LUIS' OR @CognitiveEngine ='RASA'
	SELECT @IntentId = IntentId from [dbo].[Intent] WHERE [Name] = @IntentId and [VCC] = @VCC and [AppId] = @AppId

	DELETE [Utterance] 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @IntentId
			AND [Id] = @Id
	
	DELETE [UtteranceEntity] 
		WHERE [VCC] = @VCC
			AND [UtteranceId] = @Id
			
			
	DELETE FROM [dbo].[Underlined] WHERE [VCC] = @VCC AND [UtteranceId] = @Id

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[GetBillingInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetBillingInteractions] (
	@VCC					VARCHAR(50) = NULL,
	@SecondsPerRequest		DECIMAL(18, 5) = 0,
	@CharsPerPhrase			DECIMAL(18, 5) = 0,
	@Channel				VARCHAR(25) = NULL,
	@Retranscription		BIT = 0
	
)
AS
BEGIN
	
	-- SEGUN EL TIPO DE CANAL DEFINIMOS LA FUNCION
	IF @Channel = 'CALL'
	BEGIN
		SELECT SUM(CASE WHEN A.[IsTranscribed] = 1 AND @Retranscription = 0 THEN 1 ELSE 0 END)									'alreadyTranscribedAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 AND @Retranscription = 0 THEN IT.[AttentionTime] ELSE 0 END)					'alreadyTranscribedDurationTime',
				SUM(CASE WHEN (A.[IsProcess] = 1 
								AND A.[IsTranscribed] IS NULL 
								AND A.[IsCancel] IS NULL) 
							THEN 1 ELSE 0 END)															'inProcessAudio',
				SUM(CASE WHEN (A.[IsProcess] = 1 
								AND A.[IsTranscribed] IS NULL 
								AND A.[IsCancel] IS NULL) 
							THEN IT.[AttentionTime] ELSE 0 END)											'inProcessDurationTime',
				@Channel																				'interactionType',
				SUM(CASE WHEN (A.[IsProcess] IS NULL 
								OR @Retranscription = 1
									OR (A.[IsProcess] = 1 
									AND A.[IsCancel] = 1)) 
							THEN 1 ELSE 0 END)															'notTranscribedAudio',
				SUM(CASE WHEN (A.[IsProcess] IS NULL  
								OR @Retranscription = 1
									OR (A.[IsProcess] = 1 
									AND A.[IsCancel] = 1)) 
							THEN IT.[AttentionTime] ELSE 0 END)											'notTranscribedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1  
								AND A.[TotalPhrases] IS NOT NULL
							THEN A.[TotalPhrases] ELSE 0 END)											'totalPhrases',
				SUM(CASE WHEN (A.[IsProcess] IS NULL 
								OR (A.[IsProcess] = 1 
									AND A.[IsCancel] = 1)
								OR (A.[TotalPhrases] IS NULL)) 
							THEN (IT.[AttentionTime] / @SecondsPerRequest) ELSE 0 END)					'totalRawPhrases',
				SUM(IT.[AttentionTime] / @SecondsPerRequest)											'averageModelRequest' 
			FROM [#InteractionsTemp] IT
			LEFT JOIN [dbo].[Audio] A (NOLOCK) 
				ON A.[VCC] = IT.[VCC]
					AND A.[ID] = IT.[InteractionId]
					AND A.[Section] = IT.[Section]
					AND A.[Part] = IT.[Part] 
			WHERE IT.[VCC] = @VCC
	END
	ELSE
	BEGIN
		-- DECLARAMOS UNA VARIABLE PARA PARA EL TOTALDE RESULTADOS
		DECLARE @TOTAL_INTERACTIONS INT = 0

		-- SETTEAMOS EL NUMERO DE REGISTROS A LA VARIABLE DE TOTAL
		SELECT @TOTAL_INTERACTIONS = COUNT(*) FROM [#InteractionsTemp]

		IF @TOTAL_INTERACTIONS = 0 
		BEGIN
			-- SI NO EXISTEN RESULTADOS EN HD LLENAMOSUN RESULTADOS CON 0
			SELECT @Channel																					'interactionType',
					0																						'totalInteractionDetails',
					0																						'alreadyTranscribedInteraction',
					0																						'inProcessInteraction',
					0																						'notTranscribedInteraction',
					0																						'totalPhrases',
					0																						'totalRawChars',
					0																						'totalRawPhrases'
		END 
		ELSE
		BEGIN
			-- CRUZAMOS LA TABLA TEMPORAL DE INTERACCIONES ASINCRONAS CON LA TABLA LOCAL INTERACTION PARA LAS INTERACCIONES ASINCRONAS YA REGISTRADAS
			SELECT ISNULL(IT.[Channel], @Channel)															'interactionType',
					COUNT(*)																				'totalInteractionDetails',
					SUM(CASE WHEN (AI.[VCC] IS NOT NULL 
						AND AI.[IsTranscribed] = 1) THEN 1 ELSE 0 END)				'alreadyTranscribedInteraction',
					0																						'inProcessInteraction',
					SUM(CASE WHEN (AI.[VCC] IS NULL 
						OR AI.[IsTranscribed] <> 1) THEN 1 ELSE 0 END)										'notTranscribedInteraction',
					SUM(ISNULL(AI.[TotalPhrases], 0))														'totalPhrases',
					-- CUANDO TENEMOS VALIDPHRASES, YA NO CONTAMOS LAS RAWCHAR 
					SUM(
						CASE WHEN (AI.[TotalPhrases] IS NULL 
								OR AI.[TotalPhrases] = 0)
						THEN (
							ISNULL(AI.[RawChar], ISNULL(IT.[rawChar], 0))
						)
						ELSE 0 END
					)																						'totalRawChars',
					SUM(
						CASE WHEN (AI.[TotalPhrases] IS NULL 
								OR AI.[TotalPhrases] = 0)
						THEN (
							-- SI RAWCHAR ES NULL, SE DEBE VALUAR COMO MINIMO 1 FRASE(@CharsPerPhrase)
							-- CEILING(ISNULL(AI.[RawChar], ISNULL(HDI.[rawChar], @CharsPerPhrase)) * 1.00 / @CharsPerPhrase)
							CEILING(ISNULL(AI.[RawChar], ISNULL(IT.[RawChar], 0)) * 1.00 / @CharsPerPhrase)
						)
						ELSE 0 END
					)																						'totalRawPhrases' 
				FROM [#InteractionsTemp] IT
				LEFT JOIN [dbo].[AsyncInteraction] AI 
					ON IT.[VCC] = AI.[VCC]
						AND IT.[Channel] = AI.[Channel]
						AND IT.[Campaign] = AI.[Campaign]
						AND IT.[InteractionId] = AI.[ID]
						AND IT.[EndDate] = AI.[EndDate]
					--WHERE AI.[VCC] = @VCC
				GROUP BY IT.[VCC],
							IT.[Channel]

		END
	END

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [#InteractionsTemp] 
END
GO
PRINT N'Creating Procedure [dbo].[GetCognitiveInteractionIntents]...';


GO
CREATE PROCEDURE [dbo].[GetCognitiveInteractionIntents]
(
@IdInteraction VARCHAR(100),
@Section VARCHAR(50),
@Part VARCHAR(50),
@Vcc VARCHAR(50),
@TypeProcessResult VARCHAR(50),
@ProcessResult VARCHAR(50)
)
AS
BEGIN

	IF (@TypeProcessResult = 'EvaluationPlan')
	BEGIN
		SELECT DISTINCT
		I.[VCC]					'vcc',
		I.[Name]				'intentName',
		I.[IntentId]			'intentId',
		I.[AppId]				'appId',
		N.[CognitiveEngine]		'cognitiveEngine',
		N.[name]				'modelName'

		FROM InteractionEvaluationPlan  IEP 
		INNER JOIN EvaluationResult ER ON IEP.Instance = ER.Instance AND IEP.IdInteraction = ER.IdInteraction
		INNER JOIN EvaluationPlan EP ON IEP.IdEvaluationPlan = EP.ID
		INNER JOIN EvaluationFormat EF ON EP.IdEvaluationFormat = EF.ID
		INNER JOIN AbilityEvaluationFormat AEF ON EF.ID = AEF.IdEvaluationFormat
		INNER JOIN AbilityQuery AQ ON AEF.IdAbility = AQ.AbilityId
		INNER JOIN Intent I ON AQ.QueryId = I.IntentId
		INNER JOIN NLU N ON I.AppId = N.AppId

		WHERE IEP.IdInteraction = @IdInteraction and
		IEP.InteractionSection =  @Section and
		IEP.InteractionPart = @Part and 
		IEP.instance = @Vcc and 
		IEP.IdEvaluationPlan = @ProcessResult

	END

	ELSE --Es un estudio
	BEGIN
	SELECT DISTINCT	
	            TTI.[VCC]											'vcc',	
				NI.[Name]											'intentName',
				NI.[intentId]										'intentId',
				TTI.[VCC]+'::'+ NI.[nluId]							'appId',			
				NI.[cognitiveEngine]								'cognitiveEngine',
				NI.[nluId]											'modelName'	
				
				FROM StudyResultSummary SR 
				INNER JOIN StudyResultSummaryDetail SRD ON SR.StudyId =SRD.StudyId
				INNER JOIN TemplateTheme TT ON SR.TemplateId = TT.TemplateId
				INNER JOIN TemplateThemeItem TTI ON TT.TemplateId = TTI.TemplateId
				INNER JOIN (
				SELECT DISTINCT
						INNER_N.[VCC]								'vcc'
						,INNER_N.[Name] + '|'+ INNER_I.[Name]		'cognitiveId'
						,INNER_N.[Name]								'nluId'
						,INNER_N.[AppId]							'appId'
						,INNER_I.[IntentId]							'intentId'
						,INNER_I.[Name]
						,INNER_N.[CognitiveEngine]					'cognitiveEngine'	

					FROM [dbo].[NLU] INNER_N (NOLOCK)
					INNER JOIN [dbo].[Intent] INNER_I (NOLOCK) 
					ON INNER_N.[VCC] = INNER_I.[VCC]
							AND INNER_N.AppId = INNER_I.[AppId] 
					WHERE INNER_N.[VCC] = @Vcc
				) NI ON NI.[vcc] = TT.[VCC] AND NI.[cognitiveId] = TTI.[ID]
				WHERE 
				SR.StudyId = @ProcessResult AND
				SR.VCC = @Vcc AND
				SRD.TranscriptionId = @IdInteraction +'_'+@Section+'_'+@part	
		
	END

END
GO
PRINT N'Update complete.';


GO
