
GO
PRINT N'Altering SqlProcedure [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN

INSERT INTO [Progress] ([Key]
    ,[VCC]
    ,[ProcessId]
    ,[Type]
    ,[TypeId]
    ,[Total]
    ,[Progress]
    ,[Error]
    ,[Percentage]
    ,[StatusDescription])
SELECT [Key]
        ,[VCC]
        ,[ProcessId]
        ,[Type]
        ,[TypeId]
        ,[Total]
        ,[Progress]
        ,[Error]
        ,[Percentage]
        ,[StatusDescription]
FROM [dbo].[#ProgressTemp]

-----------ESTADOS DE PROCESS I6UPDATE-----------

-- ACTUALIZAMOS EL ESTADO GENERAL DE PROCESS SOBRE LA ACTUALIZACION DE INTERACCIONES CALL I6
UPDATE P
SET [Total] = PT.[Total]
        ,[progress] = PT.[Progress]
        ,[error] = PT.[Error]
        ,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR'
										WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) = 0 THEN 'COMPLETED'
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P
		INNER JOIN [dbo].[#ProgressTemp] PT
			ON P.[vcc] = PT.[vcc]
				AND PT.ProcessId = P.[Name]
		WHERE PT.[Type] = 'i6update'

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
UPDATE A
SET [Status] = CASE
    WHEN B.total >= 0 AND B.total <= B.[updated] + B.cancel AND B.cancel > B.[updated] THEN 'FAILED'
    WHEN B.total >= 0 AND B.total <= B.[updated] + B.cancel THEN 'COMPLETE'
    ELSE 'INPROCESS_I6_UPDATE'
END
,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] AS A
		INNER JOIN (
			SELECT SUM(UT.total)									'total',
					SUM(UT.cancel)									'cancel',
					SUM(UT.[updated])								'updated',
					UT.processId									'processId',
					UT.vcc											'vcc'
				FROM (
					SELECT COUNT(1)										'total'
							,COUNT(A.[isCancel])						'cancel'
							,COUNT(IIF(A.[NeedI6Update] = 0, 1, 0))		'updated'
							,PT.[ProcessId]								'processId'
							,PT.[vcc]									'vcc'
						FROM [dbo].[ProcessAudio] PA (NOLOCK)
						INNER JOIN [#ProgressTemp] PT
							ON PA.[vcc] = PT.[vcc]
								AND PA.ProcessId = PT.ProcessId
								AND PT.[Percentage] = 1
						INNER JOIN [dbo].[Audio] A (NOLOCK)
							ON PA.[VCC] = A.VCC
								AND PA.[AudioId] = A.ID
						WHERE PT.[Type] = 'i6update'
						GROUP BY PT.ProcessId, PT.vcc
				) UT
				GROUP BY UT.processId, UT.vcc
		) B ON A.[vcc] = B.[vcc]
			AND A.[Name] = B.[ProcessId]

	------------ESTADOS DE PROCESS ---------------
UPDATE A
SET [Total] = PT.[Total]
        ,[progress] = PT.[Progress]
        ,[error] = PT.[Error]
        ,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR'
										WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) = 0 THEN 'COMPLETED'
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM Process AS A
		INNER JOIN [dbo].[#ProgressTemp] PT
			ON A.[vcc] = PT.[vcc]
				AND A.[Name] = PT.ProcessId
		WHERE PT.[Type] IS NULL

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
UPDATE A
SET [Status] = CASE
    WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED'
    WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE'
    ELSE 'INPROCESS_TRANSCRIPTION'
END
,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT ISNULL(SUM(UT.total), 0)					'total',
				ISNULL(SUM(UT.cancel), 0)				'cancel',
				ISNULL(SUM(UT.transcription), 0)		'transcription',
				UT.processId							'processId',
				UT.vcc									'vcc'
			FROM (
			SELECT COUNT(1)					total
					,COUNT(C.isCancel)			cancel
					,COUNT(C.IsTranscribed)		transcription
					,B.ProcessId				processId
					,B.vcc						vcc
				FROM [ProcessAudio] A (NOLOCK)
				INNER JOIN [#ProgressTemp] B
					ON A.[vcc] = B.[vcc]
						AND A.ProcessId = B.ProcessId
						-- AND B.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN Audio C (NOLOCK)
					ON A.VCC = C.VCC
						AND A.AudioId =C.ID
						AND ISNULL(A.Section,0) = ISNULL(C.Section,0)
						AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
				WHERE B.[Type] IS NULL
				GROUP BY B.ProcessId, B.vcc
			UNION
			SELECT
				COUNT(1)						total
				,COUNT(AI.IsCancel)			cancel
				,COUNT(AI.IsTranscribed)		transcription
				,PT.[ProcessId]				processId
				,PT.[vcc]						vcc
				FROM [ProcessAsyncInteraction] PAI (NOLOCK)
				INNER JOIN [#ProgressTemp] PT
					ON PAI.[VCC] = PT.[vcc]
						AND PAI.[ProcessId] = PT.[ProcessId]
						-- AND PT.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN [AsyncInteraction] AI (NOLOCK)
					ON AI.[VCC] = PT.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE PT.[Type] IS NULL
				GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc]
		AND A.[Name] = B.ProcessId

	-- ACTUALIZAMOS EL ESTADO DE OTROS PROCESOS QUE ESTAN COMO FALLIDOS, COLGADOS, ETC QUE COINCIDEN CON LAS INTERACCIONES DEL PROCESS TERMINADO
UPDATE P
SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
                      ELSE 'COMPLETE' END,
    P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR'
                                 ELSE 'COMPLETED' END,
    P.[Percentage] = 1
        ,P.[LastModifiedDate] = GETUTCDATE()
    FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK)
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
							ON PA.[VCC] = P.[VCC]
								AND PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK)
							ON A.[VCC] = PA.[VCC]
								AND A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR
							(P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]

					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK)
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK)
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR
							(P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
ON TMPP.[processId] = P.[Name]
    AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


    -- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
    -- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
FROM [#ProgressTemp] PTMP
    INNER JOIN [dbo].[Process] P
ON P.[vcc] = PTMP.[vcc]
    AND P.[Name] = PTMP.[ProcessId]
    AND PTMP.[Type] IS NULL
WHERE PTMP.[Percentage] = 1
  AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION

-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
SELECT PTMP.[vcc],
       NEWID(),
       BS.[Id],
       PTMP.[ProcessId],
       GETUTCDATE(),
       'PENDING',
       'system',
       GETUTCDATE(),
       GETUTCDATE()
FROM [#ProgressTemp] PTMP
    LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
ON BS.[VCC] = PTMP.[vcc]
WHERE PTMP.[Percentage] = 1
  AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION
  AND BS.[BatchType] = 'TEMPLATE'
  AND GETUTCDATE() >= BS.[StartDate]
  AND (
    BS.[EndDate] IS NULL
   OR
    GETUTCDATE() < BS.[EndDate]
    )

------------ESTADOS DE ESTUDIOS --------------
UPDATE A
SET [Total] = B.[Total]
        ,[progress] = B.[Progress]
        ,[error] = B.[Error]
        ,[percentage] = B.[Percentage]
        ,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR'
    WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED'
    ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR'
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED'
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B
			ON A.[vcc] = B.[vcc]
				AND A.[ProcessId] = B.ProcessId
				AND A.[Name] = B.[TypeId]
				AND B.[Type] IN ('study', 'template')

	--Eliminar StudyResultSummary
	         DELETE SRS FROM [dbo].[StudyResultSummary] SRS
	                    JOIN [dbo].[Study]  S
	                         ON
	                        (S.[VCC] = SRS.[VCC]
	                       AND S.[Name] = SRS.[StudyId]
	                       AND S.[TemplateId] = SRS.[TemplateId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRS.[TemplateThemeId])
	                   JOIN [dbo].[#ProgressTemp] PT
	                        ON
	                       (S.[VCC] = PT.[vcc]
							AND S.[ProcessId] = PT.ProcessId
							AND S.[Name] = PT.[TypeId]
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1
	                   WHERE SRS.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)


	 -- Eliminar StudyResultSummaryDetail
	           	  DELETE SRSD FROM [dbo].[StudyResultSummaryDetail] SRSD
	                    JOIN [dbo].[Study]  S
	                         ON
	                        (S.[VCC] = SRSD.[VCC]
	                       AND S.[Name] = SRSD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRSD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SRSD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT
	                        ON
	                       (S.[VCC] = PT.[vcc]
							AND S.[ProcessId] = PT.ProcessId
							AND S.[Name] = PT.[TypeId]
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1
	                   WHERE SRSD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)

   	 -- Eliminar StudyResultSummaryDetail
	           	  DELETE SD FROM [dbo].[StudyDetail] SD
	                    JOIN [dbo].[Study]  S
	                         ON
	                        (S.[VCC] = SD.[VCC]
	                       AND S.[Name] = SD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT
	                        ON
	                       (S.[VCC] = PT.[vcc]
							AND S.[ProcessId] = PT.[ProcessId]
							AND S.[Name] = PT.[TypeId]
							AND PT.[Type] IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1
	                   WHERE SD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
SELECT PTMP.[vcc], UPPER(PTMP.[Type]), PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
FROM [#ProgressTemp] PTMP
    INNER JOIN [dbo].[Study] S
ON S.[vcc] = PTMP.[vcc]
    AND S.[ProcessId] = PTMP.[ProcessId]
    AND S.[Name] = PTMP.[TypeId]
    AND PTMP.[Type] IN ('study', 'template')
WHERE PTMP.[Percentage] = 1
  AND PTMP.[Type] IN ('study', 'template')

-- ACTUALIZAMOS LA EJECUCION RELACIONADA AL BATCH TEMPLATE TERMINADO
UPDATE BSE
SET BSE.[Status] = 'FINISHED',
    BSE.[LastModifiedByUserId] = 'system',
    BSE.[LastModifiedDate] = GETUTCDATE()
    FROM [#ProgressTemp] PTMP
		INNER JOIN [dbo].[BatchScheduleExecution] BSE
ON BSE.[vcc] = PTMP.[vcc]
    AND BSE.[BatchId] = PTMP.[TypeId]
WHERE PTMP.[Percentage] = 1
  AND PTMP.[Type] = 'template'

------------Estados de plan de evaluacion --------------

-- UPDATE PARA LA PARTE DE TRANSCRIPCION
UPDATE A
SET [Total] = B.[Total]
        ,[progress] = B.[Progress]
        ,[error] = B.[Error]
        ,[percentage] = B.[Percentage]
        ,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR'
    WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED'
    ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B
		ON A.[Instance] = B.[vcc]
			AND A.[ProcessId] = B.ProcessId
			AND B.[Type] IS NULL
			AND A.[FilterByContentQueryName] IS NOT NULL
			AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
UPDATE A
SET [Total] = B.[Total]
        ,[progress] = B.[Progress]
        ,[error] = B.[Error]
        ,[percentage] = B.[Percentage]
        ,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR'
    WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED'
    ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B
		ON A.[Instance] = B.[vcc]
			AND A.[ProcessId] = B.ProcessId
			AND A.Id = B.[TypeId]
			AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
UPDATE A
SET [Total] = B.[Total]
        ,[progress] = B.[Progress]
        ,[error] = B.[Error]
        ,[percentage] = B.[Percentage]
        ,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR'
    WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED'
    ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc]
	AND A.[ProcessId] = B.ProcessId
	AND B.[Type] IS NULL
	AND A.[FilterByContentQueryName] IS NULL
	AND A.[FilterByContentQuery] IS NULL
	AND (
		A.[Evaluation_Mode] = 'A'
		OR
		A.[Evaluation_Mode] = 'X'
	)

	--OBTENGO ESTADOS DE PROCESO DE AUDIOS
	;WITH AudioStatus AS (
    SELECT	D.[VCC]									'instance',
            D.[ProcessId]							'processId',
            COUNT(*) 								'total',
            SUM(IIF(A.[IsTranscribed] = 1, 1, 0))	'transcribed',
            SUM(IIF(A.[IsCancel] = 1, 1, 0))			'cancelled'


    FROM [dbo].[Audio] A
                                                                                                INNER JOIN [dbo].[InteractionEvaluationPlan] B
     ON A.[ID] = B.[IdInteraction]
                                                                                                AND A.[Section] = B.[InteractionSection]
                                                                                                AND A.[Part] = B.InteractionPart
                                                                                                INNER JOIN [dbo].[EvaluationPlan] C
                                                                                                ON C.[Instance] = B.[Instance]
                                                                                                AND C.[ID] = B.[IdEvaluationPlan]
                                                                                                INNER JOIN [dbo].[#ProgressTemp] D
                                                                                                ON D.[vcc] = C.[Instance]
                                                                                                AND D.[ProcessId] = C.ProcessId
                                                                                                AND  D.[TypeId] = C.Id
                                                                                                AND D.[Type] = 'ability'
     GROUP BY D.[VCC], D.[ProcessId]
                                                                                                )

-- ACTUALIZAMOS EL ESTADO DE LOS PLANES DE LA TABLA TEMPORAL
UPDATE A
SET [Total] = B.[Total]
        ,[progress] = B.[Progress]
        ,[error] = B.[Error]
        ,[percentage] = B.[Percentage]
        ,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND ISNULL(B.[Error],0) = 0 AND ISNULL(B.[Total], 0) > 0 AND ISNULL(C.[cancelled], 0) = 0 THEN 'COMPLETED'
    WHEN B.[Percentage] = 1 AND (ISNULL(B.[Error],0) = 0 AND ISNULL(B.[Total], 0) = 0 OR (ISNULL(C.[total], 0) > 0 AND ISNULL(C.[cancelled], 0) > C.[total]/2)) THEN 'CANCELLED_BY_FAILED_PROCESS'
    WHEN B.[Percentage] = 1 AND (ISNULL(B.[Error],0) > 0 OR (ISNULL(C.[total], 0) > 0 AND ISNULL(C.[cancelled], 0) > 0)) THEN 'COMPLETED_WITH_ERROR'
    ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 AND ISNULL(B.[Error],0) = 0 AND ISNULL(B.[Total], 0) > 0 THEN 7
		    WHEN B.[Percentage] = 1 AND ISNULL(B.[Error],0) = 0 AND ISNULL(B.[Total], 0) = 0 THEN 10
		    WHEN B.[Percentage] = 1 AND ISNULL(B.[Error],0) > 0 THEN  9
		    ELSE 6 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B
		ON A.[Instance] = B.[vcc]
			AND A.[ProcessId] = B.[ProcessId]
			AND A.Id = B.[TypeId]
			AND B.[Type] = 'ability'
	LEFT JOIN [AudioStatus] C
		ON C.[instance] = B.[vcc]
			AND C.[processId] = B.[ProcessId]


	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
UPDATE AEP
SET AEP.[Completed] = 1
  ,[StatusDescription] = 'COMPLETED'
  ,[LastModifiedDate] = GETUTCDATE()
FROM dbo.[AuditorEvaluationPlan] AEP
    INNER JOIN dbo.[EvaluationPlan] EP
ON EP.[ID] = AEP.[IdEvaluationPlan]
    INNER JOIN [dbo].[#ProgressTemp] B
    ON EP.[Instance] = B.[vcc]
    AND EP.[ProcessId] = B.ProcessId
    AND EP.Id = B.[TypeId]
    AND B.[Type] = 'ability'
WHERE EP.[Status] = 7
  AND AEP.[IdAuditor] = 'SPEECH'
  AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X')

-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
FROM [#ProgressTemp] PTMP
    INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
ON EP.[Instance] = PTMP.[vcc]
    AND EP.[ProcessId] = PTMP.[ProcessId]
    AND EP.[Id] = PTMP.[TypeId]
    AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
WHERE PTMP.[Percentage] = 1
  AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
SELECT PTMP.[vcc],
       NEWID(),
       BS.[Id],
       PTMP.[ProcessId],
       GETUTCDATE(),
       'PENDING',
       'system',
       GETUTCDATE(),
       GETUTCDATE()
FROM [#ProgressTemp] PTMP
    LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
ON BS.[VCC] = PTMP.[vcc]
WHERE PTMP.[Percentage] = 1
  AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan') -- EL NULL INDICA QUE ES PROCESS DE PLAN DE EVALUACION
  AND BS.[BatchType] = 'TEMPLATE'
  AND GETUTCDATE() >= BS.[StartDate]
  AND (
    BS.[EndDate] IS NULL
   OR
    GETUTCDATE() < BS.[EndDate]
    )

-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
DECLARE MY_CURSOR CURSOR
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL
		FOR
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
SELECT PTMP.[vcc] 'VCC',
        PTMP.[TypeId] 'EVALUATION_PLAN_ID'
FROM [#ProgressTemp] PTMP
    INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
ON EP.[Instance] = PTMP.[vcc]
    AND EP.[ProcessId] = PTMP.[ProcessId]
    AND EP.[Id] = PTMP.[TypeId]
    AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
WHERE PTMP.[Percentage] = 1
  AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
BEGIN
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1
				FROM [dbo].[EvaluationResult] ER (NOLOCK)
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
UPDATE AEP
SET AEP.[Completed] = '1'
  ,AEP.[StatusDescription] = 'COMPLETED'
  ,AEP.[LastModifiedDate] = GETUTCDATE()
    FROM AuditorEvaluationPlan AEP (NOLOCK)
WHERE AEP.[Instance] = @CURRENT_VCC
  AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
END

FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
END
CLOSE MY_CURSOR
    DEALLOCATE MY_CURSOR
-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE AUTOMATICA(ESTADO 7), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL REGRESA AL ESTADO 7)

DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR_2 CURSOR
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL
		FOR
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
SELECT DISTINCT
    PT.[vcc]								'VCC',
        PT.[TypeId]								'EVALUATION_PLAN_ID',
        EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
    INNER JOIN [dbo].[#ProgressTemp] PT
ON EP.[Instance] = PT.[vcc]
    AND EP.[ProcessId] = PT.[ProcessId]
    AND EP.[Id] = PT.[TypeId]
    AND PT.[Type] = 'ability'
    INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
    ON EF.[Instance] = EP.[Instance]
    AND EF.[ID] = EP.[IdEvaluationFormat]
WHERE EP.[Status] = 7
  AND EP.[Evaluation_Mode] = 'X'

-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
    OPEN MY_CURSOR_2
    FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
    WHILE @@FETCH_STATUS = 0
BEGIN
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
UPDATE EP
SET EP.[percentage] = 0
  ,EP.[StatusDescription] = 'IN_PROGRESS'
  ,EP.[Status] = 8
  ,EP.[LastModifiedDate] = GETUTCDATE()
    FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
WHERE EP.[Instance] = @CURRENT_VCC
  AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
DECLARE MY_AUDITOR_CURSOR CURSOR
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL
				FOR
				-- CONSULTAMOS LOS ID DE AUDITORES
SELECT DISTINCT AEP.[IdAuditor]
FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
WHERE  AEP.[Instance] = @CURRENT_VCC
  AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND AEP.[IdAuditor] <> 'SPEECH'

-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
    OPEN MY_AUDITOR_CURSOR
    FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
    WHILE @@FETCH_STATUS = 0
BEGIN
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
INSERT INTO [dbo].[EvaluationResult] (
    [Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
    [MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
    [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
    [CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], [CampaignDescription],
    [AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], [AbilityOrder],
    [InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
)
-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
       ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
       ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], ER.[CreatedDate],
       ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], ER.[CampaignDescription],
       ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], ER.[AbilityOrder],
       ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
FROM [dbo].[EvaluationResult] ER (NOLOCK)
    INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
ON AEP.[Instance] = ER.[Instance]
    AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
    AND AEP.[IdAuditor] = ER.[IdAuditor]
    AND AEP.[IdInteraction] = ER.[IdInteraction]
    AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
WHERE ER.[Instance] = @CURRENT_VCC
  AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND ER.[IdAuditor] = 'SPEECH'

-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
UPDATE [dbo].[AuditorEvaluationPlan]
SET [Completed] = 0,
    [AutomaticScore] = [Score],
    [ManualScore] = 0,
    [StatusDescription] = 'NEW',
    [LastModifiedDate] = GETUTCDATE(),
    [TimeStamp] = GETUTCDATE()
WHERE [Instance] = @CURRENT_VCC
  AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND [IdAuditor] = @CURRENT_AUDITOR_ID

    FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
END
CLOSE MY_AUDITOR_CURSOR
    DEALLOCATE MY_AUDITOR_CURSOR

-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
DELETE
FROM [dbo].[AuditorEvaluationPlan]
WHERE [Instance] = @CURRENT_VCC
  AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND [IdAuditor] = 'SPEECH'
  AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
DELETE
FROM [dbo].[AuditorEvaluationPlan]
WHERE [Instance] = @CURRENT_VCC
  AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND [IdAuditor] <> 'SPEECH'
  AND [IdInteraction] IN (
    SELECT [IdInteraction]
    FROM [dbo].[AuditorEvaluationPlan]
    WHERE [Instance] = @CURRENT_VCC
  AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND [IdAuditor] = 'SPEECH'
  AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
    )

-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
UPDATE [dbo].[AuditorEvaluationPlan]
SET [AutomaticScore] = [Score],
    [ManualScore] = 0,
    [LastModifiedDate] = GETUTCDATE(),
    [TimeStamp] = GETUTCDATE()
WHERE [Instance] = @CURRENT_VCC
  AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND [IdAuditor] = 'SPEECH'

END
ELSE
BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
DELETE FROM [dbo].[AuditorEvaluationPlan]
WHERE  [Instance] = @CURRENT_VCC
  AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
  AND [IdAuditor] <> 'SPEECH'

-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

END

FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
END
CLOSE MY_CURSOR_2
    DEALLOCATE MY_CURSOR_2

-- INVALIDAR LAS AUDITORIAS CUYO AUDIO PRESENTAN ALGUN ERROR
UPDATE AEP
SET AEP.[StatusDescription] = 'INVALID'
    FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		JOIN [dbo].[Audio] A (NOLOCK)
ON AEP.[Instance] = A.[VCC]
    AND AEP.[IdInteraction] = A.[ID]
    JOIN [#ProgressTemp] PTMP (NOLOCK)
    ON AEP.[Instance] = PTMP.[vcc]
    AND AEP.[IdEvaluationPlan] = PTMP.[TypeId]
WHERE (A.[IsTranscribed] IS NULL OR A.[IsTranscribed]  <> 1)
  AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
-- AND A.[ErrorMessage] IN ('GET_AUDIO_REQUEST_FAILED','JSON_IDATHA_IS_NOT_FOUND','JSON_TRANSCRIPTION_CONTENT_IS_EMPTY')

-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

/*
-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
UPDATE EP
    SET EP.[percentage] = 0
        ,EP.[StatusDescription] = 'IN_PROGRESS'
        ,EP.[Status] = 8
        ,EP.[LastModifiedDate] = GETUTCDATE()
    FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
    INNER JOIN [dbo].[#ProgressTemp] PT
        ON EP.[Instance] = PT.[vcc]
            AND EP.[ProcessId] = PT.[ProcessId]
            AND EP.[Id] = PT.[TypeId]
            AND PT.[Type] = 'ability'
    WHERE EP.[Status] = 7
        AND EP.[Evaluation_Mode] = 'X'
*/


-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





-----------------------------------------------------

DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Update complete.';


GO
