PRINT N'Quitando Procedimiento [dbo].[GetEvaluationPlansByStatus]...';


GO
DROP PROCEDURE [dbo].[GetEvaluationPlansByStatus];


GO
PRINT N'Quitando Procedimiento [dbo].[GetInteractionsEvaluationPlan]...';


GO
DROP PROCEDURE [dbo].[GetInteractionsEvaluationPlan];


GO
PRINT N'Quitando Procedimiento [dbo].[SaveAuditorEvaluationPlan]...';


GO
DROP PROCEDURE [dbo].[SaveAuditorEvaluationPlan];


GO
PRINT N'Modificando Procedimiento [dbo].[BulkInteractionEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DEFINIR EL VCC
	DECLARE @VCC VARCHAR(50) = NULL
	DECLARE @VCC_TYPE VARCHAR(50) = NULL
	DECLARE @NEED_I6_UPDATE BIT = 0 

	-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL VCC
	SELECT TOP 1 @VCC = [VCC] FROM [#InteractionEvaluationPlanTemp] (NOLOCK)

	-- BUSCAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] FROM [dbo].[VCC] V (NOLOCK) WHERE V.[VCC] = @VCC

	-- CAMBIAMOS EL VALOR DEL FLAG
	IF @VCC_TYPE = 'I6' SET @NEED_I6_UPDATE = 1

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [RelativePath], [FileName],
			[ContactId], [ContactAddress], [ContactName], 
			[InteractionFormat], 
			[NeedI6Update],
			[CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				IEP.[AgentName], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[RelativePath], IEP.[FileName],
				IEP.[InteractionContactId], IEP.[InteractionContactAddress], IEP.[InteractionContactName],
				IEP.[InteractionFormat], 
				CASE WHEN @VCC_TYPE = 'OCC'
					THEN IIF(IEP.[InteractionType] = 'CALL', 0 , 1) 
					ELSE @NEED_I6_UPDATE
					END,
				IEP.[CreatedByUserId], GETUTCDATE(), GETUTCDATE()
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			/*
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]
			*/

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetAgentsFromEvaluation]...';


GO
-- ESTE SP RETORNA LOS AGENTES ASOCIADOS A EVALUACIONES
ALTER PROCEDURE [dbo].[GetAgentsFromEvaluation] 
(
	@VCC					VARCHAR(50) = NULL,
	@UserId					VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
	@SearchType				VARCHAR(50) = NULL,
	@EfectivityMode			BIT = 0 
) 
AS
BEGIN
	-- DECLARAMOS UN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FROM_EFECTIVITY VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER_EFECTIVITY VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT DISTINCT IEP.[Instance]							''vcc'', 
						IEP.[IdAgent]							''userId'',
						IEP.[IdCampaign]						''campaignId'' '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] '
	SET @SQL_FROM_EFECTIVITY += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] 
			INNER JOIN (
				SELECT DISTINCT [VCC],
								[InteractionId],
								[AgentId],
								[EvaluationPlanId],
								[AuditorId] 
					FROM [dbo].[EvaluationResultEfectivity] (NOLOCK)
					WHERE [VCC] = ''' + @VCC + ' '' 
						AND [EfectivityStatus] IN (''' + 'CREATED' + '''' + ',' + '''' + 'DRAFT' + ''''+ ')' + '
			) AS ERE ON 
				(AEP.[Instance] = ERE.[VCC] 
					AND AEP.[IdEvaluationPlan] = ERE.[EvaluationPlanId]
					AND AEP.[IdInteraction] = ERE.[InteractionId])'	

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' '
	SET @SQL_FILTER_EFECTIVITY += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' '

	-- ARMAMOS LA PARTE DE EXTRAS
	SET @SQL_EXTRA = '
			ORDER BY IEP.[IdAgent] ASC '

	-- FILTRAMOS SEGUN EL TIPO DE BUSQUEDA
	IF @SearchType = 'PENDING'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE NO HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 0 '
	END
	ELSE IF @SearchType = 'HISTORY'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE YA HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 1 '
	END

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ROLE DEL USUARIO
	DECLARE @USER_ROLE VARCHAR(50) 
	SELECT TOP 1 @USER_ROLE = U.[Role] 
		FROM [dbo].[User] U (NOLOCK) 
		WHERE U.[VCC] = @VCC
			AND U.[ID] = @UserId

	-- FILTRAMOS SEGUN EL ROLE DEL USUARIO
	-- IF @RoleId = 'administrator, quality_admin'
	IF @USER_ROLE = 'quality_auditor'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES AUDITADAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAuditor] = ''' + @UserId + ''' '
		SET @SQL_FILTER_EFECTIVITY += '
			AND ERE.[AuditorId] = ''' + @UserId + ''' '
	END
	ELSE IF @USER_ROLE = 'quality_agent'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES HECHAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAgent] = ''' + @UserId + ''' '
	END

	-- FILTRAMOS SEGUN EL VALOR DE CAMPAIGNS
	IF @Campaigns IS NOT NULL AND @Campaigns <> ''
	BEGIN
		SET @SQL_FILTER += '
			AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
        SET @SQL_FILTER_EFECTIVITY += '
			AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	END 

	-- UNIMOS LAS PARTES DEL QUERY
	IF (@EfectivityMode =1)
	SET @SQL_SELECT += @SQL_FROM_EFECTIVITY + @SQL_FILTER_EFECTIVITY + @SQL_EXTRA
	ELSE
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA
	
	-- EJECUTAMOS LA CONSULTA
	--PRINT @SQL_SELECT
	EXEC (@SQL_SELECT)
	
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetEvaluationPlans]...';


GO
ALTER  PROCEDURE [dbo].[GetEvaluationPlans] (
@Instance           Varchar(50) = NULL,
@SearchCriteria     Varchar(50) = NULL,
@SearchExpression   Varchar(50) = NULL,
@Disabled			bit = NULL
)
AS
BEGIN
SET NOCOUNT ON

	-- 
	;WITH CTE_AEP_SUMMARY AS (
		SELECT AEP.[IdEvaluationPlan]																				'evaluationPlanId',
				COUNT(AEP.[IdInteraction])																			'totalEvaluations',
				--ISNULL(sum(cast(a.Completed as int)), 0)   'completedEvaluations',
				--ISNULL(ROUND(sum(cast(a.Completed as numeric(5,2)))*100/count(a.IdInteraction),2), 0) 'completedPercentage',
				COUNT(DISTINCT CASE AEP.[Completed] WHEN 1 THEN AEP.[IdInteraction] ELSE NULL END)					'completedEvaluations',
				(
					(
						CAST(
							COUNT(DISTINCT CASE AEP.[Completed] WHEN 1 THEN AEP.[IdInteraction] ELSE NULL END)
							+ 
							COUNT(DISTINCT CASE AEP.[Status] WHEN 0 THEN AEP.[IdInteraction] ELSE NULL END)
						 AS NUMERIC(18,2)) 
					)
					/
					CASE COUNT(DISTINCT AEP.[IdInteraction]) WHEN 0 THEN 1 ELSE COUNT(DISTINCT AEP.[IdInteraction]) END 
				) * 100																								'completedPercentage'
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			WHERE AEP.[Instance] = @Instance
			GROUP BY AEP.[IdEvaluationPlan]
	)
		
	-- 
    SELECT
			e.[ID]									'id',
			e.[Modality]							'modality',
			e.[DateFin]								'dateFin',
			e.CreatedDate							'createdDate',
			e.CreatedByUserId						'createdByUserId',
			e.LastModifiedDate						'lastModifiedDate',
			e.LastModifiedByUserId					'lastModifiedByUserId',
			e.Description							'description',
			e.IdEvaluationFormat					'idEvaluationFormat',
			e.Enabled								'enabled',
			e.Status								'status',
			e.Evaluation_Mode						'evaluation_mode',
			e.processId    							'processId',
			ef.templateId    						'templateId',
			CTE_AEP_S.[totalEvaluations]			'totalEvaluations',
			CTE_AEP_S.[completedEvaluations]		'completedEvaluations',
			CTE_AEP_S.[completedPercentage]			'completedPercentage',

			/*
			count(a.IdInteraction)			'totalEvaluations',
			--ISNULL(sum(cast(a.Completed as int)), 0)   'completedEvaluations',
			--ISNULL(ROUND(sum(cast(a.Completed as numeric(5,2)))*100/count(a.IdInteraction),2), 0) 'completedPercentage',
			COUNT(DISTINCT CASE a.[Completed] WHEN 1 THEN a.[IdInteraction] ELSE NULL END)					'completedEvaluations',
			(
				(
					CAST(
						COUNT(DISTINCT CASE a.[Completed] WHEN 1 THEN a.[IdInteraction] ELSE NULL END)
						+ 
						COUNT(DISTINCT CASE a.[Status] WHEN 0 THEN a.[IdInteraction] ELSE NULL END)
					 AS NUMERIC(18,2)) 
				)
				/
				CASE COUNT(DISTINCT a.[IdInteraction]) WHEN 0 THEN 1 ELSE COUNT(DISTINCT a.[IdInteraction]) END 
			) * 100																							'completedPercentage',
			*/
			e.[Percentage]							'percentage',
			e.[StatusDescription]					'statusDescription',
			e.[BatchStatus]							'batchStatus'
		FROM EvaluationPlan e (NOLOCK)
		/*
		LEFT JOIN AuditorEvaluationPlan a (NOLOCK) 
			ON a.[Instance] = e.[Instance]
				AND a.[IdEvaluationPlan] = e.[ID]
		*/
		INNER JOIN CTE_AEP_SUMMARY CTE_AEP_S
			ON CTE_AEP_S.[evaluationPlanId] = e.[ID] 
		INNER JOIN [dbo].[EvaluationFormat] ef (NOLOCK)
			ON ef.[Instance] = e.[Instance]
				AND ef.[ID] = e.[IdEvaluationFormat]
		WHERE e.Instance = @Instance
			AND ISNULL(e.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL(e.Modality, '') LIKE CASE WHEN @SearchCriteria = 'modality' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL(@Disabled, 0) <> e.Enabled

		/*
		GROUP BY e.[ID],
					e.[Modality],
					e.[DateFin],
					e.CreatedDate,
					e.CreatedByUserId,
					e.LastModifiedDate,
					e.LastModifiedByUserId,
					e.Description,
					e.IdEvaluationFormat,
					e.Enabled, 
					e.Status, 
					e.Evaluation_Mode,
					e.processId,
					ef.templateId, 
					e.Percentage, 
					e.StatusDescription, 
					e.[BatchStatus]	
		*/

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetGlobalSearchInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetGlobalSearchInteractions] (
	@VCC Varchar(50) = NULL,
	@Agents Varchar(MAX) = NULL,
   	@Campaigns VARCHAR(MAX) = NULL,
 	@InteractionDateFrom VARCHAR(50) = '1980-01-01T00:00:00',
    @InteractionDateTo VARCHAR(50) = '2050-01-01T23:59:59',	
    @InteractionOrigins Varchar(50) = NULL,	
	@InteractionTypes Varchar(50) = NULL,
	@InteractionIds     VARCHAR(MAX) = NULL,
	@ContactAddress Varchar(300) = NULL,
	@DispositionCodes VARCHAR(MAX)
	
	
)
AS
BEGIN
	SET NOCOUNT ON	
	
	--LISTAMOS INTERACCIONES ENCONTRADAS CON LOS  FILTROS BASICOS
	
	--INTERACCIONES DE PLANES MANUALES
	--SELECT * FROM InteractionEvaluationPlan
	CREATE TABLE #AllInteractionEvaluationPlan
	(
		[interactionId]				VARCHAR(250),
		[interactionSection]		INT,
		[interactionPart]			INT,	
		[interactionType]			VARCHAR(50),
		[interactionDateStart]		DATETIME,
		[interactionDateEnd]		DATETIME,
		[agentId]					VARCHAR(50),
		[campaignId]				VARCHAR(50),
		[interactionOrigin]			VARCHAR(50),
		[contactAddress]			VARCHAR(50),
		[interactionDuration]		INT,
		[evaluationPlanId]			VARCHAR(50),
		[processId]						VARCHAR(50),
		[evaluation_Mode]			VARCHAR(50),
		RN							INT
		
	)
	IF (@InteractionIds IS NULL OR  @InteractionIds = '')
	BEGIN
		INSERT INTO #AllInteractionEvaluationPlan
			SELECT DISTINCT
			IEP.[IdInteraction]				'interactionId',
			IEP.[InteractionSection]		'interactionSection',
			IEP.[InteractionPart]			'interactionPart',	
			IEP.[InteractionType]			'interactionType',
			IEP.[InteractionDateStart]		'interactionDateStart',
			IEP.[InteractionDateEnd]		'interactionDateEnd',
			IEP.[IdAgent]					'agentId',
			IEP.[IdCampaign]				'campaignId',
			IEP.[InteractionOrigin]			'originId',
			IEP.[ContactAddress]			'contactAddress',
			IEP.[InteractionDuration]		'duration',
			IEP.[IdEvaluationPlan]			'evaluationPlanId',
			NULL							'processId',
			EP.[Evaluation_Mode]			'evaluation_mode',
			
			RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],IEP.[IdInteraction] ORDER BY IEP.[CreatedDate] DESC)

		
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN dbo.[EvaluationPlan] EP (NOLOCK)
				 ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]

			WHERE IEP.[Instance] = @VCC			
				AND	(
						ISNULL(LEN(@Agents), 0) = 0
						OR
						[IdAgent]  IN (SELECT Value FROM [dbo].[split](@Agents, ','))
					)
	
				AND (
						ISNULL(LEN(@Campaigns), 0) = 0
						OR
						[IdCampaign]  IN (SELECT Value FROM [dbo].[split](@Campaigns, ','))
					)
	
				AND (
						ISNULL(LEN(@InteractionOrigins), 0) = 0
						OR
						[InteractionOrigin]  IN (SELECT Value FROM [dbo].[split](@InteractionOrigins, ','))
					)

				AND	(
						ISNULL(LEN(@InteractionTypes), 0) = 0
						OR
						[InteractionType]  IN (SELECT Value FROM [dbo].[split](@InteractionTypes, ','))
					)	

	

				AND (
						ISNULL(LEN(@ContactAddress), 0) = 0
						OR
						[ContactAddress] LIKE '%' + @ContactAddress + '%'
					)
    
				AND (
						ISNULL(LEN(@DispositionCodes), 0) = 0
						OR
						[ManagementResult] IN (SELECT Value FROM [dbo].[split](@DispositionCodes, ','))
					)
				AND (
						IEP.InteractionDateEnd BETWEEN @InteractionDateFrom AND @InteractionDateTo
					)

					
	END
	ELSE 
	BEGIN
		INSERT INTO #AllInteractionEvaluationPlan
			SELECT DISTINCT
			IEP.[IdInteraction]				'interactionId',
			IEP.[InteractionSection]		'interactionSection',
			IEP.[InteractionPart]			'interactionPart',	
			IEP.[InteractionType]			'interactionType',
			IEP.[InteractionDateStart]		'interactionDateStart',
			IEP.[InteractionDateEnd]		'interactionDateEnd',
			IEP.[IdAgent]					'agentId',
			IEP.[IdCampaign]				'campaignId',
			IEP.[InteractionOrigin]			'originId',
			IEP.[ContactAddress]			'contactAddress',
			IEP.[InteractionDuration]		'duration',
			IEP.[IdEvaluationPlan]			'evaluationPlanId',
			NULL							'processId',
			EP.[Evaluation_Mode]			'evaluation_mode',
			
			RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],IEP.[IdInteraction] ORDER BY IEP.[CreatedDate] DESC)

		
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN dbo.[EvaluationPlan] EP (NOLOCK)
				 ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]

			WHERE IEP.[Instance] = @VCC			
					AND [IdInteraction]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))				
		
	END

		DROP TABLE IF EXISTS #DistinctInteractionEvaluationPlan
	    SELECT [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode]
			INTO  #DistinctInteractionEvaluationPlan
			FROM #AllInteractionEvaluationPlan 
			WHERE RN = 1

	
	--INTERACCIONES DE CALL DE PLANES AUTOMATICOS QUE AUN NO EXISTAN EN EL PRIMER LISTADO

	CREATE TABLE #AllInteractionProcess
	(
		[interactionId]				VARCHAR(250),
		[interactionSection]		INT,
		[interactionPart]			INT,	
		[interactionType]			VARCHAR(50),
		[interactionDateStart]		DATETIME,
		[interactionDateEnd]		DATETIME,
		[agentId]					VARCHAR(50),
		[campaignId]				VARCHAR(50),
		[interactionOrigin]			VARCHAR(50),
		[contactAddress]			VARCHAR(50),
		[interactionDuration]		INT,
		[evaluationPlanId]			VARCHAR(50),
		[processId]						VARCHAR(50),
		[evaluation_Mode]			VARCHAR(50),
		RN							INT
		
	)

	IF (@InteractionIds IS NULL OR  @InteractionIds = '')
	BEGIN
		INSERT INTO #AllInteractionProcess
			SELECT DISTINCT
			A.[ID]					'interactionId',
			A.[Section]				'interactionSection',
			A.[Part]				'interactionPart',	
			A.[Channel]				'interactionType',
			A.[StartDate]			'interactionDateStart',
			A.[EndDate]				'interactionDateEnd',
			A.[Agent]				'agentId',
			A.[Campaign]			'campaignId',
			A.[Type]				'originId',
			A.[ContactAddress]		'contactAddress',
			A.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PA.[ProcessId]			'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC],A.[ID] ORDER BY A.[CreatedDate] DESC)
	

			FROM dbo.[Audio] A (NOLOCK)
			INNER JOIN dbo.[ProcessAudio] PA (NOLOCK)
				ON  A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId] 
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]

			WHERE A.[VCC] = @VCC 
				AND  A.[IsTranscribed] = 1
				AND	(
						ISNULL(LEN(@Agents), 0) = 0
						OR
						[Agent]  IN (SELECT Value FROM [dbo].[split](@Agents, ','))
					)
	
				AND (
						ISNULL(LEN(@Campaigns), 0) = 0
						OR
						[Campaign]  IN (SELECT Value FROM [dbo].[split](@Campaigns, ','))
					)
		
				AND (
						ISNULL(LEN(@InteractionOrigins), 0) = 0
						OR
						[Type]  IN (SELECT Value FROM [dbo].[split](@InteractionOrigins, ','))
					)

				AND	(
						ISNULL(LEN(@InteractionTypes), 0) = 0
						OR
						[channel]  IN (SELECT Value FROM [dbo].[split](@InteractionTypes, ','))
					)	

				--AND (
				--		ISNULL(LEN(@InteractionIds), 0) = 0
				--		OR
				--		[Id]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))
				--	)

				AND (
						ISNULL(LEN(@ContactAddress), 0) = 0
						OR
						[ContactAddress] LIKE '%' + @ContactAddress + '%'
					)
		
				AND (
						ISNULL(LEN(@DispositionCodes), 0) = 0
						OR
						[Description] IN (SELECT Value FROM [dbo].[split](@DispositionCodes, ','))
					)

				AND (
						A.EndDate BETWEEN @InteractionDateFrom AND @InteractionDateTo
					)

				AND  [Id] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)
					
				
				
	END		
	ELSE
	BEGIN
		INSERT INTO #AllInteractionProcess
			SELECT DISTINCT
			A.[ID]					'interactionId',
			A.[Section]				'interactionSection',
			A.[Part]				'interactionPart',	
			A.[Channel]				'interactionType',
			A.[StartDate]			'interactionDateStart',
			A.[EndDate]				'interactionDateEnd',
			A.[Agent]				'agentId',
			A.[Campaign]			'campaignId',
			A.[Type]				'originId',
			A.[ContactAddress]		'contactAddress',
			A.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PA.[ProcessId]			'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC],A.[ID] ORDER BY A.[CreatedDate] DESC)
	

			FROM dbo.[Audio] A (NOLOCK)
			INNER JOIN dbo.[ProcessAudio] PA (NOLOCK)
				ON  A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId] 
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]

			WHERE A.[VCC] = @VCC
					AND A.[IsTranscribed] = 1
					AND A.[ID]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))	
					AND A.[ID] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)
					
					
				
				
	END

	DROP TABLE IF EXISTS #DistinctInteractionProcess
	    SELECT [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode]
			INTO  #DistinctInteractionProcess
			FROM #AllInteractionProcess WHERE RN = 1	

	--LISTAMOS INTERACCIONES DE TEXTO DE PLANES AUTOMATICOS QUE AUN NO EXISTAN EN UN PLAN DE EVALUACION 
	CREATE TABLE #AllTextInteractionProcess
	(
		[interactionId]				VARCHAR(250),
		[interactionSection]		INT,
		[interactionPart]			INT,	
		[interactionType]			VARCHAR(50),
		[interactionDateStart]		DATETIME,
		[interactionDateEnd]		DATETIME,
		[agentId]					VARCHAR(50),
		[campaignId]				VARCHAR(50),
		[interactionOrigin]			VARCHAR(50),
		[contactAddress]			VARCHAR(50),
		[interactionDuration]		INT,
		[evaluationPlanId]			VARCHAR(50),
		[processId]						VARCHAR(50),
		[evaluation_Mode]			VARCHAR(50),
		RN							INT
		
	)
	IF (@InteractionIds IS NULL OR  @InteractionIds = '')
	BEGIN
		INSERT INTO #AllTextInteractionProcess
			SELECT DISTINCT
			ASY.[ID]				'interactionId',
			0						'interactionSection',
			0						'interactionPart',
			ASY.[Channel]			'interactionType',
			ASY.[StartDate]			'interactionDateStart',
			ASY.[EndDate]			'interactionDateEnd',
			ASY.[FirstTakedAgent]	'agentId',
			ASY.[Campaign]			'campaignId',
			ASY.[Initiative]		'originId',
			ASY.[ContactAddress]	'contactAddress',
			ASY.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PASY.[ProcessId]		'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY ASY.[VCC],ASY.[ID] ORDER BY ASY.[CreatedDate] ASC)


			FROM dbo.[AsyncInteraction] ASY (NOLOCK)
			INNER JOIN dbo.[ProcessAsyncInteraction] PASY  (NOLOCK)
				ON ASY.[VCC] = PASY.[VCC]
					AND ASY.[ID] = PASY.[InteractionId]
					AND ASY.[EndDate] = PASY.[EndDate]


			WHERE ASY.[VCC] = @VCC	
				AND ASY.[IsTranscribed] = 1
				AND	(
						ISNULL(LEN(@Agents), 0) = 0
						OR
						[FirstTakedAgent]  IN (SELECT Value FROM [dbo].[split](@Agents, ','))
					)
	
				AND	(
						ISNULL(LEN(@Campaigns), 0) = 0
						OR
						ASY.[Campaign]  IN (SELECT Value FROM [dbo].[split](@Campaigns, ','))
					)
		
				AND (
						ISNULL(LEN(@InteractionOrigins), 0) = 0
						OR
						[Initiative]  IN (SELECT Value FROM [dbo].[split](@InteractionOrigins, ','))
					)

				AND	(
						ISNULL(LEN(@InteractionTypes), 0) = 0
						OR
						[channel]  IN (SELECT Value FROM [dbo].[split](@InteractionTypes, ','))
					)	

				--AND (
				--		ISNULL(LEN(@InteractionIds), 0) = 0
				--		OR
				--		[Id]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))
				--	)

				AND (
						ISNULL(LEN(@ContactAddress), 0) = 0
						OR
						[ContactAddress] LIKE '%' + @ContactAddress + '%'
					)
		
				AND (
						ISNULL(LEN(@DispositionCodes), 0) = 0
						OR
						[DispositionTreePath] IN (SELECT Value FROM [dbo].[split](@DispositionCodes, ','))
					)

				AND ASY.EndDate BETWEEN @InteractionDateFrom AND @InteractionDateTo
					
				AND ASY.[ID] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)

				
	END
	ELSE
	BEGIN
		INSERT INTO #AllTextInteractionProcess
			SELECT DISTINCT
			ASY.[ID]				'interactionId',
			0						'interactionSection',
			0						'interactionPart',
			ASY.[Channel]			'interactionType',
			ASY.[StartDate]			'interactionDateStart',
			ASY.[EndDate]			'interactionDateEnd',
			ASY.[FirstTakedAgent]	'agentId',
			ASY.[Campaign]			'campaignId',
			ASY.[Initiative]		'originId',
			ASY.[ContactAddress]	'contactAddress',
			ASY.[DurationTime]		'duration',
			NULL					'evaluationPlanId',
			PASY.[ProcessId]		'processId',
			'A'						'evaluation_mode',
			RN = ROW_NUMBER() OVER(PARTITION BY ASY.[VCC],ASY.[ID] ORDER BY ASY.[CreatedDate] ASC)


			FROM dbo.[AsyncInteraction] ASY
			INNER JOIN dbo.[ProcessAsyncInteraction] PASY 
				ON ASY.[VCC] = PASY.[VCC]
					AND ASY.[ID] = PASY.[InteractionId]
					AND ASY.[EndDate] = PASY.[EndDate]


			WHERE ASY.[VCC] = @VCC	
					AND ASY.[IsTranscribed] = 1
					AND ASY.[ID]  IN (SELECT Value FROM [dbo].[split](@InteractionIds, ','))	
					AND ASY.[ID] NOT IN (SELECT interactionId FROM #DistinctInteractionEvaluationPlan)
		

	END

	
	
	DROP TABLE IF EXISTS #DistinctTextInteractionProcess
	    SELECT [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode]
			INTO   #DistinctTextInteractionProcess
			FROM #AllTextInteractionProcess WHERE RN = 1	
	
	--LISTADO CONSOLIDADO 
	
	SELECT  [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode] 
	FROM #DistinctInteractionEvaluationPlan
	UNION
	SELECT  [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode] 
	FROM #DistinctInteractionProcess
	UNION
	SELECT  [interactionId],
				[interactionSection],
				[interactionPart],	
				[interactionType],
				[interactionDateStart],
				[interactionDateEnd],
				[agentId],
				[campaignId],
				[interactionOrigin],
				[contactAddress],
				[interactionDuration],
				[evaluationPlanId],
				[processId],
				[evaluation_Mode] 
	FROM #DistinctTextInteractionProcess
		
	SET NOCOUNT OFF
	
END
GO
PRINT N'Modificando Procedimiento [dbo].[GetProcessFiltersData]...';


GO
ALTER PROCEDURE [dbo].[GetProcessFiltersData] ( 
	@VCC VARCHAR(50) = NULL, 
	@ProcessId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ELIMINAMOS LA TABLA TEMPORAL EN CASO EXISTA
	DROP TABLE IF EXISTS  #ProcessFiltersData 

	-- CREAMOS LA TABLA TEMPORAL PARA LOS RESUMENES
	CREATE TABLE #ProcessFiltersData (
		[Channel] VARCHAR(50),
		[Campaign] VARCHAR (50),
		[AgentId] VARCHAR(50),
		[AgentName] VARCHAR(100),
		[DispositionCode] VARCHAR(50),
		[Category1] VARCHAR(100),
		[Category2] VARCHAR(100),
		[Category3] VARCHAR(100),
		[Description] VARCHAR(100),
	)
	
	-- CONSULTAMOS DATA DE LA TABLA
	--SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'AsyncInteraction' AND COLUMN_NAME IN ('Agent', 'AgentName', 'FirstTakedAgent', 'FirstTakedAgentName', 'LastTakedAgent', 'LastTakedAgentName')
	--SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'Audio' AND COLUMN_NAME IN ('Category1', 'Category2', 'Category3', 'Description', 'DispositionCode')

	-- INSERTAMOS LA DATA DE AUDIOS
	INSERT INTO #ProcessFiltersData
		SELECT 'CALL',
				A.[Campaign],
				A.[Agent],
				A.[AgentName],
				A.[DispositionCode],
				A.[Category1],
				A.[Category2],
				A.[Category3],
				A.[Description]
			FROM [dbo].[ProcessAudio] PA (NOLOCK) 
			INNER JOIN [Audio] A (NOLOCK)
				ON A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId

	-- INSERTAMOS LA DATA DE TEXTOS
	INSERT INTO #ProcessFiltersData
		SELECT AI.[Channel],
				AI.[Campaign],
				ISNULL(AI.[LastTakedAgent], AI.[FirstTakedAgent]),
				ISNULL(AI.[LastTakedAgentName], AI.[FirstTakedAgentName]),
				AI.[DispositionCode],
				NULL,--AI.[Category1],
				NULL,--AI.[Category2],
				NULL,--AI.[Category3],
				NULL--AI.[Description]
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK) 
			INNER JOIN [AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC] 
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
					AND AI.[Campaign] = PAI.[Campaign]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId

	-- SELECCIONAMOS AGRUPADO POR FILTRO
	SELECT [Channel] 'channel' FROM #ProcessFiltersData GROUP BY [Channel] ORDER BY [Channel] ASC
	SELECT [Campaign] 'campaignId' FROM #ProcessFiltersData GROUP BY [Campaign] ORDER BY [Campaign] ASC
	SELECT [AgentId] 'agentId', 
			[AgentName] 'agentName'
		FROM #ProcessFiltersData 
		GROUP BY [AgentId], [AgentName] 
		ORDER BY [AgentId], [AgentName] ASC
	SELECT [DispositionCode]	'dispositionCode',
			[Category1]			'description',
			[Category2]			'description2',
			[Category3]			'description3',
			[Description]		'description4'
		FROM #ProcessFiltersData 
		GROUP BY [DispositionCode], [Category1], [Category2], [Category3], [Description] 
		ORDER BY [DispositionCode], [Category1], [Category2], [Category3], [Description]  ASC

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE #ProcessFiltersData 

END
GO
PRINT N'Modificando Procedimiento [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null, -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
			[dbo].[Audio].[ErrorMessage] = NULL
		
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				INSERTED.[RelativePath]					'relativePath',
				INSERTED.[FileName]						'fileName',
				INSERTED.[Format]                       'format',
				INSERTED.[MediaInfoTime]                'mediaInfoTime',
				INSERTED.[NeedI6Update]					'needI6Update',
				0										'isDiariced',
				P.[Language]							'language',
				P.[DictionaryId]						'dictionaryId',
				P.Retranscription						'retranscription',
				P.Diarization							'diarization',
				P.ChannelChange							'channelchange',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(A.[IsProcess], 0) = 0				
					AND 
					ISNULL(A.[IsTranscribed], 0) = 0	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				)
				OR 
				(
					A.[IsProcess] = 1						
					AND 
					A.[IsCancel] = 1
				)
			
				
				
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL,
			[dbo].[AsyncInteraction].[ErrorMessage] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				INSERTED.[FileName]                                                 'fileName',
				'allegro'															'environmentType',
				P.Retranscription													'retranscription'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				-- AND AI.[EndDate] = PAI.[EndDate]
				AND FORMAT (AI.[EndDate], 'yyyy-MM-dd') = FORMAT (PAI.[EndDate], 'yyyy-MM-dd')
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(AI.[IsProcess], 0) = 0
					AND 
					ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					AI.[IsProcess] = 1
					AND 
					AI.[IsCancel] = 1
				)

				
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveEvaluationBaseResult]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS

BEGIN
	-- ALERTA: NO ESTA PROBBADO PARA PLAN MANUAL

	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART

	DROP TABLE IF EXISTS #TMP_TRANSCRIBED_CALL_INTERACTIONS
	DROP TABLE IF EXISTS #TMP_RESULTS_FOR_EVALUATION 
	DROP TABLE IF EXISTS #TMP_EVALUATIONS_RESULTS

	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LAS INTERACCIONES CALL YA TRANSRITAS
	SELECT A.[ID]
		INTO #TMP_TRANSCRIBED_CALL_INTERACTIONS
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
			ON PA.[VCC] = A.[VCC]
				AND PA.[AudioId] = A.[ID] 
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = A.[VCC]
				AND EP.[ProcessId] = PA.[ProcessId]
		WHERE A.[VCC] = @VCC 
			AND A.[IsTranscribed] = 1
			AND EP.[ID] = @EVALUATION_PLAN_ID

	-- SELECT * FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
	
	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LAS INTERACCIONES TEXT YA TRANSRITAS
	SELECT AI.[ID]
		INTO #TMP_TRANSCRIBED_TEXT_INTERACTIONS
		FROM [dbo].[AsyncInteraction] AI (NOLOCK)
		INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			ON IEP.[Instance] = AI.[VCC]
				AND IEP.[IdInteraction] = AI.[ID]
				AND IEP.[FormattedEndDate] = AI.[Folder]
		WHERE AI.[VCC] = @VCC 
			AND AI.[IsTranscribed] = 1
			AND IEP.[IdInteraction] = @EVALUATION_PLAN_ID

	-- CREAMOS UNA TABLA TEMPORAL PARA ALMACENAR LOS EVALUATION_RESULT YA REGISTRADOS
	SELECT ER.*
		INTO #TMP_EVALUATIONS_RESULTS
		FROM [dbo].[EvaluationResult] ER (NOLOCK) 
		WHERE ER.[Instance] = @VCC 
			AND ER.[IdEvaluationPlan] = @EVALUATION_PLAN_ID

	-- SELECT * FROM #TMP_TRANSCRIBED_TEXT_INTERACTIONS
	
	-- GENERAMOS REGISTROS PARA TODAS LAS INTERACCIONES
	;WITH INTERACTIONS_ALL_CTE AS (
		SELECT IEP.[Instance],
				IEP.[IdEvaluationPlan],
				IEP.[IdCampaign],
				IEP.[IdInteraction],
				IEP.[IdAgent],
				IEP.[InteractionDateStart],
				IEP.[InteractionDateEnd],
				IEP.[InteractionType],
				IEP.[ContactId],
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[Instance],
													IEP.[IdEvaluationPlan],				
													IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent],
													IEP.[InteractionDateStart],
													IEP.[InteractionDateEnd],
													IEP.[InteractionType],
													IEP.[ContactId]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC)
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC
				AND IEP.[IdEvaluationPlan] = @EVALUATION_PLAN_ID
	)  -- SELECT * FROM INTERACTIONS_ALL_CTE RETURN
	, INTERACTIONS_SUMMARY_CTE AS (
		SELECT I_A_CTE.*
			FROM INTERACTIONS_ALL_CTE I_A_CTE
			WHERE I_A_CTE.RN = 1
	) -- SELECT * FROM INTERACTIONS_SUMMARY_CTE RETURN
	, INTERACTIONS_FIRST_FILTER_CTE AS (
		SELECT * 
			FROM INTERACTIONS_SUMMARY_CTE IS_CTE
			WHERE (
					IS_CTE.[InteractionType] = 'CALL' 
					AND 
					IS_CTE.[IdInteraction] IN (
						SELECT [ID] FROM #TMP_TRANSCRIBED_CALL_INTERACTIONS
					)
				)
				OR
				IS_CTE.[InteractionType] <> 'CALL' 
	)  -- SELECT * FROM INTERACTIONS_FIRST_FILTER_CTE RETURN /*
	-- TODO: EL SECOND_FILTER ES SOBRE LAS INTERACCIONES TEXT TRANSCRITAS
	, MAIN_CTE AS (
		SELECT EP.[Instance]										'vcc',
				EP.[ID]												'IdEvaluationPlan',
				EP.[IdEvaluationFormat]								'IdEvaluationFormat',
				HEF.[MinQualificationAcceptable]					'MinQualificationAcceptable',
				IFF_CTE.[IdInteraction]								'IdInteraction',
				IFF_CTE.[IdCampaign]								'IdCampaign',
				IFF_CTE.[IdAgent]									'IdAgent',
				EP.[ProcessId]										'ProcessId',
				HAEF.[IdGroup]										'IdGroup',
				HAEF.[IdSubGroup]									'IdSubGroup',
				HAEF.[IdAbility]									'IdAbility',
				HAEF.[Score]										'MaxAbilityScore',
				HS.[Value]											'AbilityInnerScore',
				HS.[Description]									'ScoreDescription',
				IFF_CTE.[IdCampaign]								'CampaignDescription',
				IFF_CTE.[IdAgent]									'AgentDescription',
				IFF_CTE.[InteractionDateStart]						'InteractionDateini',
				IFF_CTE.[InteractionDateEnd]						'InteractionDatefin',
				IFF_CTE.[ContactId]									'InteractionAddress',
				HAEF.[Order]										'AbilityOrder',
				IFF_CTE.[InteractionType]							'InteractionType',
				HAEF.[ID]											'IdAbilityEvaluationFormat',
				HAEF.[Conditional]									'Conditional'
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			INNER JOIN [dbo].[HistoricEvaluationFormat] HEF (NOLOCK)
				ON HEF.[VCC] = EP.[Instance]
					AND HEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbilityEvaluationFormat] HAEF (NOLOCK)
				ON HAEF.[VCC] = EP.[Instance]
					AND HAEF.[EvaluationPlanId] = EP.[ID]
			INNER JOIN [dbo].[HistoricAbility] HA (NOLOCK)
				ON HA.[VCC] = EP.[Instance]
					AND HA.[EvaluationPlanId] = EP.[ID]
					AND HA.[ID] = HAEF.[IdAbility]
			INNER JOIN [dbo].[HistoricScore] HS (NOLOCK)
				ON HS.[VCC] = EP.[Instance]
					AND HS.[EvaluationPlanId] = EP.[ID]
					AND HS.[IdAbility] = HA.[ID]
					AND HS.[Value] = IIF(HA.[IsNegative] = 1, 100, 0)
			INNER JOIN INTERACTIONS_FIRST_FILTER_CTE IFF_CTE 
				ON IFF_CTE.[Instance] = EP.[Instance]
					AND IFF_CTE.[IdEvaluationPlan] = EP.[ID]
			LEFT JOIN #TMP_EVALUATIONS_RESULTS TMP_ER 
				ON TMP_ER.[Instance] = EP.[Instance]
					AND TMP_ER.[IdEvaluationPlan] = EP.[ID]
					AND TMP_ER.[IdInteraction] = IFF_CTE.[IdInteraction]
					AND TMP_ER.[IdAbility] = HA.[ID]
					AND TMP_ER.[IdAgent] = IFF_CTE.[IdAgent]
					AND TMP_ER.[IdAbilityEvaluationFormat] = HAEF.[ID]
			WHERE TMP_ER.[Instance] IS NULL
				AND EP.[Instance] = @VCC
				AND IFF_CTE.[IdInteraction] IS NOT NULL
			    AND EP.[ID] = @EVALUATION_PLAN_ID
				AND (
					(
						@ABILITY_TYPE = 'AUTOMATIC' 
						AND 
						HA.[Type] = 'MANUAL_AUTOMATIC'
					)
					OR
					(
						@ABILITY_TYPE = 'MANUAL' 
						AND 
						HA.[Type] = 'MANUAL'
					)
				)
	)  -- SELECT * FROM MAIN_CTE RETURN
	
		
	-- INSERTAMOS TODOS LOS REGISTROS EN UNA TABLA TEMPORAL
	SELECT * -- 0 'DEBUG'
		INTO #TMP_RESULTS_FOR_EVALUATION
		FROM MAIN_CTE
	
	-- ELIMINAMOS LOS REGISTROS PARA INTERACCIONES TEXT NO TRANSCRITAS
	/*
	DELETE FROM TMP_RESULTS_FOR_EVALUATION
		WHERE [InteractionType] <> 'CALL' 
			AND [IdInteraction] NOT IN (
				SELECT [ID] FROM #TMP_NOT_TRANSCRIBED_TEXT_INTERACTIONS
			)
			*/

	-- TENEMOS LOS REGISTROS PARA INSERTAR EN EVALUATIONRESULT
	-- SELECT * FROM #TMP_RESULTS_FOR_EVALUATION RETURN

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [OwnScore], [AbilityInnerScore],
		[IdEvaluator], [EvaluationDate], [MaxAbilityScore],
		[IdEvaluationPlan], [CreatedDate], [CreatedByUserId],
		[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],
		[Comment], [NotApplies], [ScoreDescription],
		[CampaignDescription], [AgentDescription], [InteractionDateini],
		[InteractionDatefin], [InteractionAddress], [AbilityOrder],
		[InteractionType], [IdAbilityEvaluationFormat],  [IdAuditor],
		[Conditional]
	)
		SELECT TMP_RFE.[vcc], TMP_RFE.[IdCampaign], TMP_RFE.[IdInteraction],
				TMP_RFE.[IdAgent], TMP_RFE.[IdEvaluationFormat], TMP_RFE.[MinQualificationAcceptable],
				TMP_RFE.[IdGroup], TMP_RFE.[IdSubGroup], TMP_RFE.[IdAbility],
				(TMP_RFE.[MaxAbilityScore] * TMP_RFE.[AbilityInnerScore] / 100), (TMP_RFE.[MaxAbilityScore] * TMP_RFE.[AbilityInnerScore] / 100), TMP_RFE.[AbilityInnerScore],
				'SPEECH', GETUTCDATE(), TMP_RFE.[MaxAbilityScore],
				TMP_RFE.[IdEvaluationPlan], GETUTCDATE(), 'SPEECH',
				--'100', TMP_RFE.[IdEvaluationPlan], GETUTCDATE(),
				GETUTCDATE(), 'SPEECH', GETUTCDATE(),
				NULL, '0', TMP_RFE.[ScoreDescription],
				TMP_RFE.[CampaignDescription], TMP_RFE.[AgentDescription], TMP_RFE.[InteractionDateini],
				TMP_RFE.[InteractionDatefin], TMP_RFE.[InteractionAddress], TMP_RFE.[AbilityOrder],
				TMP_RFE.[InteractionType], TMP_RFE.[IdAbilityEvaluationFormat], 'SPEECH',
				TMP_RFE.[Conditional]
			FROM #TMP_RESULTS_FOR_EVALUATION TMP_RFE

	-- ELIMINAMOS LAS TABLAS TEMPORALES
	DROP TABLE #TMP_TRANSCRIBED_CALL_INTERACTIONS
	DROP TABLE #TMP_RESULTS_FOR_EVALUATION
	DROP TABLE #TMP_EVALUATIONS_RESULTS

	SET NOCOUNT OFF

END
GO
PRINT N'Modificando Procedimiento [dbo].[SaveHistoricEvaluationPlanData]...';


GO
ALTER PROCEDURE [dbo].[SaveHistoricEvaluationPlanData] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50)=NULL,
	@FormatId VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA LA MODALIDAD DEL PLAN
	DECLARE @EVALUATION_MODE VARCHAR(50) = NULL 
	SELECT @EVALUATION_MODE = [Evaluation_Mode] FROM [dbo].[EvaluationPlan] (NOLOCK) WHERE [ID] = @EvaluationPlanId

	-- REGISTRAMOS LA DATA DEL FORMATO DE EVALUACION
	INSERT INTO [dbo].[HistoricEvaluationFormat] 
		SELECT EF.[Instance],
				EF.[ID],
				EF.[Description],
				EF.[type],
				EF.[EnvironmentType],
				EF.[MinAutomaticQualification],
				EF.[MinQualificationAcceptable],
				EF.[ManagementFormURL],
				EF.[Enabled],
				EF.[templateId],
				@EvaluationPlanId
            FROM [dbo].[EvaluationFormat] EF (NOLOCK) 
            WHERE [ID] = @FormatId 
				AND [Instance] = @VCC


	-- 
	INSERT INTO [dbo].[HistoricAbilityEvaluationFormat]
		SELECT DISTINCT A.[Instance],
							A.[ID] ,
							A.[IdEvaluationFormat],
							A.[IdAbility],
							A.[IdGroup],
							A.[IdSubGroup],
							A.[Penalizes],
							A.[Score],
							A.[Order],
							A.[Conditional],
							@EvaluationPlanId
			FROM  [dbo].[AbilityEvaluationFormat] A (NOLOCK)
			JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = A.[Instance] 
					AND EF.[ID] = A.[IdEvaluationFormat]
			WHERE EF.[ID] = @FormatId AND EF.[Instance] = @VCC

	--
	INSERT INTO [dbo].[HistoricEvaluationFormatCustomField]
		SELECT ECF.[VCC],
				ECF.[ID],
				ECF.[EvaluationFormatId],
				ECF.[CustomFieldId],
				ECF.[Order],
				@EvaluationPlanId
			FROM [dbo].[EvaluationFormatCustomField] ECF (NOLOCK)
			JOIN [dbo].[EvaluationFormat] EF (NOLOCK) 
				ON ECF.[VCC] = EF.[Instance] 
				AND ECF.[EvaluationFormatId] = EF.[ID]
			WHERE EF.[ID] = @FormatId AND EF.[Instance] = @VCC
			GROUP BY ECF.[VCC],
						ECF.[ID],
						ECF.[EvaluationFormatId],
						ECF.[CustomFieldId],
						ECF.[Order]

	-- 
	INSERT INTO [dbo].[HistoricCustomField]
		SELECT C.[VCC],
				 C.[ID],
				 C.[Description],
				 C.[Type],
				 C.[Label],
				 @EvaluationPlanId
			FROM [dbo].[CustomField] C (NOLOCK)
			JOIN [dbo].[EvaluationFormatCustomField] FC (NOLOCK)
				ON C.[VCC] = FC.[VCC] 
					AND C.[ID] = FC.[CustomFieldId]
			WHERE FC.[EvaluationFormatId] = @FormatId 
				AND FC.[VCC] = @VCC
			GROUP BY C.[VCC],
						C.[ID],
						C.[Description],
						C.[Type],
						C.[Label]


	--
	INSERT INTO [dbo].[HistoricCustomFieldResult]
		SELECT CR.[VCC],
				CR.[ID],
				CR.[Description],
				CR.[Order],
				CR.[CustomFieldId],
				@EvaluationPlanId
			FROM [dbo].[CustomFieldResult] CR (NOLOCK)
			JOIN [dbo].[CustomField] C (NOLOCK)
				ON CR.[VCC] = C.[VCC] 
					AND CR.[CustomFieldId] = C.[ID]
			JOIN [dbo].[EvaluationFormatCustomField] FC (NOLOCK)
				ON C.[VCC] = FC.[VCC] 
					AND C.[ID] = FC.[CustomFieldId]
			WHERE FC.[EvaluationFormatId] = @FormatId 
				AND FC.[VCC] = @VCC
			GROUP BY CR.[VCC],
						CR.[ID],
						CR.[Description],
						CR.[Order],
						CR.[CustomFieldId]
	
	
	--
	INSERT INTO [dbo].[HistoricEvaluationFormatAttachedSignature]
		SELECT AFS.[VCC],
				AFS.[Description],
				AFS.[Order],
				AFS.[EvaluationFormatId],
				@EvaluationPlanId
			FROM [dbo].[EvaluationFormatAttachedSignature] AFS (NOLOCK)
            WHERE AFS.[EvaluationFormatId] = @FormatId 
				AND AFS.[VCC] = @VCC


	--
	INSERT INTO [dbo].[HistoricCampaignEvaluationFormat]
		SELECT CEF.[Instance],
				CEF.[IdEvaluationFormat],
				CEF.[IdCampaign],
				@EvaluationPlanId
			FROM [dbo].[CampaignEvaluationFormat] CEF (NOLOCK) 
			WHERE CEF.[IdEvaluationFormat] = @FormatId 
				AND CEF.[Instance] = @VCC
			GROUP BY CEF.[Instance],
						CEF.[IdEvaluationFormat],
						CEF.[IdCampaign]


	--
	INSERT INTO [dbo].[HistoricGroup] 
		SELECT G.[Instance] ,
				G.[ID],
				G.[Description] ,
				G.[Enabled],
				@EvaluationPlanId
			FROM [dbo].[Group] G (NOLOCK)
			JOIN [dbo].[AbilityEvaluationFormat] A (NOLOCK)
				ON  A.[Instance] = G.[Instance] 
					AND A.[IdGroup] = G.[ID]
			WHERE A.[IdEvaluationFormat] = @FormatId 
				AND A.[Instance] = @VCC
			GROUP BY G.[Instance] ,
						G.[ID],
						G.[Description] ,
						G.[Enabled] 
	


	--
	INSERT INTO [dbo].[HistoricSubGroup] 
		SELECT G.[Instance] ,
				G.[ID],
				G.[Description] ,
				G.[Enabled],
				@EvaluationPlanId
			FROM [dbo].[SubGroup] G (NOLOCK)
			JOIN [dbo].[AbilityEvaluationFormat] A (NOLOCK)
				ON  A.[Instance] = G.[Instance] 
					AND A.[IdSubGroup] = G.[ID]
			WHERE A.[IdEvaluationFormat] = @FormatId 
				AND A.[Instance] = @VCC
			GROUP BY G.[Instance],
						G.[ID],
						G.[Description] ,
						G.[Enabled] 


	-- INSERTAMOS LA DATA DE LAS HABILIDADES
	INSERT INTO [dbo].[HistoricAbility] 
		SELECT A.[Instance],
				A.[ID],
				A.[Title],
				A.[Detail],
				A.[Type],
				A.[CalificationType],
				A.[Binary],
				A.[NotApply],
				A.[Distribute],
				A.[AcceptComments],
				A.[Enabled],
				A.[AnalysisType],
				A.[Query],
				A.[QueryName],
				A.[Language],
				A.[IsNegative],
				@EvaluationPlanId
			FROM [dbo].[Ability] A (NOLOCK)
			JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
				ON  A.[Instance] = AEF.[Instance] 
					AND AEF.[IdAbility] = A.[ID]
			WHERE AEF.[IdEvaluationFormat] = @FormatId 
				AND A.[Instance] = @VCC

	-- REGISTRAMOS LOS SCORES ASOCIADOS A LAS HABILIDADES DEL FORMATO DEL PLAN
	INSERT INTO [dbo].[HistoricScore] 
		SELECT DISTINCT S.[Instance], 
						S.[ID], 
						S.[IdAbility], 
						S.[Description], 
						S.[Value], 
						EP.[ID]
			FROM [dbo].[EvaluationPlan] EP (NOLOCK)
			LEFT JOIN [dbo].[AbilityEvaluationFormat] AEP (NOLOCK)
				ON AEP.[Instance] = EP.[Instance]
					AND AEP.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
			LEFT JOIN [dbo].[Score] S (NOLOCK)
				ON S.[Instance] = EP.[Instance]
					AND S.[IdAbility] = AEP.[IdAbility]
			WHERE EP.[Instance] = @VCC
			   AND EP.[ID] = @EvaluationPlanId
				
	-- REGISTRAMOS LOS SCORE_TIPIFICATIONS ASOCIADOS A LAS HABILIDADES DEL FORMATO DEL PLAN
	INSERT INTO [dbo].[HistoricEvaluationFormatAbilityScoreTipification]
		SELECT [VCC],
				[EvaluationFormatId],
				[ScoreId],
				[ID],
				[Description],
				[Detail],
				[Order],
				GETUTCDATE(),
				NULL,
				@EvaluationPlanId
			FROM [dbo].[EvaluationFormatAbilityScoreTipification] (NOLOCK)
			WHERE [VCC] = @VCC
				AND [EvaluationFormatId] = @FormatId
				
	-- REGISTRAMOS LOS SCORE_TIPIFICATION_QUERIES ASOCIADOS A LAS HABILIDADES DEL FORMATO DEL PLAN
	INSERT INTO [dbo].[HistoricEvaluationFormatAbilityScoreTipificationQuery]
		SELECT [VCC],
				[EvaluationFormatId],
				[ScoreId],
				[TipificationId],
				[QueryId],
				[QueryContent],
				[AcceptancePercentage],
				GETUTCDATE(),
				NULL,
				@EvaluationPlanId
			FROM [dbo].[EvaluationFormatAbilityScoreTipificationQuery] (NOLOCK)
			WHERE [VCC] = @VCC
				AND [EvaluationFormatId] = @FormatId
				-- select * FROM [dbo].[EvaluationFormatAbilityScoreTipificationQuery] (NOLOCK)
	
	
	-- REGISTRAMOS TIPIFICACIONES DE 2DO Y TERCER NIVEL CUANDO EL PLAN NO ES AUTOMATIC
	IF @EVALUATION_MODE <> 'A' 
	BEGIN
		-- REGISTRAMOS LOS SCORE_TIPIFICATIONS_ITEMS ASOCIADOS A LAS HABILIDADES DEL FORMATO DEL PLAN
		INSERT INTO [dbo].[HistoricEvaluationFormatAbilityScoreTipificationItem]
			SELECT [VCC],
					[EvaluationFormatId],
					[ScoreId],
					[TipificationId],
					[ID],
					[SecondLevelItemId],
					[Description],
					[Order],
					GETUTCDATE(),
					NULL,
					@EvaluationPlanId
				FROM [dbo].[EvaluationFormatAbilityScoreTipificationItem] (NOLOCK)
				WHERE [VCC] = @VCC
					AND [EvaluationFormatId] = @FormatId
	END
				
	-- 
	INSERT INTO [dbo].[HistoricAbilityQuery]
		SELECT AQ.[ID],
				AQ.[VCC],
				AQ.[AbilityId],
				AQ.[QueryId],
				AQ.[QueryContent],
				AQ.[AcceptancePercentage],
				AQ.[Order],
				@EvaluationPlanId
			FROM [dbo].[AbilityQuery] AQ (NOLOCK)
			JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
			ON  AQ.[VCC] = AEF.[Instance] AND AEF.[IdAbility] = AQ.[AbilityId]
			WHERE AEF.[IdEvaluationFormat] = @FormatId AND AQ.[VCC] = @VCC
			GROUP BY 
				AQ.[ID],
				AQ.[VCC],
				AQ.[AbilityId],
				AQ.[QueryId],
				AQ.[QueryContent],
				AQ.[AcceptancePercentage],
				AQ.[Order]

	--
	INSERT INTO [dbo].[HistoricAbilityQueryEntity]
		SELECT AQE.[VCC],
				AQE.[AbilityQueryId],
				AQE.[EntityId],
				AQE.[EntityName],
				AQE.[AcceptancePercentage],
				AQE.[Order],
				@EvaluationPlanId
			FROM [dbo].[AbilityQueryEntity] AQE (NOLOCK)
			JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
				ON AQ.[VCC] = AQE.[VCC] 
					AND AQE.[AbilityQueryId] = AQ.[ID]
			JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
				ON  AQ.[VCC] = AEF.[Instance] 
					AND AEF.[IdAbility] = AQ.[AbilityId]
			WHERE AQ.[VCC] = @VCC 
				AND AEF.[IdEvaluationFormat] = @FormatId
			GROUP BY AQE.[VCC],
						AQE.[AbilityQueryId],
						AQE.[EntityId],
						AQE.[EntityName],
						AQE.[AcceptancePercentage],
						AQE.[Order]

	SET NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[BulkAuditorEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[BulkAuditorEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	/*
	SELECT * 
		INTO TMP_AUDITOR_EVALUATION_PLAN
		FROM [dbo].[#AuditorEvaluationPlanTemp]
		
	SELECT *
		INTO #AuditorEvaluationPlanTemp
		FROM TMP_AUDITOR_EVALUATION_PLAN
	*/

	-- SELECT * FROM dbo.[#AuditorEvaluationPlanTemp]


	-- ACTUALIZAMOS LOS REGISTROS QUE YA EXISTAN BD
	UPDATE AEP
		SET AEP.[InteractionOrigin] = TMP_AEP.[InteractionOrigin],
			AEP.[InteractionFormat] = TMP_AEP.[InteractionFormat],
			AEP.[ContactId] = TMP_AEP.[InteractionContactId],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		INNER JOIN [#AuditorEvaluationPlanTemp] TMP_AEP
			ON AEP.[Instance] = TMP_AEP.[VCC]
				AND TMP_AEP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND TMP_AEP.[AuditorId] = AEP.[IdAuditor]
				AND TMP_AEP.[InteractionId] = AEP.[IdInteraction]
				AND TMP_AEP.[AgentId] = AEP.[IdAgent]
				AND TMP_AEP.[InteractionType] = AEP.[InteractionType]

	-- VOLCAMOS LOS REGISTROS QUE NO EXISTAN EN LA BD
	;WITH CTE_NEW_AUDITOR_EVALUATION_PLAN AS (
		SELECT TMP_AEP.* 
			FROM [#AuditorEvaluationPlanTemp] TMP_AEP
			LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				ON AEP.[Instance] = TMP_AEP.[VCC]
					AND AEP.[IdEvaluationPlan] = TMP_AEP.[EvaluationPlanId]
					AND AEP.[IdAuditor] = TMP_AEP.[AuditorId]
					AND AEP.[IdInteraction] = TMP_AEP.[InteractionId]
					AND AEP.[IdAgent] = TMP_AEP.[AgentId]
					AND AEP.[InteractionType] = TMP_AEP.[InteractionType]
			WHERE AEP.[Instance] IS NULL 
	)
		-- INSERTMAOS LA DATA EN LA TABLA AEP
		INSERT INTO [dbo].[AuditorEvaluationPlan] (
				[Instance], [IdEvaluationPlan], [idCampaign], [IdAgent], [IdAuditor],
				[IdInteraction], [InteractionType], [InteractionDate], [InteractionDateEnd], [InteractionDuration],
				[ManagementResult], [InteractionOrigin], [InteractionFormat], [ContactId], [ContactAddress], 
				[ContactName], [Status], [StatusDescription], [Completed], [Score],
				[CreatedByUserId], [CreatedDate], [TimeStamp]
			)
			SELECT CTE_AEP.[VCC], CTE_AEP.[EvaluationPlanId], CTE_AEP.[CampaignId], CTE_AEP.[AgentId], CTE_AEP.[AuditorId],
					CTE_AEP.[InteractionId], CTE_AEP.[InteractionType], CTE_AEP.[InteractionStartDate], CTE_AEP.[InteractionEndDate], CTE_AEP.[InteractionDuration],
					CTE_AEP.[InteractionManagementResult], CTE_AEP.[InteractionOrigin], CTE_AEP.[InteractionFormat], CTE_AEP.[InteractionContactId], CTE_AEP.[InteractionContactAddress],
					CTE_AEP.[InteractionContactName], 1, 'NEW', 0, 0,
					'system', GETUTCDATE(), GETUTCDATE()
				FROM CTE_NEW_AUDITOR_EVALUATION_PLAN CTE_AEP 


	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#AuditorEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[CloseI6InteractionAsyncInteraction]...';


GO
CREATE PROCEDURE [dbo].[CloseI6InteractionAsyncInteraction] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Folder					VARCHAR(50) = NULL,
	@Channel				VARCHAR(25) = NULL,
	@Succed					BIT = 0,
	@ErrorMessage			VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- ACTUALIZAMOS LA TABLA DE LA INTERACCION EN LA TABLA ASYNC_INTERACTION
		UPDATE [dbo].[AsyncInteraction]
			SET [IsProcess] = NULL,
				[IsCancel] = NULL,
				[NeedI6Update] = IIF (@Succed = 1, 0, 1),
				[ErrorMessage] = @ErrorMessage,
				[LastModifiedByUserId] = 'system',
				[LastModifiedDate] = GETUTCDATE(),
				[TimeStamp] = GETUTCDATE()
			WHERE [VCC] = @VCC
				AND [ID] = @InteractionId
				AND [Folder] = @Folder
				AND [NeedI6Update] = 1
				AND (
					[IsTranscribed] IS NULL 
					OR
					[IsTranscribed] <> 1
				)

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creando Procedimiento [dbo].[CloseI6InteractionAudio]...';


GO
CREATE PROCEDURE [dbo].[CloseI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@Succed					BIT = 0,
	@ErrorMessage			VARCHAR(50) = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
		UPDATE [dbo].[Audio] 
			SET [IsProcess] = NULL,
				[IsCancel] = NULL,
				[NeedI6Update] = IIF (@Succed = 1, 0, 1),
				[ErrorMessage] = IIF (@Succed = 1, NULL, @ErrorMessage),
				[LastModifiedByUserId] = 'system',
				[LastModifiedDate] = GETUTCDATE(),
				[TimeStamp] = GETUTCDATE()
			WHERE [VCC] = @VCC
				AND [ID] = @InteractionId
				AND [NeedI6Update] = 1
				AND (
					[IsTranscribed] IS NULL 
					OR
					[IsTranscribed] <> 1
				)
			
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Modificando Procedimiento [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]

	



	------------INICIO DE ACTUALIZACION DE ESTADOS DE PROCESS I6UPDATE --------------

	-- ACTUALIZAMOS EL ESTADO GENERAL DE PROCESS SOBRE LA ACTUALIZACION DE INTERACCIONES CALL I6
	UPDATE P 
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error],0) > 0 
											THEN 'I6_UPDATE_COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error],0) = 0 
											THEN 'I6_UPDATE_COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON P.[vcc] = PT.[vcc] 
				AND PT.ProcessId = P.[Name] 
		WHERE PT.[Type] = 'i6update'

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	UPDATE A
		SET [Status] = CASE 
				WHEN B.total >= 0 
						AND B.total <= B.[updated] + B.cancel 
						AND B.cancel > B.[updated] 
					THEN 'FAILED' 
				WHEN B.total >= 0 
						AND B.total <= B.[updated] + B.cancel 
					THEN 'COMPLETE' 
				ELSE 'INPROCESS_I6_UPDATE' 
				END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] AS A
		INNER JOIN (
			SELECT SUM(UT.total)									'total',
					SUM(UT.cancel)									'cancel',
					SUM(UT.[updated])								'updated',
					UT.processId									'processId',
					UT.vcc											'vcc'
				FROM (
					SELECT COUNT(1)										'total'
							,COUNT(A.[isCancel])						'cancel'
							,COUNT(IIF(A.[NeedI6Update] = 0, 1, 0))		'updated' 
							,PT.[ProcessId]								'processId'
							,PT.[vcc]									'vcc'
						FROM [dbo].[ProcessAudio] PA (NOLOCK)
						INNER JOIN [#ProgressTemp] PT 
							ON PA.[vcc] = PT.[vcc] 
								AND PA.ProcessId = PT.ProcessId 
								AND PT.[Percentage] = 1
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON PA.[VCC] = A.VCC 
								AND PA.[AudioId] = A.ID 
						WHERE PT.[Type] = 'i6update'
						GROUP BY PT.ProcessId, PT.vcc
				) UT 
				GROUP BY UT.processId, UT.vcc
		) B ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.[ProcessId]

	------------FIN DE ACTUALIZACION DE ESTADOS DE PROCESS I6UPDATE --------------



	  
	------------INICIO DE ACTUALIZACION DE ESTADOS DE PROCESS --------------

	UPDATE A
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error], 0) > 0 
											THEN 'COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 
												AND PT.[Percentage] = 1 
												AND  ISNULL(PT.[Error], 0) = 0 
											THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM Process AS A
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON A.[vcc] = PT.[vcc] 
				AND A.[Name] = PT.ProcessId 
		WHERE PT.[Type] IS NULL

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT ISNULL(SUM(UT.total), 0)					'total',
				ISNULL(SUM(UT.cancel), 0)				'cancel',
				ISNULL(SUM(UT.transcription), 0)		'transcription',
				UT.processId							'processId',
				UT.vcc									'vcc'
			FROM (
			SELECT COUNT(1)					total
					,COUNT(C.isCancel)			cancel
					,COUNT(C.IsTranscribed)		transcription 
					,B.ProcessId				processId
					,B.vcc						vcc
				FROM [ProcessAudio] A (NOLOCK)
				INNER JOIN [#ProgressTemp] B 
					ON A.[vcc] = B.[vcc] 
						AND A.ProcessId = B.ProcessId 
						-- AND B.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN Audio C (NOLOCK) 
					ON A.VCC = C.VCC 
						AND A.AudioId =C.ID 
						AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
						AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
				WHERE B.[Type] IS NULL
				GROUP BY B.ProcessId, B.vcc
			UNION
			SELECT 
				COUNT(1)						total
				,COUNT(AI.IsCancel)			cancel
				,COUNT(AI.IsTranscribed)		transcription
				,PT.[ProcessId]				processId
				,PT.[vcc]						vcc
				FROM [ProcessAsyncInteraction] PAI (NOLOCK)
				INNER JOIN [#ProgressTemp] PT
					ON PAI.[VCC] = PT.[vcc]
						AND PAI.[ProcessId] = PT.[ProcessId]
						-- AND PT.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN [AsyncInteraction] AI (NOLOCK) 
					ON AI.[VCC] = PT.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE PT.[Type] IS NULL
				GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	-- ACTUALIZAMOS EL ESTADO DE OTROS PROCESOS QUE ESTAN COMO FALLIDOS, COLGADOS, ETC QUE COINCIDEN CON LAS INTERACCIONES DEL PROCESS TERMINADO
	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[VCC] = P.[VCC]
								AND PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[VCC] = PA.[VCC]
								AND A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION

	-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
	INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT PTMP.[vcc],
				NEWID(),
				BS.[Id],
				PTMP.[ProcessId],
				GETUTCDATE(),
				'PENDING',
				'system',
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
				ON BS.[VCC] = PTMP.[vcc]
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL -- EL NULL INDICA QUE ES PROCESS DE TRANSCRIPCION Y NO DE PLAN DE EVALUACION
				AND BS.[BatchType] = 'TEMPLATE'
				AND GETUTCDATE() >= BS.[StartDate]
				AND (
					BS.[EndDate] IS NULL 
					OR
					GETUTCDATE() < BS.[EndDate]
				)

	------------FIN DE ACTUALIZACION DE ESTADOS DE PROCESS --------------





	------------INICIO DE ACTUALIZACION DE ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] IN ('study', 'template')
				
	--Eliminar StudyResultSummary
	         DELETE SRS FROM [dbo].[StudyResultSummary] SRS 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRS.[VCC] 
	                       AND S.[Name] = SRS.[StudyId] 
	                       AND S.[TemplateId] = SRS.[TemplateId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRS.[TemplateThemeId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRS.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	                  
	           	        
	 -- Eliminar StudyResultSummaryDetail
	           	  DELETE SRSD FROM [dbo].[StudyResultSummaryDetail] SRSD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRSD.[VCC] 
	                       AND S.[Name] = SRSD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRSD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SRSD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type]  IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRSD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	
   	 -- Eliminar StudyResultSummaryDetail
	           	  DELETE SD FROM [dbo].[StudyDetail] SD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SD.[VCC] 
	                       AND S.[Name] = SD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.[ProcessId] 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type] IN ('study', 'template'))
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], UPPER(PTMP.[Type]), PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] IN ('study', 'template')
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IN ('study', 'template')

	-- ACTUALIZAMOS LA EJECUCION RELACIONADA AL BATCH TEMPLATE TERMINADO
	UPDATE BSE 
		SET BSE.[Status] = 'FINISHED',
			BSE.[LastModifiedByUserId] = 'system',
			BSE.[LastModifiedDate] = GETUTCDATE()
		FROM [#ProgressTemp] PTMP
		INNER JOIN [dbo].[BatchScheduleExecution] BSE 
			ON BSE.[vcc] = PTMP.[vcc] 
				AND BSE.[BatchId] = PTMP.[TypeId] 
		WHERE PTMP.[Percentage] = 1 
			AND PTMP.[Type] = 'template'

	------------FIN DE ACTUALIZACION DE ESTADOS DE ESTUDIOS --------------





	------------INICIO DE ACTUALIZACION DE ESTADOS DE PLAN DE EVALUACION --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE EP
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE 'IN_PROGRESS' END
			,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
				AND B.[Type] IS NULL 
				AND EP.[FilterByContentQueryName] IS NOT NULL 
				AND EP.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'
			
	-- UPDATE PARA INICIAR LA PARTE DE ANALISIS SEMANTICO/COGNITIVO CUANDO EL PROCESS TERMINOS
	UPDATE EP
		SET EP.[Total] = B.[Total]
			,EP.[progress] = B.[Progress]
			,EP.[error] = B.[Error]
			,EP.[percentage] = B.[Percentage]
			,EP.[StatusDescription] = CASE WHEN B.[Percentage] = 1 
												AND P.[Status] NOT LIKE '%I6_UPDATE%'
											--THEN CASE WHEN P.[StatusDescription] = 'FAILED' THEN 'CANCELLED_BY_FAILED_PROCESS'
											--		ELSE P.[StatusDescription]
											--		END
											THEN IIF (P.[StatusDescription] = 'FAILED', 'CANCELLED_BY_FAILED_PROCESS', P.[StatusDescription])
											ELSE 'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN B.[Percentage] = 1 
							--THEN CASE WHEN P.[StatusDescription] = 'FAILED' THEN 10 
							--		ELSE 5 END
							THEN IIF (P.[StatusDescription] = 'FAILED', 10, 5)
							ELSE 2 END
			,EP.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[Process] P (NOLOCK)
			ON P.[VCC] = EP.[Instance]
				AND P.[Name] = EP.[ProcessId] 
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
		WHERE EP.[FilterByContentQueryName] IS NULL 
				AND EP.[FilterByContentQuery] IS NULL 
				AND EP.[Evaluation_Mode] IN ('A', 'X')
				AND B.[Type] IS NULL 

	/*
	--OBTENGO ESTADOS DE PROCESO DE AUDIOS
	;WITH AudioStatus AS (
		SELECT D.[VCC]										'instance',
				D.[ProcessId]								'processId',
				COUNT(*) 									'total',
				SUM(IIF(A.[IsTranscribed] = 1, 1, 0))		'transcribed',
				SUM(IIF(A.[IsCancel] = 1, 1, 0))			'cancelled'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON A.[ID] = IEP.[IdInteraction]
					AND A.[Section] = IEP.[InteractionSection]
					AND A.[Part] = IEP.[InteractionPart]
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = IEP.[Instance]
					AND EP.[ID] = IEP.[IdEvaluationPlan]
			INNER JOIN [dbo].[#ProgressTemp] D (NOLOCK)
				ON D.[vcc] = EP.[Instance]
					AND D.[ProcessId] = EP.ProcessId
					AND  D.[TypeId] = EP.Id
					AND D.[Type] = 'ability'
			GROUP BY D.[VCC], D.[ProcessId]
	)
	*/

	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES(FASE DE EVALUACION AUTOMATICA) DE LA TABLA TEMPORAL CUANDO EL PLAN ESTA EN STATUS 5 (ANALIZADO) O 6 (EVALUANDO)
	UPDATE EP
		SET EP.[Total] = B.[Total]
			,EP.[progress] = B.[Progress]
			,EP.[error] = B.[Error]
			,EP.[percentage] = B.[Percentage]
			,EP.[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error], 0) > 0 THEN 'EVALUATION_COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error], 0) = 0 THEN 'EVALUATION_COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN B.[Percentage] = 1 THEN 11 ELSE 6 END
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON EP.[Instance] = B.[vcc] 
				AND EP.[ProcessId] = B.ProcessId 
				AND EP.Id = B.[TypeId] 
				AND B.[Type] = 'ability'
		WHERE EP.[Status] IN (5, 6)

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 11 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[StatusDescription] = 'COMPLETED'
			,[LastModifiedByUserId] = 'system'
			,[LastModifiedDate] = GETUTCDATE()
			,[TimeStamp] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
	WHERE EP.[Status] = 11
		AND AEP.[IdAuditor] = 'SPEECH' 
		AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X') 
		AND B.[Type] = 'ability'



	/*************************************INICIO DE ACTUALIZACION DE TIPIFICACIONES***********************************************/
	
	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES(FASE DE TIPIFICACIONES) DE LA TABLA TEMPORAL
	UPDATE EP
		SET EP.[percentage] = TMP_P.[Percentage]
			,EP.[StatusDescription] = CASE WHEN TMP_P.[Percentage] = 1 AND  ISNULL(TMP_P.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN TMP_P.[Percentage] = 1 AND  ISNULL(TMP_P.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,EP.[Status] = CASE WHEN TMP_P.[Percentage] = 1 THEN 7 ELSE 12 END
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] EP
		INNER JOIN [dbo].[#ProgressTemp] TMP_P 
			ON EP.[Instance] = TMP_P.[vcc] 
				AND EP.[ProcessId] = TMP_P.ProcessId 
				AND EP.Id = TMP_P.[TypeId] 
		WHERE EP.[Status] IN (11, 12)
			AND TMP_P.[Type] = 'tipification'

	/*************************************FIN DE ACTUALIZACION DE TIPIFICACIONES***********************************************/

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (
						PTMP.[Type] = 'ability' 
						OR 
						PTMP.[Type] = 'evaluationPlan'
					)
			WHERE EP.[Status] = 7
				AND PTMP.[Percentage] = 1 
				AND (
					PTMP.[Type] = 'ability' 
					OR 
					PTMP.[Type] = 'evaluationPlan'
				)



	-- REGISTRAMOS LA(S) AGENDA(S) DE PLANTILLA PARA LOS PROCESS TERMINADO
	INSERT INTO [dbo].[BatchScheduleExecution] ([VCC], [Id], [BatchScheduleId], [ProcessId], [ExecutionDate], [Status], [CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT PTMP.[vcc],
				NEWID(),
				BS.[Id],
				PTMP.[ProcessId],
				GETUTCDATE(),
				'PENDING',
				'system',
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			LEFT JOIN [dbo].[BatchSchedule] BS (NOLOCK)
				ON BS.[VCC] = PTMP.[vcc]
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan') -- EL NULL INDICA QUE ES PROCESS DE PLAN DE EVALUACION
				AND BS.[BatchType] = 'TEMPLATE'
				AND GETUTCDATE() >= BS.[StartDate]
				AND (
					BS.[EndDate] IS NULL 
					OR
					GETUTCDATE() < BS.[EndDate]
				)

	-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT PTMP.[vcc] 'VCC', 
				PTMP.[TypeId] 'EVALUATION_PLAN_ID'
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
			WHERE PTMP.[Percentage] = 1 
				AND (
					PTMP.[Type] = 'ability' 
					OR 
					PTMP.[Type] = 'evaluationPlan'
				)
			
	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1 
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
		BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
			EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
			UPDATE AEP
				SET AEP.[Completed] = '1'
					,AEP.[StatusDescription] = 'COMPLETED'
					,AEP.[LastModifiedByUserId] = 'system'
					,AEP.[LastModifiedDate] = GETUTCDATE()
					,AEP.[TimeStamp] = GETUTCDATE()
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		END

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





	-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE DE EVALUACION AUTOMATICA(ESTADO 11), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL AL ESTADO 7)

	DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR_2 CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				PT.[vcc]								'VCC', 
				PT.[TypeId]								'EVALUATION_PLAN_ID',
				EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
			FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
			INNER JOIN [dbo].[#ProgressTemp] PT 
				ON EP.[Instance] = PT.[vcc] 
					AND EP.[ProcessId] = PT.[ProcessId] 
					AND EP.[Id] = PT.[TypeId] 
					AND PT.[Type] = 'ability'
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			WHERE EP.[Status] = 11
				AND EP.[Evaluation_Mode] = 'X'

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR_2
	FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
		BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
			UPDATE EP 
				SET EP.[percentage] = 0
					,EP.[StatusDescription] = 'IN_PROGRESS'
					,EP.[Status] = 8
					,EP.[LastModifiedDate] = GETUTCDATE() 
				FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
				WHERE EP.[Instance] = @CURRENT_VCC
					AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
			DECLARE MY_AUDITOR_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
				FOR 
				-- CONSULTAMOS LOS ID DE AUDITORES
				SELECT DISTINCT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE  AEP.[Instance] = @CURRENT_VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND AEP.[IdAuditor] <> 'SPEECH'

			-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
			OPEN MY_AUDITOR_CURSOR
			FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
				INSERT INTO [dbo].[EvaluationResult] (
					[Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
					[MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
					[OwnScore], [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], 
					[CreatedDate], [CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], 
					[CampaignDescription], [AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], 
					[AbilityOrder], [InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
				) 
					-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
					SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
							ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
							ER.[OwnScore], ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], 
							ER.[CreatedDate], ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], 
							ER.[CampaignDescription], ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], 
							ER.[AbilityOrder], ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
						FROM [dbo].[EvaluationResult] ER (NOLOCK)
						INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
							ON AEP.[Instance] = ER.[Instance]
								AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
								AND AEP.[IdAuditor] = ER.[IdAuditor]
								AND AEP.[IdInteraction] = ER.[IdInteraction]
								AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
						WHERE ER.[Instance] = @CURRENT_VCC
							AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
							AND ER.[IdAuditor] = 'SPEECH'

				-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
				UPDATE [dbo].[AuditorEvaluationPlan]
					SET [Completed] = 0,
						[AutomaticScore] = [Score],
						[ManualScore] = 0,
						[StatusDescription] = 'NEW',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = @CURRENT_AUDITOR_ID

				FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			END
			CLOSE MY_AUDITOR_CURSOR
			DEALLOCATE MY_AUDITOR_CURSOR

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

			-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
			DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] = 'SPEECH'
					AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'
					AND [IdInteraction] IN (
						SELECT [IdInteraction] 
							FROM [dbo].[AuditorEvaluationPlan] 
							WHERE [Instance] = @CURRENT_VCC
								AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
								AND [IdAuditor] = 'SPEECH'
								AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
					)

			-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
			UPDATE [dbo].[AuditorEvaluationPlan]
					SET [AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = 'SPEECH'

		END
		ELSE
		BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
			DELETE FROM [dbo].[AuditorEvaluationPlan] 
				WHERE  [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

		END

		FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	END
	CLOSE MY_CURSOR_2
	DEALLOCATE MY_CURSOR_2

	-- INVALIDAR LAS AUDITORIAS CUYO AUDIO PRESENTAN ALGUN ERROR
	UPDATE AEP
		SET AEP.[StatusDescription] = 'INVALID'
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK)
		    ON AEP.[Instance] = A.[VCC] 
		        AND AEP.[IdInteraction] = A.[ID]
		INNER JOIN [#ProgressTemp] PTMP (NOLOCK)
			ON AEP.[Instance] = PTMP.[vcc]
			    AND AEP.[IdEvaluationPlan] = PTMP.[TypeId]
		WHERE (
				A.[IsTranscribed] IS NULL 
				OR 
				A.[IsTranscribed]  <> 1
			)
		    AND (
				PTMP.[Type] = 'ability' 
				OR 
				PTMP.[Type] = 'evaluationPlan'
			)
		    -- AND A.[ErrorMessage] IN ('GET_AUDIO_REQUEST_FAILED','JSON_IDATHA_IS_NOT_FOUND','JSON_TRANSCRIPTION_CONTENT_IS_EMPTY')

	-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

	/*
	-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
	UPDATE EP 
		SET EP.[percentage] = 0
			,EP.[StatusDescription] = 'IN_PROGRESS'
			,EP.[Status] = 8
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON EP.[Instance] = PT.[vcc] 
				AND EP.[ProcessId] = PT.[ProcessId] 
				AND EP.[Id] = PT.[TypeId] 
				AND PT.[Type] = 'ability'
		WHERE EP.[Status] = 7
			AND EP.[Evaluation_Mode] = 'X'
	*/
	

	-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO

ALTER PROCEDURE [dbo].[DeleteAbility] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
			-- ELIMINAMOS LO ITEMS ASOCIADOS A LOS SCORES
			DECLARE RECURRENT_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			-- SELECCIONAMOS LOS VCC EXISTENTES
			SELECT [ID]
				FROM [Score]
				WHERE [Instance] = @Instance
					AND [IdAbility] = @ID 
			
			-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL SCORE ACTUAL QUE ESTAMOS ELIMINANDO
			DECLARE @CURRENT_SCORE_TO_REMOVE VARCHAR(50) = ''

			-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
			OPEN RECURRENT_CURSOR

			FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_SCORE_TO_REMOVE
			WHILE @@FETCH_STATUS = 0
			BEGIN
				-- ELIMINAMOS LOS REGISTROS DE SCORETIPIFICATION
				DELETE [ScoreTipificationItem] 
					WHERE [VCC] = @Instance
						AND [ScoreId] = @CURRENT_SCORE_TO_REMOVE

				-- ELIMINAMOS LOS REGISTROS DE SCORETIPIFICATION
				DELETE [ScoreTipification] 
					WHERE [VCC] = @Instance
						AND [ScoreId] = @CURRENT_SCORE_TO_REMOVE

				-- ELIMINAMOS LOS REGISTROS DE SCORE
				DELETE [Score]
					WHERE [Instance] = @Instance
						AND [IdAbility] = @ID 
						
				FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_SCORE_TO_REMOVE
			END
			CLOSE RECURRENT_CURSOR
			DEALLOCATE RECURRENT_CURSOR

			-- ELIMINAMOS LOS REGISTROS ABILITYQUERY
			DELETE [AbilityQuery] 
				WHERE [VCC] = @Instance 
					AND [AbilityId] = @ID

			-- ELIMINAMOS EL REGISTRO ABILITY
			DELETE [Ability] 
				WHERE [Instance] = @Instance
					AND [ID] = @ID

			DELETE [AbilityScoreCard] 
				WHERE [VCC] = @Instance
					AND [ID] = @ID

			SELECT 1 AS 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    
    SET NOCOUNT OFF
END
GO

ALTER PROCEDURE [dbo].[DeleteCustomField] (
	@VCC VARCHAR(50) = NULL, 				
	@CustomFieldId VARCHAR(100) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON;

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
        
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS SI EL CUSTOMFIELD ESTA RELACIONADO A ALGUN FORMATO EN USO
		IF EXISTS (
			SELECT DISTINCT EFCF.[CustomFieldId] 'customFieldId'
				FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
				WHERE EFCF.[VCC] = @VCC 
					AND EFCF.[CustomFieldId] = @CustomFieldId
		)	
			RAISERROR('DATABASE_ERROR_CUSTOM_FIELD_ON_USE', 16, 16)

		-- ELIMINAMOS LOS RESULTS DEL CUSTOM FIELD
		DELETE FROM [dbo].[CustomFieldResult] 
			WHERE [VCC] = @VCC 
				AND [CustomFieldId] = @CustomFieldId

		-- ELIMINAMOS EL CUSTOM FIELD
		DELETE FROM [dbo].[CustomField]
			WHERE [VCC] = @VCC 
				AND [ID] = @CustomFieldId
		
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
	
	SET NOCOUNT OFF
END
GO

ALTER PROCEDURE [dbo].[DeleteGroup] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	DELETE FROM [Group]
	WHERE [Instance] = @Instance
	AND [ID] = @ID

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO

ALTER PROCEDURE [dbo].[DeleteSubGroup] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	DELETE FROM [SubGroup]
	WHERE [Instance] = @Instance
	AND [ID] = @ID

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO

ALTER PROCEDURE [dbo].[DeleteCustomField] (
	@VCC VARCHAR(50) = NULL, 				
	@CustomFieldId VARCHAR(100) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON;

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
        
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS SI EL CUSTOMFIELD ESTA RELACIONADO A ALGUN FORMATO EN USO
		IF EXISTS (
			SELECT DISTINCT EFCF.[CustomFieldId] 'customFieldId'
				FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
				WHERE EFCF.[VCC] = @VCC 
					AND EFCF.[CustomFieldId] = @CustomFieldId
		)	
			RAISERROR('DATABASE_ERROR_CUSTOM_FIELD_ON_USE', 16, 16)

		-- ELIMINAMOS LOS RESULTS DEL CUSTOM FIELD
		DELETE FROM [dbo].[CustomFieldResult] 
			WHERE [VCC] = @VCC 
				AND [CustomFieldId] = @CustomFieldId

		-- ELIMINAMOS EL CUSTOM FIELD
		DELETE FROM [dbo].[CustomField]
			WHERE [VCC] = @VCC 
				AND [ID] = @CustomFieldId
		
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
	
	SET NOCOUNT OFF
END
GO


GO
PRINT N'Actualizando Procedimiento [dbo].[GetFiltersFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetFiltersFromEvaluation]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando Procedimiento [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualizando Procedimiento [dbo].[SaveEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlan]';


GO
PRINT N'Actualización completada.';


GO
